/* COPYRIGHT-ENEA-SRC-R2 *
 **************************************************************************
 * Copyright (C) 2004-2006 by Enea Software AB.
 * All rights reserved.
 *
 * This Software is furnished under a software license agreement and
 * may be used only in accordance with the terms of such agreement.
 * Any other use or reproduction is prohibited. No title to and
 * ownership of the Software is hereby transferred.
 *
 * PROPRIETARY NOTICE
 * This Software consists of confidential information.
 * Trade secret law and copyright law protect this Software.
 * The above notice of copyright on this Software does not indicate
 * any actual or intended publication of such Software.
 **************************************************************************
 * COPYRIGHT-END */
/**
 * @public
 *
 * @toc Standard_C:
 *
 * @file gcc/stdint.h
 *
 * @brief Standard integer definitions
 *
 * @library newlib
 */

#ifndef _STDINT_H
#define _STDINT_H

#ifdef __cplusplus
#if !defined (NO_NAME_STD) && defined (__ARMCC_VERSION)
namespace std {
#endif /* NO_NAME_STD */
extern "C" {
#endif /* __cplusplus */

#ifndef int8_t
typedef signed char		int8_t;
#endif

#ifndef int16_t
typedef short int		int16_t;
#endif

#ifndef int32_t
typedef int			int32_t;
#endif

#ifndef int64_t
typedef long long int		int64_t;
#endif

#ifndef uint8_t
typedef unsigned char		uint8_t;
#endif

#ifndef uint16_t
typedef unsigned short int	uint16_t;
#endif

#ifndef uint32_t
typedef unsigned int		uint32_t;
#endif

#ifndef uint64_t
typedef unsigned long long int	uint64_t;
#endif

#ifndef uintptr_t
typedef unsigned int            uintptr_t;
#endif

#ifdef __cplusplus
}
#if !defined (NO_NAME_STD) && defined (__ARMCC_VERSION)
}  /* namespace std */
using namespace ::std;
#endif /* NO_NAME_STD */
#endif /* __cplusplus */

#endif
