/* COPYRIGHT-ENEA-SRC-R2 *
 **************************************************************************
 * Copyright (C) 2004-2006 by Enea Software AB.
 * All rights reserved.
 *
 * This Software is furnished under a software license agreement and
 * may be used only in accordance with the terms of such agreement.
 * Any other use or reproduction is prohibited. No title to and
 * ownership of the Software is hereby transferred.
 *
 * PROPRIETARY NOTICE
 * This Software consists of confidential information.
 * Trade secret law and copyright law protect this Software.
 * The above notice of copyright on this Software does not indicate
 * any actual or intended publication of such Software.
 **************************************************************************
 * COPYRIGHT-END */

#ifndef _CPU_SMP_H
#define _CPU_SMP_H

#ifdef OSE_SMP
#define OSE_SMP_MAX_CPUS 32
#else
#define OSE_SMP_MAX_CPUS 1
#endif

#ifndef __ASM_ONLY__
#include "ose.h"

#ifdef __cplusplus
extern "C" {
#endif


#ifdef OSE_SMP

cpuid_t bsp_num_cpus(void);

#define zzkrn_num_cpus() bsp_num_cpus()

static __inline__ cpuid_t
zzkrn_cpu_id(void)
{
   cpuid_t id;

   __asm__ __volatile__ (" lw %0,0($28)" :"=r"(id):);
   return id;
}

#else

#define zzkrn_num_cpus()    1
#define zzkrn_cpu_id()      0

#endif

#ifdef __cplusplus
}
#endif

#else /* __ASM_ONLY__ */

#define OSE_SMP_CPU_ID(out_reg) \
	lw out_reg,0(gp);

#endif /* __ASM_ONLY__ */

#endif /* CPU_SMP_H */

