/* COPYRIGHT-ENEA-SRC-R2 *
 **************************************************************************
 * Copyright (C) 2009 by Enea Software AB.
 * All rights reserved.
 *
 * This Software is furnished under a software license agreement and
 * may be used only in accordance with the terms of such agreement.
 * Any other use or reproduction is prohibited. No title to and
 * ownership of the Software is hereby transferred.
 *
 * PROPRIETARY NOTICE
 * This Software consists of confidential information.
 * Trade secret law and copyright law protect this Software.
 * The above notice of copyright on this Software does not indicate
 * any actual or intended publication of such Software.
 **************************************************************************
 * COPYRIGHT-END */


/*     
 ****************************************************************************
 *                            PUBLIC INTERFACE
 *
 *     $Workfile:   outfmt.h  $
 *     Document no: @(#) 510/OSE66-28 $Revision:   1.8  $
 *     $Author:   frbr  $
 *     $Date:   06/13/02 11:20:25  $
 *
 ****************************************************************************
 */
#ifndef _OUTFMT_H
#define _OUTFMT_H

#include <stddef.h>
#include <stdarg.h>
#include "osarch.h"

#ifdef USE_OSEDEF_H
#include "osedef.h"
#endif

#ifdef __cplusplus
extern "C"
{
#endif

#ifdef softOSE
#define vsnprintf zzvsnprintf
#define snprintf  zzsnprintf
#ifndef OUTFMT_NO_SPRINTF
#define vsprintf  zzvsprintf
#define sprintf   zzsprintf
#endif
#endif
   
/* _vsOutFmt() is a generic printf()-like formatting engine. */
int _vsOutFmt(int (*iOutFoo) (void *, const char *, size_t),
	      void *pvOutData,
	      const char *szFmt,
	      va_list tArg);

/* vsnprintf() is like the ANSI-C vsprintf() and sprintf()
 * but with the buffer size specified to prohibit buffer overflow.
 */

int vsnprintf(char *acBuf, size_t tBufLen, const char *szFmt,
		 va_list tArg);

/* snprintf() is like the ANSI-C vsprintf() and sprintf()
 * but with the buffer size specified to prohibit buffer overflow.
 */
int snprintf(char *acBuf, size_t tBufLen, const char *szFmt,...);
   
/* Define OUTFMT_NO_SPRINTF at compile time if you don't want the
 * outfmt package to define the ANSI-C library functions sprintf
 * and vsprintf.
 */

#ifndef OUTFMT_NO_SPRINTF
int vsprintf(char *acBuf, const char *szFmt, va_list tArg);
int sprintf(char *acBuf, const char *szFmt,...);
#endif

#ifdef __cplusplus
}
#endif
#endif
