/* COPYRIGHT-ENEA-SRC-R2 *
 **************************************************************************
 * Copyright (C) 2004-2007 by Enea Software AB.
 * All rights reserved.
 *
 * This Software is furnished under a software license agreement and
 * may be used only in accordance with the terms of such agreement.
 * Any other use or reproduction is prohibited. No title to and
 * ownership of the Software is hereby transferred.
 *
 * PROPRIETARY NOTICE
 * This Software consists of confidential information.
 * Trade secret law and copyright law protect this Software.
 * The above notice of copyright on this Software does not indicate
 * any actual or intended publication of such Software.
 **************************************************************************
 * COPYRIGHT-END */
/**
 * @toc Standard_C:
 *
 * @file sys/types.h
 *
 * @brief EFS POSIX interface type definitions (sys/types.h).
 *
 */
#ifndef _SYS_TYPES_H
#define _SYS_TYPES_H
#define OSE_SYS_TYPES_H

#include "ose.h"
#include "stdint.h"

#ifdef __cplusplus
extern "C" {
#endif

#if !defined(_OFF_T)
#define _OFF_T

/**
 * @type off_t
 * @brief Used for file sizes.
 */
typedef int32_t off_t;
#endif

#if !defined(_OFF64_T)
#define _OFF64_T

/**
 * @type off64_t
 * @brief Used for file sizes.
 */
typedef int64_t off64_t;
#endif

#if !defined(_SSIZE_T)
#define _SSIZE_T

/**
 * @type ssize_t
 * @brief Used for a count of bytes or an error indication.
 */
typedef long ssize_t;
#endif

#if !defined(_MODE_T)
#define _MODE_T

/**
 * @type mode_t
 * @brief Used for some file attributes.
 */
typedef int mode_t;
#endif

#if !defined(_INO_T)
#define _INO_T

/**
 * @type ino_t
 * @brief Used for file serial numbers.
 */
typedef uint32_t ino_t;
#endif

#if !defined(_INO64_T)
#define _INO64_T

/**
 * @type ino64_t
 * @brief Used for file serial numbers.
 */
typedef uint64_t ino64_t;
#endif

#if !defined(_DEV_T)
#define _DEV_T

/**
 * @type dev_t
 * @brief Used for device IDs.
 */
typedef PROCESS dev_t;
#endif

#if !defined(_NLINK_T)
#define _NLINK_T

/**
 * @type nlink_t
 * @brief Used for link counts.
 */
typedef unsigned long nlink_t;
#endif

#if !defined(_UID_T)
#define _UID_T

/**
 * @type uid_t
 * @brief Used for user IDs.
 */
typedef unsigned long uid_t;
#endif

#if !defined(_GID_T)
#define _GID_T

/**
 * @type gid_t
 * @brief Used for group IDs.
 */
typedef unsigned long gid_t;
#endif

#if !defined(_PID_T)
#define _PID_T

/**
 * @type pid_t
 * @brief Used for process IDs and process group IDs.
 */
typedef PROCESS pid_t;
#endif

#if !defined(_BLKSIZE_T)
#define _BLKSIZE_T

/**
 * @type blksize_t
 * @brief Used for block sizes.
 */
typedef uint32_t blksize_t;
#endif

/*
 * The following two types only used when CRT version > 1
 */

#if !defined(_FSBLKCNT_T)
#define _FSBLKCNT_T

/**
 * @type fsblkcnt_t
 *
 * @brief Used for file system block counts.
 * @long Only used when CRT version > 1.
 */
typedef uint64_t fsblkcnt_t;
#endif

#if !defined(_FSFILCNT_T)
#define _FSFILCNT_T

/**
 * @type fsfilcnt_t
 *
 * @brief Used for file system file counts.
 * @long Only used when CRT version > 1.
 */
typedef uint64_t fsfilcnt_t;
#endif

#ifdef __cplusplus
}
#endif

#endif /* _SYS_TYPES_H */
