/* COPYRIGHT-ENEA-SRC-R1 *
 **************************************************************************
 * Copyright (C) 2008 by Enea Embedded Technology AB.
 * All rights reserved.
 *
 * This Software is furnished under a software license agreement and
 * may be used only in accordance with the terms of such agreement.
 * Any other use or reproduction is prohibited. No title to and
 * ownership of the Software is hereby transferred.
 *
 * PROPRIETARY NOTICE
 * This Software consists of confidential information.
 * Trade secret law and copyright law protect this Software.
 * The above notice of copyright on this Software does not indicate
 * any actual or intended publication of such Software.
 **************************************************************************
 * COPYRIGHT-END */

/*
 * Description: Cache internal
 */

#ifndef __CACHE_INTERNAL_H
#define __CACHE_INTERNAL_H

/* #include "compiler_macros.h" FIXME */
/*
** The purpose of the bios is to provide references to
** the cpu hal and cache functions in the kernel
**
*/

/* The cache bios name. */
#define CACHE_BIOS_NAME                             "CACHE"


/* Functions in the arcitechture specific implementation
 * in ..core/core/arch/xxx/krn/cache/cache.c
 *
 * Weak references to be used when linked to the monolith
 */
extern void
zzose_cache(U32 action, U32 level, OSADDRESS base, size_t size);
extern U32
zzose_cache_query(U32 query, ...);


/* Called from exec_start() to init the bios interface */
extern void
cache_init_bios_interface(void);



/*
 * Functions exported through the cache_bios_funcs struct
 * by the CACHE_TRAP_GET_FUNCS function code.
*/

#define CACHE_BIOS_NO_OF_ELEMENTS 2
struct cache_bios_funcs
{
   U32 no_of_elements;
   void (*zzose_cache)(U32 action, U32 level, OSADDRESS base, size_t size);
   U32 (*zzose_cache_query)(U32 query, ...);
};

/*
* Current interface version in the cache trap interface
* Should !!!ONLY!!! be incremented when backward
* binary compatibility needs to be broken. I.e. only
* when an existing interface is changed or removed.
* Adding new functionality should only affect the
* result of CACHE_TRAP_GET_LAST_FCODE. See cache_trap.c
*/
#define CACHE_TRAP_INTERFACE_VERSION                 1

/* Cache trap interface function codes */
#define CACHE_TRAP_GET_INTERFACE_VERSION             0
#define CACHE_TRAP_GET_LAST_FCODE                    1
#define CACHE_TRAP_GET_FUNCS                         2
#define CACHE_TRAP_LAST_FCODE                        2


#endif /* #ifndef __CACHE_INTERNAL_H */
