/* COPYRIGHT-ENEA-SRC-R2 *
 **************************************************************************
 * Copyright (C) 2004-2006 by Enea Software AB.
 * All rights reserved.
 *
 * This Software is furnished under a software license agreement and
 * may be used only in accordance with the terms of such agreement.
 * Any other use or reproduction is prohibited. No title to and
 * ownership of the Software is hereby transferred.
 *
 * PROPRIETARY NOTICE
 * This Software consists of confidential information.
 * Trade secret law and copyright law protect this Software.
 * The above notice of copyright on this Software does not indicate
 * any actual or intended publication of such Software.
 **************************************************************************
 * COPYRIGHT-END */
/*
 ****************************************************************************
 *                            HEADER
 *
 *     $Workfile:   child.sig  $
 *     Document no: @(#) 512/OSE52-15 $Revision:   1.3  $
 *     $Author:   olli  $
 *     $Date:   05/15/00 06:37:20  $
 *
 *
 ****************************************************************************
 */

#ifndef _CHILD_SIG
#define _CHILD_SIG

#include "ose.h"
#include "osetypes.h"

#define SHELL_SIGBASE 30300 /* Start of internal Shell signals. */

/* Sent from shell to proxy: create a child process. */

#define CHILD_CREATE_REQUEST  (30328) /* !-SIGNO(struct ChildCreateRequest)-! */
struct ChildCreateRequest
{
	SIGSELECT sigNo;
	U32 ptype; /* enum PROCESS_TYPE */
	U32 priority; /* OSPRIORITY. */
	U32 stack_size;
	OSADDRESS entrypoint;
	OSUSER user_id;
	U32 name; /* Offset into string pool. */
	char s[1]; /* String pool, variable size. */
};
#define allocChildCreateRequest(len) (struct ChildCreateRequest *)alloc(sizeof(struct ChildCreateRequest)+(len), CHILD_CREATE_REQUEST)

/* Returned from proxy to shell: return PID of (stopped) child process. */

#define CHILD_CREATE_REPLY    (30321) /* !-SIGNO(struct ChildCreateReply)-! */
struct ChildCreateReply
{
	SIGSELECT sigNo;
	PROCESS child_pid;
};
#define allocChildCreateReply() (struct ChildCreateReply *)alloc(sizeof(struct ChildCreateReply), CHILD_CREATE_REPLY)

/* Used by the shell proxy when attaching a shared model shell command process
 * in order to remember which block the command process was created in. */

#define CHILD_ATTACH          (30320) /* !-SIGNO(struct ChildAttach)-! */
struct ChildAttach
{
        SIGSELECT sigNo;
        PROCESS child_bid;
};
#define allocChildAttach() ((struct ChildAttach *)alloc(sizeof(struct ChildAttach), CHILD_ATTACH))

#endif
