/* COPYRIGHT-ENEA-SRC-R2 *
 **************************************************************************
 * Copyright (C) 2004-2007 by Enea Software AB.
 * All rights reserved.
 *
 * This Software is furnished under a software license agreement and
 * may be used only in accordance with the terms of such agreement.
 * Any other use or reproduction is prohibited. No title to and
 * ownership of the Software is hereby transferred.
 *
 * PROPRIETARY NOTICE
 * This Software consists of confidential information.
 * Trade secret law and copyright law protect this Software.
 * The above notice of copyright on this Software does not indicate
 * any actual or intended publication of such Software.
 **************************************************************************
 * COPYRIGHT-END */

#ifndef OSE_MM_PRIVATE_H_
#define OSE_MM_PRIVATE_H_


/*
 * Determines if the logical address range spans a MAS mapped
 * logical memory partition.
 */
mm_bool_t
mm_space_is_mas(log_addr_t log, log_size_t size);

/*
 * Determines if the logical address range spans a logical memory
 * partition that is statically mapped with large resident pages.
 */
struct partition_class *
mm_space_is_resident(log_addr_t log, log_size_t size);


/*
** Validate the access of a buffer without accessing it.
** See mm.h for more information.
*/
size_t
mm_validate_buffer_by_domain(log_addr_t bbase,	          /* buffer base */
                             size_t bsize,	          /* buffer size */
                             OSDOMAIN domain,             /* validation domain */
                             unsigned int bperm,  	  /* buffer permissions */
                             unsigned int options,	  /* validation options */
                             unsigned int *result,	  /* option results */
                             OSADDRESS supervisor_mode,   /* supervisior mode*/
                             U32 hal_options);


/*
** Lookup the physical address for a logical pointer.
** See mm.h for more information.
*/
mm_status_t
mm_l2p_by_domain(OSDOMAIN domain, log_addr_t la, phys_addr_t *pa);



/*
 * Try to reclaim memory allocated by other components in the system.
 */
mm_status_t
ose_mm_reclaim_memory(U32 required_size, const char *phys_mem);

/*
 * Retrieve information about current and past metadata usage. 
 */
void
mm_query_log_mem2(U32 *usage, U32 *usage_high);

#endif /* OSE_MM_PRIVATE_H_ */
