/* COPYRIGHT-ENEA-SRC-R1 *
 **************************************************************************
 * Copyright (C) 2007 by Enea Embedded Technology AB.
 * All rights reserved.
 *
 * This Software is furnished under a software license agreement and
 * may be used only in accordance with the terms of such agreement.
 * Any other use or reproduction is prohibited. No title to and
 * ownership of the Software is hereby transferred.
 *
 * PROPRIETARY NOTICE
 * This Software consists of confidential information.
 * Trade secret law and copyright law protect this Software.
 * The above notice of copyright on this Software does not indicate
 * any actual or intended publication of such Software.
 **************************************************************************
 * COPYRIGHT-END */

/*
 * Description: MM trap interface
 */

#ifndef __MM_TRAP_H
#define __MM_TRAP_H

#include "mmtypes.h"
#include "compiler_macros.h"

/* The MM BIOS name. */
#define MM_BIOS_NAME                             "MM"

/*
** Current interface version in the MM trap interface
** Should !!!ONLY!!! be incremented when backward
** binary compatibility needs to be broken. I.e. only
** when an existing interface is changed or removed.
** Adding new functionality should only affect the
** result of MM_TRAP_GET_LAST_FCODE. See mm_trap.c
*/
#define MM_TRAP_INTERFACE_VERSION                 1

/* MM trap interface function codes */
#define MM_TRAP_GET_INTERFACE_VERSION             0
#define MM_TRAP_GET_LAST_FCODE                    1
#define MM_TRAP_VALIDATE_BUFFER                   2
#define MM_TRAP_L2P                               3
#define MM_TRAP_L2P_RANGE                         4
#define MM_TRAP_RECLAIM_REGION                    5
#define MM_TRAP_ACCESS_FORCED_WRITE               6
#define MM_TRAP_GET_CACHE_MODE                    7
#define MM_TRAP_GET_CACHE_TYPE                    8

WEAK_REF(mm_status_t mm_l2p(PROCESS pid, log_addr_t la, phys_addr_t *pa));

#endif /* #ifndef __MM_TRAP_H */
