/* COPYRIGHT-ENEA-SRC-R2 *
 **************************************************************************
 * Copyright (C) 2004-2006 by Enea Software AB.
 * All rights reserved.
 *
 * This Software is furnished under a software license agreement and
 * may be used only in accordance with the terms of such agreement.
 * Any other use or reproduction is prohibited. No title to and
 * ownership of the Software is hereby transferred.
 *
 * PROPRIETARY NOTICE
 * This Software consists of confidential information.
 * Trade secret law and copyright law protect this Software.
 * The above notice of copyright on this Software does not indicate
 * any actual or intended publication of such Software.
 **************************************************************************
 * COPYRIGHT-END */

#ifndef OSE_MMAN_TRAP_H_
#define OSE_MMAN_TRAP_H_

#include "mmtypes.h"
#include "compiler_macros.h"

#define MMAN_BIOS_NAME "MMAN"

/*
** Current interface version in the MMAN trap interface
** Should !!!ONLY!!! be incremented when backward
** binary compatibility needs to be broken.
*/
#define MMAN_TRAP_INTERFACE_VERSION       1

/* MM trap interface function codes */
#define MMAN_TRAP_GET_INTERFACE_VERSION   0
#define MMAN_TRAP_GET_LAST_FCODE          1
#define MMAN_TRAP_MMAP                    2
#define MMAN_TRAP_MUNMAP                  3
#define MMAN_TRAP_MLOCK                   4
#define MMAN_TRAP_MUNLOCK                 5
#define MMAN_TRAP_VALIDATE_BUFFER         6
#define MMAN_TRAP_PAGER_CONTROL           7

WEAK_REF(size_t mman_validate_buffer(log_addr_t la, size_t sz, PROCESS pid, unsigned int perm, unsigned int options, unsigned int *result));

#endif /* #ifndef OSE_MMAN_TRAP_H_ */
