/* COPYRIGHT-ENEA-SRC-R2 *
 **************************************************************************
 * Copyright (C) 2004-2006 by Enea Software AB.
 * All rights reserved.
 *
 * This Software is furnished under a software license agreement and
 * may be used only in accordance with the terms of such agreement.
 * Any other use or reproduction is prohibited. No title to and
 * ownership of the Software is hereby transferred.
 *
 * PROPRIETARY NOTICE
 * This Software consists of confidential information.
 * Trade secret law and copyright law protect this Software.
 * The above notice of copyright on this Software does not indicate
 * any actual or intended publication of such Software.
 **************************************************************************
 * COPYRIGHT-END */

#include "osetypes.h"
#include "mmtypes.h"
#include "ose.h"
#include "hal.h"
#include "epm.h"
#include "cpu_regdump.h"

#define OSE_AGENT_IF_VERSION_MAJOR 2
#define OSE_AGENT_IF_VERSION_MINOR 3

#define OSE_AGENT_NAME "ose_agent"
#define BIOS_FUNC_START_AGENT "start_ose_test_agent"

#define OSE_AGENT_GET_IF_ID              2718001
#define OSE_AGENT_CACHE_SYNC             2718002
#define OSE_AGENT_GET_HAL_INFO           2718003
#define OSE_AGENT_INSTALL_ERR_HOOK       2718006
#define OSE_AGENT_FORCED_WRITE           2718007
#define OSE_AGENT_GET_MM_ATTRIBUTES      2718008

#define OSE_AGENT_EPM_ADD_EXECUTION_POINT      2718009
#define OSE_AGENT_EPM_REMOVE_EXECUTION_POINT   2718010
#define OSE_AGENT_EPM_NEXT_INSTRUCTION         2718011
#define OSE_AGENT_EPM_DISABLE_ALL              2718012
#define OSE_AGENT_EPM_ENABLE_ALL               2718013
#define OSE_AGENT_GET_CPU_DESCRIPTOR           2718014

#define OSE_AGENT_MM_MAP_RANGE                 2718015
#define OSE_AGENT_MM_UNMAP_RANGE               2718016
#define OSE_AGENT_MM_MULTITHREAD               2718017
#define OSE_AGENT_MM_CHECK_SWAPH               2718018 


/****************************************/

struct oseAgentCacheSync {
  SIGSELECT sigNo;
  OSADDRESS base;
  size_t size;
};

struct oseAgentGetHalInfo {
  SIGSELECT sigNo;
  struct hal_info info;
};

struct oseAgentGetIfId {
  SIGSELECT sigNo;
  U32 major;
  U32 minor;
};

struct oseAgentInstallErrHook {
  SIGSELECT sigNo;
  OSERRH    *hook;
  struct oseAgentInstallErrHook *next;
};

struct oseAgentForcedWrite {
  SIGSELECT sigNo;
  OSDOMAIN dst_domain;
  void *dst;
  const void *src;
  size_t size;
  int freeze_mode;
  int result;
};

struct oseAgentGetMmAttributes {
   SIGSELECT sigNo;
   U32 attr;
};

struct oseAgentEpmAddExecutionPoint {
   SIGSELECT sigNo;
   struct EpmExecutionPoint *ep;
   EpmStatus status;
};

struct oseAgentEpmRemoveExecutionPoint {
   SIGSELECT sigNo;
   struct EpmExecutionPoint *ep;
   EpmStatus status;
};

struct oseAgentEpmNextInstruction {
   SIGSELECT sigNo;
   struct cpu_regdump *dump;
   U32 options;
   OSADDRESS *next_address;
   EpmStatus status;
};

struct oseAgentEpmDisableAll {
   SIGSELECT sigNo;
   EpmStatus status;
};

struct oseAgentEpmEnableAll {
   SIGSELECT sigNo;
   EpmStatus status;
};
struct oseAgentGetCpuDescriptor {
   SIGSELECT sigNo;
   struct arch_cpu_descriptor  *hal_arch_cpu_descriptor;
};

enum swaph
{
   MM_TEST_SWAP_IN_HANDLER = 1
};

struct oseAgentCheckSwaph {
   SIGSELECT   sigNo;
   enum swaph  swaph_nr;
   mm_status_t status;
};

struct oseAgentMmMapRange {
   SIGSELECT   sigNo;
   OSDOMAIN    domain;
   log_addr_t  la;
   phys_addr_t pa;
   size_t      size;
   U32         permission;
   U32         cache_mode;
   int         options;
   mm_status_t result;
};

struct oseAgentMmUnmapRange {
   SIGSELECT   sigNo;
   OSDOMAIN    domain;
   log_addr_t  la;
   size_t      size;
   int         options;
   mm_status_t result;
};

struct oseAgentMmMultithread {
   SIGSELECT   sigNo;
   mm_bool_t   enable;
   mm_status_t result;
};
