/* COPYRIGHT-ENEA-SRC-R2 *
 **************************************************************************
 * Copyright (C) 2004-2006 by Enea Software AB.
 * All rights reserved.
 *
 * This Software is furnished under a software license agreement and
 * may be used only in accordance with the terms of such agreement.
 * Any other use or reproduction is prohibited. No title to and
 * ownership of the Software is hereby transferred.
 *
 * PROPRIETARY NOTICE
 * This Software consists of confidential information.
 * Trade secret law and copyright law protect this Software.
 * The above notice of copyright on this Software does not indicate
 * any actual or intended publication of such Software.
 **************************************************************************
 * COPYRIGHT-END */
#include "ramlog.h"
#include "compiler_macros.h"

#ifndef _RAMLOG_TRAPS
#define _RAMLOG_TRAPS

#define FC_ADDR_OF_OLDEST	0
#define FC_ADDR_OF_NEWEST	1
#define FC_FIND_NEXT		2
#define FC_FIND_PREV		3
#define FC_READ			4
#define FC_WRITE		5
#define FC_SET_OLDEST		6

#define BIOSNAME_RAMLOG		"RAMLOG"

WEAK_REF(RamlogVirtAddr ramlog_handle_addr_of_oldest(void));
WEAK_REF(RamlogVirtAddr ramlog_handle_addr_of_newest(void));
WEAK_REF(RamlogVirtAddr ramlog_handle_find_next(RamlogVirtAddr whence, const char *pattern));

WEAK_REF(RamlogVirtAddr ramlog_handle_find_previous(RamlogVirtAddr whence,
                                             const char *pattern));
WEAK_REF(size_t ramlog_handle_read(char *buf, size_t size,
                            RamlogVirtAddr req_addr,
                            RamlogVirtAddr *actual_addr));

WEAK_REF(size_t ramlog_handle_write(const char *buf, size_t size));

WEAK_REF(RamlogVirtAddr ramlog_handle_set_oldest(RamlogVirtAddr new_oldest));

void
ramlog_bios_install(void);

#endif /* #ifndef _RAMLOG_TRAPS */
