/* COPYRIGHT-ENEA-SRC-R2 *
 **************************************************************************
 * Copyright (C) 2004-2006 by Enea Software AB.
 * All rights reserved.
 *
 * This Software is furnished under a software license agreement and
 * may be used only in accordance with the terms of such agreement.
 * Any other use or reproduction is prohibited. No title to and
 * ownership of the Software is hereby transferred.
 *
 * PROPRIETARY NOTICE
 * This Software consists of confidential information.
 * Trade secret law and copyright law protect this Software.
 * The above notice of copyright on this Software does not indicate
 * any actual or intended publication of such Software.
 **************************************************************************
 * COPYRIGHT-END */
/****************************************************************
 *   Description:
 *	This interface file contains OSE-internal type definitions
 *	and prototypes for the System Parameter implementation. The
 *	sysparam_early_-functions are intended to be used before the
 *	OSE kernel has been started, and they assume single threaded
 *	execution.
 ****************************************************************
 */
#ifndef OSE_SYSPARAM_SYS_H_
#define OSE_SYSPARAM_SYS_H_

#include "stddef.h"
#include "sysparam.h"
#include "compiler_macros.h"

#define BIOSNAME_SYSPARAM   "SYSPARAM"

   /* Define a base different from zero so that if anybody unintentionally
    * calls this BIOS module the function code will probably be wrong an thus
    * the error detected.
    */
#define SYSPAR_FC_BASE	0x02aa4545
   
   enum SysparamBiosCode
   {
      SYSPARAM_BIOS_READ		= SYSPAR_FC_BASE + 0,
      SYSPARAM_BIOS_LIST_NEXT		= SYSPAR_FC_BASE + 1,
      SYSPARAM_BIOS_WRITE		= SYSPAR_FC_BASE + 2,
      SYSPARAM_BIOS_READATTR_LONG	= SYSPAR_FC_BASE + 3,
      SYSPARAM_BIOS_READATTR_STRING	= SYSPAR_FC_BASE + 4,
      SYSPARAM_BIOS_READATTR_ENUM	= SYSPAR_FC_BASE + 5,
      SYSPARAM_BIOS_READATTR_LONGLONG	= SYSPAR_FC_BASE + 6
   };
   
WEAK_REF(size_t sysparam_handle_read(const char *name, char *buffer,size_t bufsize));

WEAK_REF(size_t sysparam_handle_list_next(const char *str, char *buffer,size_t bufsize));

WEAK_REF(int sysparam_handle_write(const char *name, const char *value));


WEAK_REF(int sysparam_handle_readattr_long(const char *param_name, const char *attr,
				  long *value));

WEAK_REF(int sysparam_handle_readattr_longlong(const char *param_name, const char *attr,
				  long long int *value));

WEAK_REF(int sysparam_handle_readattr_string(const char *param_name, const char *attr,
                                             char *value, size_t bufsize));

WEAK_REF(int sysparam_handle_readattr_enum(const char *param_name, const char *attr,
                                           const struct enumeration *enumeration,
                                           long *value));

void
zzsysparam_bios_install(void);
   
#endif /* #ifndef OSE_SYSPARAM_SYS_H_ */
