/* COPYRIGHT-ENEA-SRC-R2 *
 **************************************************************************
 * Copyright (C) 2004-2006 by Enea Software AB.
 * All rights reserved.
 *
 * This Software is furnished under a software license agreement and
 * may be used only in accordance with the terms of such agreement.
 * Any other use or reproduction is prohibited. No title to and
 * ownership of the Software is hereby transferred.
 *
 * PROPRIETARY NOTICE
 * This Software consists of confidential information.
 * Trade secret law and copyright law protect this Software.
 * The above notice of copyright on this Software does not indicate
 * any actual or intended publication of such Software.
 **************************************************************************
 * COPYRIGHT-END */
/* 
** This file defines requiremnts for the exec_start start sequence.
**
** exec_start by itself defines the kernel entry point, but no other services.
*/

#include "osetypes.h"		/* OSE types. */
#include "krncon.h"		/* KRN configuration. */

/*
******************************************************************************
** exec_start.c offers zzcpu_hal() for access of the selected cpu hal.
******************************************************************************
*/
const struct cpu_descriptor *zzcpu_hal(void);

/*
******************************************************************************
** Implemented by the target interface:
**
** All these functions are called in supervisor mode with interrupts disabled.
******************************************************************************
*/

/* Configuration of the Target Interface */
extern struct Ti_ctlblk zzconf; 

/* Early System Call handler used before pose started. */
U32 zzearly_syscallh(void);
	
/* Install an early system call handler in the interface library. */
void zzkrnflib_init(U32 (*zzearly_syscallh)(void)); 

/*
** Initiate target interface variables using information from the kernel 
** configuration and cpu probing.
** Return size of the entire exception vector area. 
*/
U32 zzinit_ti(U32 exec_attributes); 

/* Get the processor identification register (pvr) from the chip, or zero if 
** none is found. */
U32 zzget_cpu_id(void);

/* Try to convert a cpu model number to a pvr value, return zero if unknown. */
U32 zzcpu_to_pvr(U32 cpu_model); 

/* Get current vector base from hardware */
U32 zzget_vector_base(void);

/* Set hardware vector base. If the specified vector base can't be used,
** then just return the current vector base. Otherwise return the new base.
*/
U32 zzset_vector_base(U32 vector_base);

/* Install kernel handled exception vectors */
void zzinstall_vectors(U32 vector_base);

/*
******************************************************************************
** Implemented by Bios:
**
** These functions are called with interrupts disabled.
******************************************************************************
*/
void zzinitBios(void);	

