/* COPYRIGHT-ENEA-SRC-R2 *
 **************************************************************************
 * Copyright (C) 2009 by Enea Software AB.
 * All rights reserved.
 *
 * This Software is furnished under a software license agreement and
 * may be used only in accordance with the terms of such agreement.
 * Any other use or reproduction is prohibited. No title to and
 * ownership of the Software is hereby transferred.
 *
 * PROPRIETARY NOTICE
 * This Software consists of confidential information.
 * Trade secret law and copyright law protect this Software.
 * The above notice of copyright on this Software does not indicate
 * any actual or intended publication of such Software.
 **************************************************************************
 * COPYRIGHT-END */

#ifndef __ISR_H
#define __ISR_H

#ifndef __ASM_ONLY__

#include <stddef.h>
#include "ose.h"

/* Maximum number of vector entries supported by the target
 * interface. Must match the amount of entries provided by each target
 * interface for the zzint_table array. Could be redefined per
 * architecture if needed in the future. */
#define VECTOR_NUM_ENTRIES 255

/* Number of ISR slots per vector. This defines the maximum number of
 * ISRs + vector_hooks that can be used on a certain vector. */
#define ISR_NUM_ENTRIES 7

#define ISR_TYPE_ISR 1
#define ISR_TYPE_HOOK 0

struct intdata
{
   OSPRIORITY pri; /* Interrupt priority. */
   uint8_t pad[3]; /* Occupy the remaining 3 bytes. */
   void *pcb;
   void *isr[ISR_NUM_ENTRIES + 1]; /* An additional slot is reserved that must be 0. */
   uint32_t arg[ISR_NUM_ENTRIES];
   uint32_t type[ISR_NUM_ENTRIES];
};

#else /* __ASM_ONLY__ */

/* Offsets useful from assembler code. Must match structure above. */

#define intdata_pri		0
#define intdata_pcb		4
#define intdata_isr		8
#define intdata_arg		40
#define intdata_type		68

#endif /* __ASM_ONLY__ */

#endif /* __ISR_H */
