/* COPYRIGHT-ENEA-SRC-R2 *
 **************************************************************************
 * Copyright (C) 2004-2006 by Enea Software AB.
 * All rights reserved.
 *
 * This Software is furnished under a software license agreement and
 * may be used only in accordance with the terms of such agreement.
 * Any other use or reproduction is prohibited. No title to and
 * ownership of the Software is hereby transferred.
 *
 * PROPRIETARY NOTICE
 * This Software consists of confidential information.
 * Trade secret law and copyright law protect this Software.
 * The above notice of copyright on this Software does not indicate
 * any actual or intended publication of such Software.
 **************************************************************************
 * COPYRIGHT-END */
#ifndef _KRNCON_H
#define _KRNCON_H

/*EXTRACT_START*/

/* Ti_ctlblk magic number. Tagged to extract to assembler include file. */
/*DEFINE_START*/
#define TI_CTLBLK_MAGIC 0x4C0B
/*DEFINE_STOP*/

struct Ti_preserved_vec
{
   OSADDRESS offset;
   OSADDRESS count;
};

struct Ti_ctlblk
{
    /*INC_PREFIX conf_ */
    /*INC_CONTINUE*/
    /* Extracted from krncon.c when the kernel was compiled */
    /* DO NOT CHANGE! */
    OSADDRESS	magic ;		/* Set by kernel */
    OSADDRESS	struct_size ;	/* Set by kernel */
    OSADDRESS	inherit_preinstalled_bsp ;
    OSADDRESS	debug ;
    OSADDRESS	error_checks ;
    OSADDRESS	remote_calls ;
    OSADDRESS	memory_model ;

    OSADDRESS	cpu ;		
    OSADDRESS	vector_base ;	
    OSADDRESS	vector_base_set ;
    OSADDRESS	user_start ;	
    OSADDRESS	superv_stacksize ; 
    OSADDRESS	user_area ;	
    OSADDRESS	internal_timer_vector ;		
    OSADDRESS	use_fpu ;	
    OSADDRESS	bplevel ;	
    OSADDRESS	sysproc_count ;	
    OSADDRESS	sysprocs ;	
    OSADDRESS	count_per_tick ;	
    OSADDRESS	count_per_ms ;		
    OSADDRESS	tick_add ;	
    OSADDRESS	tick_shift ;	

    OSADDRESS	start_handler1_list ; 
    OSADDRESS	create_handler_list ; 
    OSADDRESS	kill_handler_list ; 
    OSADDRESS	swap_in_handler_list ; 
    OSADDRESS	swap_out_handler_list ; 

    OSADDRESS	err_handler ;	
    OSADDRESS	clear_bp_handler ; 
    OSADDRESS	set_bp_handler ;	
    OSADDRESS	read_microtick_handler ;	
    OSADDRESS	clear_microtick_handler ; 
    OSADDRESS	vector_handler ;	
    OSADDRESS	int_mask_handler ; 
    OSADDRESS	power_off_handler ; 
    OSADDRESS	start_handler0_deprecated ;
    OSADDRESS	power_save_handler ; 
    OSADDRESS	warmstart_handler ; 
    OSADDRESS	start_status_handler ; 
    OSADDRESS	int_create_handler ; 
    OSADDRESS	int_kill_handler ; 
    OSADDRESS	attach_block_handler ; 
    OSADDRESS	mem_move_handler ; 
    OSADDRESS	remove_block_handler ; 
    OSADDRESS	select_segment_handler ;	
    OSADDRESS	set_segment_mode_handler ; 
    OSADDRESS	kernel_halted_handler ;

    OSADDRESS	internal_timer ;		
    U8		ose_trap [ 4 ] ; /* [0-2] 3 traps for 68K + [3] set flag */
    OSADDRESS	preserv_vec_list ;
    OSADDRESS	cpu_probe_handler_list ;
    OSADDRESS	start_handler0_list ;
    OSADDRESS	vector_write_base ;
    OSADDRESS	vector_write_base_set ;	   
    OSADDRESS	end ;		/* Not really part of structure! */
    /*INC_STOP*/
};

/*EXTRACT_STOP*/


/* 
** The start stack. 
**
** The stack is provided by the configuration module krncon.c and
** used by the kernel. Early kernel handlers run on this stack.
** The kernel may reuse this stack for other purpose in a running system.
*/
extern OSADDRESS zzstart_stack[];

/* 
** Get kernel configuration from con-file part 1.
**
** This function is called by the kernel during early system start. 
** It runs in supervisor mode with interrupts disabled.
*/
void zzose_con_0(struct Ti_ctlblk *ti_ctl);

/* 
** Get kernel configuration from con-file part 2.
**
** This function is called by the kernel during early system start. 
** It runs in supervisor mode with interrupts disabled.
*/
void zzose_con_1(struct Ti_ctlblk *ti_ctl);


/* 
** Get the size of the start stack.
**
** This function is called by the kernel during early system start. 
** It runs in supervisor mode with interrupts disabled.
*/
OSADDRESS zzget_start_stack_size(void);

#endif
