/* COPYRIGHT-ENEA-SRC-R2 *
 **************************************************************************
 * Copyright (C) 2004-2006 by Enea Software AB.
 * All rights reserved.
 *
 * This Software is furnished under a software license agreement and
 * may be used only in accordance with the terms of such agreement.
 * Any other use or reproduction is prohibited. No title to and
 * ownership of the Software is hereby transferred.
 *
 * PROPRIETARY NOTICE
 * This Software consists of confidential information.
 * Trade secret law and copyright law protect this Software.
 * The above notice of copyright on this Software does not indicate
 * any actual or intended publication of such Software.
 **************************************************************************
 * COPYRIGHT-END */

/*DEFINE_START*/

#define STACK_PATTERN 0xeeeeeeee

#define START_STACK_SIZE 2048

#define IFRAME_MAGIC 0x1faa

#define MAX_INTVEC 255

#define NO_ASM_VECTORS 32
#define NO_C_VECTORS   35

/* 0xffff */
#define FREE_PCB 0xffff

/* Error mode. */
#define FATAL_ERROR  2
#define SYSTEM_ERROR 1
#define WARNING      0

/* Pcb offsets in pose. */
#define PCB_UAREA      80
#define PCB_ENTRYPOINT 88

/* Process types. */
#define OS_INT_PROC 128
#define OS_TI_PROC  256

/* FPU states. */
#define FPU_NOT_PRESENT	0
#define FPU_PRESENT	1
#define FPU_PROBE_PHASE	2

/* Sysconf constants. */

/* Install a new function in get_sysconf. */
#define SYSCONF_NEW_FUNCTION           2

/* Set error check by get_sysconf. */
#define SYSCONF_SET_ERROR_CHECK        3

/* get_sysconf codes installed by ti. */
#define SYSCONF_MMU_HAL_GET_ASID      36

/* Bios constants. */

/* Max number of installed products. */
#define BIOS_TABLE_LEN	64

/* Offsets in table. */
#define BIOS_FPTR_OFFSET	0
#define BIOS_FLAG_OFFSET	4
#define BIOS_NAME_OFFSET	8
#define BIOS_NAME_END_OFFSET	31
#define BIOS_ENTRY_SIZE		32

/* Stack-frame offsets. */
#define BIOS_OFFSET_ENTRY_HI	 0
#define BIOS_OFFSET_SR		 4
#define BIOS_OFFSET_EPC		 8
#define BIOS_OFFSET_SP		16
#define BIOS_OFFSET_RA		24
#define BIOS_FRAME_SIZE		32

#define VECTOR_SIZE          0x300

#define KSEG0_BASE 0x80000000

#define EXCEPTION_DEPTH_MAX      3

#define SMP_INTERRUPT_STACK_SIZE 4096

/*DEFINE_STOP*/

extern void *zzalloc_uarea_block(void);

#if 0
/* THIS STRUCT HAS BEEN MOVED TO core/private/mips/ti_cpu_data.h */
/* The struct is kept here to be able to autogenerate .inc file. */
/* Per cpu data, keep size 64 bytes! */
struct ticpu
{
/*INC_PREFIX ticpu_ */
/*INC_START*/

   /* Generic cpu_id. Not dependant of board/bsp. */
   U32 cpu_id;

   /* Current interrupt level. */
   U32 current_int_level;

   /* Interrupt stack pointer. */
   U32 isp;

   /* Interrupt stack end address. */
   U32 isp_limit;

   /* --- Cache line --- */

   /* Temporary save area for exception handling. */
   REG64 exc_pc;
   REG64 exc_badvaddr;
   /* --- Cache line --- */
   U32 exc_sr;
   U32 exc_cause;
   U32 exc_entry_hi;

   /* Test purpose */
   U32 intcount;

   /* --- Cache line --- */

   /* Idle stack pointer. */
   U32 idle_sp;
   
   /* Vector number for non general exceptions . */
   U8 dedicated_vector;

   /* Flag for fatal recursive exceptions. */
   U8 recursive_exception_flag;

   U8 _byte1;
   U8 _byte2;
   
   /* Saved sp for first int level. */
   REG64 sp_first_int_level;

   /* Pad to 128 bytes. */
   U8 padv [ 64 ] ;
/*INC_STOP*/
};
#endif

struct tidata
{
   /*INC_PREFIX ti_ */
   /*INC_START*/

   /* For dummy stack tests. */
   U32 stack_pattern;

   U8 fpu_state;

   U8 upage_state;

   U8 inthook_flag;

   U8 _byte1;

   /* Function pointer for zzclear_microticks. */
   U32 clear_microticks;

   /* Function pointer for zzget_microticks. */
   U32 get_microticks;
      
   /* --- Cache line --- */

   U32 softtick;

   /* The uarea free list. */
   UAREA *free_uarea;

   /* Free list for supervisor stacks. */
   U32 free_superv_stack;

   /* Label used to swap in new processes. */
   U32 cont_preemption;

   /* --- Cache line --- */

   /* Return address for processes. */
   U32 dead_process;

   /* Address to zzmain_init. */
   U32 zzmain_init;
      
   REG64 safecopy_freeze_mode_sp;

   /* --- Cache line --- */

   /* Pointer to get_cpu() string. */
   char *cpu_string;

   /* Pointer to old sysconf_54 function. */
   U32 sysconf_54;
   
   /*INC_STOP*/
};

struct intframe
{
   /*INC_PREFIX intframe_ */
   /*INC_START*/
   U32 magic;
   U32 intcount;
   U32 vector;
   U32 _pad;

   REG64 zero;
   REG64 at;
   REG64 v0;
   REG64 v1;

   REG64 a0;
   REG64 a1;
   REG64 a2;
   REG64 a3;

   REG64 t0;
   REG64 t1;
   REG64 t2;
   REG64 t3;

   REG64 t4;
   REG64 t5;
   REG64 t6;
   REG64 t7;

   REG64 s0;
   REG64 s1;
   REG64 s2;
   REG64 s3;

   REG64 s4;
   REG64 s5;
   REG64 s6;
   REG64 s7;

   REG64 t8;
   REG64 t9;
   REG64 k0;
   REG64 k1;
      
   REG64 gp;
   REG64 sp;
   REG64 fp;
   REG64 ra;
      
   REG64 lo;
   REG64 hi;

   REG64 epc;
   U32 sr;
   U32 entry_hi;

#if 0
   U32 size;	/* Used only by .inc file to get size, don't remove. */
#endif
   /*INC_STOP*/
};
