/* COPYRIGHT-ENEA-SRC-R2 *
 **************************************************************************
 * Copyright (C) 2004-2006 by Enea Software AB.
 * All rights reserved.
 *
 * This Software is furnished under a software license agreement and
 * may be used only in accordance with the terms of such agreement.
 * Any other use or reproduction is prohibited. No title to and
 * ownership of the Software is hereby transferred.
 *
 * PROPRIETARY NOTICE
 * This Software consists of confidential information.
 * Trade secret law and copyright law protect this Software.
 * The above notice of copyright on this Software does not indicate
 * any actual or intended publication of such Software.
 **************************************************************************
 * COPYRIGHT-END */
/*
 * Instruction codes.
 */
#define INST_NORMAL              0
#define INST_ILLEGAL             1
#define INST_SYSCALL             2
#define INST_MFC0_STATUS_REG     3
#define INST_MTC0_STATUS_REG     4

#define INST_BR       0x100
#define INST_J        (INST_BR | 1)
#define INST_JAL      (INST_BR | 2)
#define INST_JR       (INST_BR | 3)
#define INST_JALR     (INST_BR | 4)

#define INST_BC       0x1000
#define INST_BEQ      (INST_BC | 1)
#define INST_BNE      (INST_BC | 2)
#define INST_BLEZ     (INST_BC | 3)
#define INST_BGTZ     (INST_BC | 4)
#define INST_BLTZ     (INST_BC | 5)
#define INST_BEGZ     (INST_BC | 6)
#define INST_BLTZAL   (INST_BC | 7)
#define INST_BEGZAL   (INST_BC | 8)

#define INST_TRAP     0x10000
#define INST_TGE      (INST_TRAP | 1)
#define INST_TGEU     (INST_TRAP | 2)
#define INST_TLT      (INST_TRAP | 3)
#define INST_TLTU     (INST_TRAP | 4)
#define INST_TEQ      (INST_TRAP | 5)
#define INST_TNE      (INST_TRAP | 6)
#define INST_TGEI     (INST_TRAP | 7)
#define INST_TGEUI    (INST_TRAP | 8)
#define INST_TLTI     (INST_TRAP | 9)
#define INST_TLTUI    (INST_TRAP | 10)
#define INST_TEQI     (INST_TRAP | 11)
#define INST_TNEI     (INST_TRAP | 12)

/*
 * Checks branch bits.
 */
#define BR(x) (x & INST_BR)
#define BC(x) (x & INST_BC)

/*
 * Field codes.
 */
#define MASK_BIT_20_16 0x001F0000
#define RT(x)             ((x & MASK_BIT_20_16) >> 16)

U32
zzpreprocess_trace(U32 instr, U32 pc, U32 *addr_post);

void
zzget_trace_address(U32 type, U32 instr, U32 pc,
		    void *intframe, U32 *post_addr);
/* 
** Convert register id to U32 offset in struct cpu_core.
** id is given as specified in public interface efmi_registers.h
** Returns ~0 for unknown registers.
*/
U32 zzget_regdump_core_offset(U32 id);
