/* COPYRIGHT-ENEA-SRC-R2 *
 **************************************************************************
 * Copyright (C) 2004-2006 by Enea Software AB.
 * All rights reserved.
 *
 * This Software is furnished under a software license agreement and
 * may be used only in accordance with the terms of such agreement.
 * Any other use or reproduction is prohibited. No title to and
 * ownership of the Software is hereby transferred.
 *
 * PROPRIETARY NOTICE
 * This Software consists of confidential information.
 * Trade secret law and copyright law protect this Software.
 * The above notice of copyright on this Software does not indicate
 * any actual or intended publication of such Software.
 **************************************************************************
 * COPYRIGHT-END */
#ifndef INLINE_H
#define INLINE_H

#include "cpu_intlock.h"

/* Type definition for interrupt mask variables, used by LOCK functions */
#define LOCKSTATE_CONFIGURED
typedef unsigned int	LOCKSTATE;

/* State that LOCK functions are configured. */
#define LOCK_FUNCTIONS_CONFIGURED

#ifdef OSE_SMP

#define BKL_LOCK()		zzbkl_lock()
#define BKL_UNLOCK()		zzbkl_unlock()
#define BKL_LOCK_SAVE(state)	(state) = zzbkl_lock_save()
#define BKL_LOCK_RESTORE(state)	zzbkl_lock_restore(state)

#else

#define BKL_LOCK()		LOCK()
#define BKL_UNLOCK()		UNLOCK()
#define BKL_LOCK_SAVE(state)	LOCK_SAVE(state)
#define BKL_LOCK_RESTORE(state)	LOCK_RESTORE(state)

#endif

#define LOCK() (void)LOCK_SAVE_()

#undef UNLOCK
static __inline__ void
UNLOCK(void)
{
    __asm__ volatile
    (
        "mfc0	$2,$12\n\t"
        "nop\n\t"
        "ori	$2,$2,1\n\t"
        "mtc0	$2,$12\n\t"
        : /*outputs*/
        : /*no inputs*/
        : /*trashes*/ "$2"
    );
}

#undef SYNC
#define SYNC() \
   do __asm__ volatile("sync": : :"memory"); while(0)

/*
** Barrier macros
** Synchronize shared memory for multicore kernels.
** SMP_LOAD_MEMBAR() is a barrier suitable for lock operations.
** SMP_STORE_MEMBAR() is a barrier suitable for unlock operations.
*/
#ifdef OSE_SMP
#define SMP_STORE_MEMBAR() __asm__ volatile ("sync")
#define SMP_LOAD_MEMBAR() __asm__ volatile ("sync")
#else
#define SMP_STORE_MEMBAR()
#define SMP_LOAD_MEMBAR()
#endif


#ifdef OSE_SMP
#if defined(__GNUC__)

static inline cpuid_t
zzkrn_bkl_lock_id(void)
{
   cpuid_t id;

   __asm__ __volatile__ ("lw %0,($28)" /* zzcpu.cpu_id */ :"=r"(id));
   return id | 0x8800; /* Add nonzero part to cpu_id. */
}

#endif
#endif

#endif
