/* COPYRIGHT-ENEA-SRC-R2 *
 **************************************************************************
 * Copyright (C) 2008 by Enea Software AB.
 * All rights reserved.
 *
 * This Software is furnished under a software license agreement and
 * may be used only in accordance with the terms of such agreement.
 * Any other use or reproduction is prohibited. No title to and
 * ownership of the Software is hereby transferred.
 *
 * PROPRIETARY NOTICE
 * This Software consists of confidential information.
 * Trade secret law and copyright law protect this Software.
 * The above notice of copyright on this Software does not indicate
 * any actual or intended publication of such Software.
 **************************************************************************
 * COPYRIGHT-END */

#ifndef TI_CPU_DATA_H
#define TI_CPU_DATA_H

#include "stdint.h"
#include "per_cpu_data.h"

/* Per cpu data, keep size 64 bytes! */
struct ticpu
{
/*INC_PREFIX ticpu_ */
/*INC_START*/

   /* Generic cpu_id. Not dependant of board/bsp. */
   U32 cpu_id;

   /* Current interrupt level. */
   U32 current_int_level;

   /* Interrupt stack pointer. */
   U32 isp;

   /* Interrupt stack end address. */
   U32 isp_limit;

   /* --- Cache line --- */

   /* Temporary save area for exception handling. */
   uint64_t exc_pc;
   uint64_t exc_badvaddr;
   /* --- Cache line --- */
   U32 exc_sr;
   U32 exc_cause;
   U32 exc_entry_hi;

   /* Test purpose */
   U32 intcount;

   /* --- Cache line --- */

   /* Idle stack pointer. */
   U32 idle_sp;
   
   /* Vector number for non general exceptions . */
   U8 dedicated_vector;

   /* Flag for fatal recursive exceptions. */
   U8 recursive_exception_flag;

   U8 _byte1;
   U8 _byte2;

   /* Saved sp for first int level. */
   uint64_t sp_first_int_level;

  /* Reserve space for ti part */
  U8 __pad_ti_part[TI_PER_CPU_SIZE - 64];
/*INC_STOP*/
};

#ifndef OSE_SMP

/* Define struct for non-smp systems. For smp, this struct is defined in
 * pose_internal.h.
 */
struct per_cpu
{
   struct ticpu ticpu;	/* Target Interface per cpu data. */
};

extern
struct per_cpu zzcpu[];

#endif

#ifdef OSE_SMP

static __inline__ struct _pcb*
zzkrn_get_cur_p(void)
{
#if 0
   register struct per_cpu *data asm("$28");
   return data->curr_p;
#else
   U32 id;
   __asm__ __volatile__ (" lw %0,512+4($28)" :"=r"(id):);
   return (struct _pcb *) id;
#endif
}

static __inline__ void
zzkrn_set_cpu_id(cpuid_t id)
{
   __asm__ __volatile__ (" sw %0,0($28)" ::"r"(id));
}

static struct _pcb *zzkrn_get_cur_p_usr(void);

static __inline__ struct _pcb *
zzkrn_get_cur_p_usr(void)
{
   U32 id;
   __asm__ __volatile__ (" lw %0,512+4($28)" :"=r"(id):);
   return (struct _pcb *) id;
}
#endif

#endif
