/* COPYRIGHT-ENEA-SRC-R2 *
 **************************************************************************
 * Copyright (C) 2010 by Enea Software AB.
 * All rights reserved.
 *
 * This Software is furnished under a software license agreement and
 * may be used only in accordance with the terms of such agreement.
 * Any other use or reproduction is prohibited. No title to and
 * ownership of the Software is hereby transferred.
 *
 * PROPRIETARY NOTICE
 * This Software consists of confidential information.
 * Trade secret law and copyright law protect this Software.
 * The above notice of copyright on this Software does not indicate
 * any actual or intended publication of such Software.
 **************************************************************************
 * COPYRIGHT-END */

#ifndef HEAP_FILTER_NOBREAK_H
#define HEAP_FILTER_NOBREAK_H

#include "heap.h"


/*****************************************************************************/

/*
 * This function should never be declared as weak. Doing so would permit
 * removal of the plug-in and the no_extend allocation methods could start to
 * break new memory from GMM. Interrupt processes would generate an error
 * since blocking system calls are illegal (typically receive() from GMM). 
 */

HeapStatus
heap_attach_nobreak_filter(struct Heap *heap);

/*****************************************************************************/



#endif /* HEAP_FILTER_NOBREAK_H */
