/* COPYRIGHT-ENEA-SRC-R2 *
 **************************************************************************
 * Copyright (C) 2010 by Enea Software AB.
 * All rights reserved.
 *
 * This Software is furnished under a software license agreement and
 * may be used only in accordance with the terms of such agreement.
 * Any other use or reproduction is prohibited. No title to and
 * ownership of the Software is hereby transferred.
 *
 * PROPRIETARY NOTICE
 * This Software consists of confidential information.
 * Trade secret law and copyright law protect this Software.
 * The above notice of copyright on this Software does not indicate
 * any actual or intended publication of such Software.
 **************************************************************************
 * COPYRIGHT-END */


#ifndef HEAP_FILTER_SAFE_H
#define HEAP_FILTER_SAFE_H

#include "heap.h"

/*****************************************************************************/

/*
 * This function should never be declared as weak. Doing so would permit
 * removal of the plug-in and all safe allocation methods could start to
 * return NULL. Applications would crash since no checks for NULL pointers
 * from these methods can be expected.
 */

HeapStatus
heap_attach_safe_filter(struct Heap *heap,
                        uint8_t on_alloc, uint8_t on_break);

/*****************************************************************************/

#endif /* HEAP_FILTER_SAFE_H */

