/* COPYRIGHT-ENEA-SRC-R2 *
**************************************************************************
* Copyright (C) 2010 by Enea Software AB.
* All rights reserved.
*
* This Software is furnished under a software license agreement and
* may be used only in accordance with the terms of such agreement.
* Any other use or reproduction is prohibited. No title to and
* ownership of the Software is hereby transferred.
*
* PROPRIETARY NOTICE
* This Software consists of confidential information.
* Trade secret law and copyright law protect this Software.
* The above notice of copyright on this Software does not indicate
* any actual or intended publication of such Software.
**************************************************************************
* COPYRIGHT-END */

#ifndef HEAP_RBTREE_H
#define HEAP_RBTREE_H

#include "core_rbtree.h"

typedef core_rbtree_t      rbtree_t;
typedef core_rbtree_node_t rbtree_node_t;

#define rbtree_init(tree, compare)      core_rbtree_init(tree, compare)

#define rbtree_insert(tree, node)       core_rbtree_insert_no_lock(tree, node)
#define rbtree_remove(tree, node)       core_rbtree_remove_no_lock(tree, node)
#define rbtree_first(tree)              core_rbtree_first_no_lock(tree)
#define rbtree_next(tree, node)         core_rbtree_next_no_lock(tree, node)
#define rbtree_find(tree, compare, key) core_rbtree_find_no_lock(tree, compare, key)
#define rbtree_find_best(tree, compare, key) core_rbtree_find_best_no_lock(tree, compare, key)

#endif /* HEAP_RBTREE_H */
