/* COPYRIGHT-ENEA-SRC-R2 *
 **************************************************************************
 * Copyright (C) 2010 by Enea Software AB.
 * All rights reserved.
 *
 * This Software is furnished under a software license agreement and
 * may be used only in accordance with the terms of such agreement.
 * Any other use or reproduction is prohibited. No title to and
 * ownership of the Software is hereby transferred.
 *
 * PROPRIETARY NOTICE
 * This Software consists of confidential information.
 * Trade secret law and copyright law protect this Software.
 * The above notice of copyright on this Software does not indicate
 * any actual or intended publication of such Software.
 **************************************************************************
 * COPYRIGHT-END */

#ifndef HEAP_FILTER_MONITOR_H
#define HEAP_FILTER_MONITOR_H

#include "heap.h"
#include "ose_heap.h"
#include "compiler.h"

/*****************************************************************************
 * Data Structures
 *****************************************************************************/
struct HeapMonitor;



/*****************************************************************************
 * Public Interface
 *****************************************************************************/

WEAK_REF(struct HeapMonitor *
heap_init_monitor_filter(struct Heap *heap, 
                         struct HeapStatistics *stats,
                         struct HeapConfiguration *config,
                         OSHEAP href, PROCESS pid,
                         size_t low_level, size_t high_level));

/*****************************************************************************/

WEAK_REF(void
heap_destroy_monitor_filter(struct Heap *heap, struct HeapMonitor *monitor));

/*****************************************************************************/

WEAK_REF(HeapStatus
heap_attach_monitor_filter(struct Heap *heap, struct HeapMonitor *monitor));

/*****************************************************************************/

WEAK_REF(HeapStatus
heap_detach_monitor_filter(struct Heap *heap, struct HeapMonitor *monitor));

/*****************************************************************************/

#endif /* HEAP_FILTER_MONITOR_H */
