/* COPYRIGHT-ENEA-SRC-R2 *
 **************************************************************************
 * Copyright (C) 2010 by Enea Software AB.
 * All rights reserved.
 *
 * This Software is furnished under a software license agreement and
 * may be used only in accordance with the terms of such agreement.
 * Any other use or reproduction is prohibited. No title to and
 * ownership of the Software is hereby transferred.
 *
 * PROPRIETARY NOTICE
 * This Software consists of confidential information.
 * Trade secret law and copyright law protect this Software.
 * The above notice of copyright on this Software does not indicate
 * any actual or intended publication of such Software.
 **************************************************************************
 * COPYRIGHT-END */

#ifndef OSE_HEAPD_H
#define OSE_HEAPD_H

#include "ose.h"
#include "ose_heap.h"

#include "heap.h"



/***************************************************************************
 * Helper Macros
 ***************************************************************************/
#define HUCB_FROM_HREF(ref)    ((HUCB *)((ref) & 0xFFFFFFFC))
#define HEAP_FROM_HUCB(hucb)   ((struct Heap *)&hucb[1])
#define HREF_FROM_HEAP(heap)   (((OSHEAP)(heap))|(heap->shared != 0))
#define HEAP_FROM_HREF(href)   ((struct OseHeap*)(href & ~1))
#define HREF_FROM_HUCB(hucb)   (((OSHEAP)(hucb))|(((struct OseHeap*)(hucb))->shared != 0))
#define OSHEAP_FROM_HEAP(heap) ((struct OseHeap *)&((HUCB *)heap)[-1])
/****************************************************************************/
#define HEAP_BIOS_NAME "HEAP"
/***************************************************************************/


/*****************************************************************************
 * Data Structures
 ****************************************************************************/
struct OseHeap
{
   HUCB                     hucb;
   struct Heap              heap;
   struct HeapStatistics    stats;
   struct HeapConfiguration config;
   struct HeapMonitor      *monitor;
   
   struct OseHeap          *next;
   struct OseHeap          *prev;

   PROCESS                  owner;
   PROCESS                  daemon;
   PROCESS                  daemon_stopped;
   OSDOMAIN                 domain;
   uint8_t                  shared;
   uint8_t                  manager;
   uint8_t                  tentative;

   /* Legacy configuration. */
   uint8_t                  buf_error_on_null;
   size_t                   frag_slow_limit;
   size_t                   frag_llow_limit;
   char                     frag_log_mem[MM_NAME_LENGTH+1];
   uint32_t                 frag_permissions;
   uint32_t                 frag_cache_mode;
};
/****************************************************************************/



/*****************************************************************************
 * Functions
 ****************************************************************************/

PROCESS
heapd_daemon_create(OSDOMAIN domain, PROCESS bid,
                    PROCESS ownerpid, OSENTRYPOINT *entry,
                    struct OseHeap *heap);

/****************************************************************************/

struct OseHeap *
heapd_heap_find(OSHEAP href);

/****************************************************************************/

struct OseHeap *
heapd_heap_first(void);

/****************************************************************************/

struct OseHeap *
heapd_heap_next(struct OseHeap *heap);

/****************************************************************************/

OS_PROCESS(ose_heapcd);

/****************************************************************************/


#endif /* OSE_HEAPD_H */

