/* COPYRIGHT-ENEA-SRC-R2 *
******************************************************************************
 * Copyright (C) 2009 by Enea Software AB.
 * All rights reserved.
 *
 * This Software is furnished under a software license agreement and
 * may be used only in accordance with the terms of such agreement.
 * Any other use or reproduction is prohibited. No title to and
 * ownership of the Software is hereby transferred.
 *
 * PROPRIETARY NOTICE
 * This Software consists of confidential information.
 * Trade secret law and copyright law protect this Software.
 * The above notice of copyright on this Software does not indicate
 * any actual or intended publication of such Software.
 *****************************************************************************
 * COPYRIGHT-END */


#ifndef OSE_HEAPD_SIG
#define OSE_HEAPD_SIG

/*****************************************************************************/

#define HEAPD_HEAP_CREATE    33399

struct HeapdHeapCreate
{
   SIGSELECT     sig_no;         /* I: Signal number: 33399                  */
   PROCESS       owner;          /* I: Program/block/phantom owner PID.      */
   OSDOMAIN      domain;         /* I: Protection domain.                    */
   OSBOOLEAN     supervisor;     /* I: User/supervisor mode.                 */
   U32           status;         /* O: Status of operation.                  */
   OSHEAP        href;           /* O: Created heap reference. 0 if failure. */
};

/*****************************************************************************/

#define HEAPD_HEAP_DESTROY   33391

struct HeapdHeapDestroy
{
   SIGSELECT     sig_no;         /* I: Signal number: 33391                  */
   OSHEAP        href;           /* I: Heap reference to destroy.            */
};

/*****************************************************************************/

#define HEAPD_CLIENT_ADD     33398

struct HeapdClientAdd
{
   SIGSELECT     sig_no;         /* I: Signal number: 33398                  */
   OSHEAP        href;           /* I: Heap reference.                       */ 
};

/*****************************************************************************/

#define HEAPD_CLIENT_REM     33390

struct HeapdClientRem
{
   SIGSELECT     sig_no;         /* I: Signal number: 33390                  */
   OSHEAP        href;           /* I: Heap reference.                       */ 
};

/*****************************************************************************/

#define HEAPD_MONITOR_REM    33393

struct HeapdMonitorRem
{
   SIGSELECT     sig_no;         /* I: Signal number: 33393                  */
   OSHEAP        href;           /* I: Heap reference.                       */ 
};

/*****************************************************************************/

#define HEAPD_FRAG_REM       33394

struct HeapdFragmentRem
{
   SIGSELECT     sig_no;         /* I: Signal number: 33394                  */
   OSHEAP        href;           /* I: Heap reference.                       */
   char          phys_mem[MM_NAME_LENGTH+1]; /* I: Phys_mem of interest.     */
   OSADDRESS     base;           /* O: Base address of removed fragment.     */
   OSBUFSIZE     size;           /* O: Size of removed fragment (0 = failed) */
};

/*****************************************************************************/

#define HEAPD_FRAG_INQUIRY  33395

struct HeapdFragmentInquiry
{
   SIGSELECT     sig_no;         /* I: Signal number: 33395                  */
   OSHEAP        href;           /* I: Heap reference.                       */
   char          phys_mem[MM_NAME_LENGTH+1]; /* I: Phys_mem of interest.     */
   OSBUFSIZE     size;           /* O: Size of free fragments (0 = failed)   */
};

/*****************************************************************************/

#define HEAPD_INIT_HEAPCD   33392

struct HeapdInitHeapcd
{
   SIGSELECT     sig_no;         /* I: Signal number: 33392                  */
   struct OseHeap *heap;         /* I: Heap pointer.                         */
};

/*****************************************************************************/

#endif /* OSE_HEAPD_SIG */
