/* COPYRIGHT-ENEA-SRC-R2 *
 **************************************************************************
 * Copyright (C) 2004-2007 by Enea Software AB.
 * All rights reserved.
 *
 * This Software is furnished under a software license agreement and
 * may be used only in accordance with the terms of such agreement.
 * Any other use or reproduction is prohibited. No title to and
 * ownership of the Software is hereby transferred.
 *
 * PROPRIETARY NOTICE
 * This Software consists of confidential information.
 * Trade secret law and copyright law protect this Software.
 * The above notice of copyright on this Software does not indicate
 * any actual or intended publication of such Software.
 **************************************************************************
 * COPYRIGHT-END */

/*
 *===========================================================================
 *                        pm_configure_load_measurement_request
 *===========================================================================
 *
 * Description
 * -----------
 * Configures the per program load measurements performed by the PM.
 *
 * Requirement
 * -----------
 *
 *
 * Side effects
 * ------------
 * None.
 *
 * Parameter description
 * ---------------------
 * PmInternalState                  The PM internal state structure.
 * request                          The request of the operation.
 *
 * Returns
 * -------
 * None.
 *
 */

GLOBAL void
pm_configure_load_measurement_request(struct PmInternalState * PmInternalState,
                                  struct PmConfigureLoadMeasurement * request);


/*
 *===========================================================================
 *                        pm_get_load_measurement_request
 *===========================================================================
 *
 * Description
 * -----------
 * Generates the per program load measurements.
 *
 * Requirement
 * -----------
 *
 *
 * Side effects
 * ------------
 * None.
 *
 * Parameter description
 * ---------------------
 * PmInternalState                  The PM internal state structure.
 * request                          The request of the operation.
 *
 * Returns
 * -------
 * None.
 *
 */

GLOBAL void
pm_get_load_measurement_request(struct PmInternalState * PmInternalState,
                                union SIGNAL * request);


