/* COPYRIGHT-ENEA-SRC-R2 *
 **************************************************************************
 * Copyright (C) 2006 by Enea Software AB.
 * All rights reserved.
 *
 * This Software is furnished under a software license agreement and
 * may be used only in accordance with the terms of such agreement.
 * Any other use or reproduction is prohibited. No title to and
 * ownership of the Software is hereby transferred.
 *
 * PROPRIETARY NOTICE
 * This Software consists of confidential information.
 * Trade secret law and copyright law protect this Software.
 * The above notice of copyright on this Software does not indicate
 * any actual or intended publication of such Software.
 **************************************************************************
 * COPYRIGHT-END */

#ifndef _FMM_EFMI_H
#define _FMM_EFMI_H

#include "stdint.h"

#include "fmm.h"
#include "efmi.h"

#include "monitor.sig"
#include "monitor_execution.sig"
 
typedef EfmiStatus FmmEfmiInfoRequest(int32_t (*reply)(FmmSignal *sig), 
                                      int32_t (*endmark)(FmmSignal *sig, int32_t status),
                                      const MonitorGetInfoRequest *request);

/* 
 * Requests from monitor.sig 
 */
 
FmmEfmiInfoRequest fmm_efmi_get_process_info_request;

FmmEfmiInfoRequest fmm_efmi_get_block_info_request;

FmmEfmiInfoRequest fmm_efmi_get_segment_info_request;

FmmEfmiInfoRequest fmm_efmi_get_stack_usage_request;

FmmEfmiInfoRequest fmm_efmi_get_env_vars_request;

FmmEfmiInfoRequest fmm_efmi_get_signal_queue_request;

FmmEfmiInfoRequest fmm_efmi_get_pool_info_request;

FmmEfmiInfoRequest fmm_efmi_get_pool_signals_request;
                                              
/* 
 * Requests from monitor_execution.sig 
 */

EfmiStatus
fmm_efmi_get_register_info_request(int32_t (*reply)(FmmSignal *sig),
                                   int32_t (*endmark)(FmmSignal *sig, int32_t status),
                                   const MonitorGetRegisterInfoRequest *request);

#endif
