/* COPYRIGHT-ENEA-SRC-R2 *
 **************************************************************************
 * Copyright (C) 2006 by Enea Software AB.
 * All rights reserved.
 *
 * This Software is furnished under a software license agreement and
 * may be used only in accordance with the terms of such agreement.
 * Any other use or reproduction is prohibited. No title to and
 * ownership of the Software is hereby transferred.
 *
 * PROPRIETARY NOTICE
 * This Software consists of confidential information.
 * Trade secret law and copyright law protect this Software.
 * The above notice of copyright on this Software does not indicate
 * any actual or intended publication of such Software.
 **************************************************************************
 * COPYRIGHT-END */

#ifndef _FMM_PFMI_H
#define _FMM_PFMI_H

#include "stdint.h"

#include "fmm.h"
#include "pfmi.h"

#include "pm.sig"
#include "monitor.sig"

PfmiStatus fmm_pfmi_load_module_install_handles_request(
               int32_t (*reply)(FmmSignal *sig, int32_t status),
               const struct PmLoadModuleInstallHandlesRequest *request);

PfmiStatus fmm_pfmi_load_module_info_request(
               int32_t (*reply)(FmmSignal *sig, int32_t status),
               const struct PmLoadModuleInfoRequest *request);

PfmiStatus fmm_pfmi_load_module_section_info_request(
               int32_t (*reply)(FmmSignal *sig, int32_t status),
               const struct PmLoadModuleSectionInfoRequest *request);

PfmiStatus fmm_pfmi_programs_request(
                    int32_t (*reply)(FmmSignal *sig, int32_t status),
                    const struct PmProgramsRequest *request);
                    
PfmiStatus fmm_pfmi_program_info_request(
                    int32_t (*reply)(FmmSignal *sig, int32_t status),
                    const struct PmProgramInfo *request);
                                        
PfmiStatus fmm_pfmi_get_program_pid_request(
                    int32_t (*reply)(FmmSignal *sig, int32_t status),
                    const struct PmGetProgramPid *request);

PfmiStatus fmm_pfmi_program_info(
                    int32_t (*request)(FmmSignal *sig),
                    int32_t (*reply)(FmmSignal *sig, int32_t status));

PfmiStatus fmm_pfmi_load_module_info(
                    int32_t (*request)(FmmSignal *sig),
                    int32_t (*reply)(FmmSignal *sig, int32_t status));

PfmiStatus fmm_pfmi_load_module_section_info(
                    int32_t (*request)(FmmSignal *sig),
                    int32_t (*reply)(FmmSignal *sig, int32_t status));
                    
#endif
