/* COPYRIGHT-ENEA-SRC-R2 *
 **************************************************************************
 * Copyright (C) 2006 by Enea Software AB.
 * All rights reserved.
 *
 * This Software is furnished under a software license agreement and
 * may be used only in accordance with the terms of such agreement.
 * Any other use or reproduction is prohibited. No title to and
 * ownership of the Software is hereby transferred.
 *
 * PROPRIETARY NOTICE
 * This Software consists of confidential information.
 * Trade secret law and copyright law protect this Software.
 * The above notice of copyright on this Software does not indicate
 * any actual or intended publication of such Software.
 **************************************************************************
 * COPYRIGHT-END */

#include "stdint.h"

#include "fmm.h"

struct InputSignal
{
   uint32_t size;
   uint8_t data[FMM_INPUT_SIGNAL_SIZE];   
};

struct OutputSignal
{
   uint32_t size;
   uint8_t data[FMM_OUTPUT_SIGNAL_SIZE];
};

struct FmmSignal
{
   union
   {
      struct InputSignal in;
      struct OutputSignal out;
   } io; 
};

union Stack
{
   uint64_t align;
   uint8_t data[FMM_STACK_SIZE];
};

static union Stack stack;

uint32_t *fmm_stack = (uint32_t *)&stack;

static struct InputSignal input_signal;
static struct OutputSignal output_signal;

FmmSignal *fmm_input_signal = (FmmSignal *)&input_signal;
FmmSignal *fmm_output_signal = (FmmSignal *)&output_signal;
