/* COPYRIGHT-ENEA-SRC-R2 *
 **************************************************************************
 * Copyright (C) 2004-2006 by Enea Software AB.
 * All rights reserved.
 *
 * This Software is furnished under a software license agreement and
 * may be used only in accordance with the terms of such agreement.
 * Any other use or reproduction is prohibited. No title to and
 * ownership of the Software is hereby transferred.
 *
 * PROPRIETARY NOTICE
 * This Software consists of confidential information.
 * Trade secret law and copyright law protect this Software.
 * The above notice of copyright on this Software does not indicate
 * any actual or intended publication of such Software.
 **************************************************************************
 * COPYRIGHT-END */

#ifndef _CODEC_H
#define _CODEC_H

/* C runtime include files. */
#include <stddef.h>

/* OSE public include files. */

/* OSE internal include files. */

/* MM internal include files. */
#include "partition.h"
#include "domain.h"



/*
 * Encode the contents of a region descriptor.
 * Pre-condition  : <region> is a valid region descriptor.
 * Post-condition : OK   -> allocated buffer with character encoded data.
 *                  FAIL -> NULL.
 * The returned buffer should be freed with free_buf().
 */
char *
mm_encode_metadata(struct region *region);



/*
 * Create a region from a buffer with character encoded meta-data.
 * Pre-condition  : <buf> holds character encoded metadata for a region
 *
 * Post-condition : OK   -> allocated region descriptor.
 *                  FAIL -> NULL.
 *
 * If NULL is returned, the restore sequence should be aborted.
 */
struct region *
mm_decode_metadata(U8 *buf, log_addr_t base);

#endif /* _CODEC_H */
