/* COPYRIGHT-ENEA-SRC-R2 *
 **************************************************************************
 * Copyright (C) 2004-2006 by Enea Software AB.
 * All rights reserved.
 *
 * This Software is furnished under a software license agreement and
 * may be used only in accordance with the terms of such agreement.
 * Any other use or reproduction is prohibited. No title to and
 * ownership of the Software is hereby transferred.
 *
 * PROPRIETARY NOTICE
 * This Software consists of confidential information.
 * Trade secret law and copyright law protect this Software.
 * The above notice of copyright on this Software does not indicate
 * any actual or intended publication of such Software.
 **************************************************************************
 * COPYRIGHT-END */

#ifndef _CONFIGURE_H
#define _CONFIGURE_H

/* MM internal include files. */
#include "gmm.h"
#include "hal.h"
#include "partition.h"


#define BASE_ATTRIBUTE_KEY          "base"
#define SIZE_ATTRIBUTE_KEY          "size"


/*
 * Perform most of the initialization of GMM.
 */
void
mm_config_init(void);

/*
 * Read the log level configuration and set log level accordingly.
 */
void
mm_configure_log_level(void);

/*
 * Read cache configuration from system parameters. Result is placed
 * in global GMM structure.
 */
void
mm_configure_cache_mode(void);

/*
 * Alloc <size> bytes from boot area. Only used during boot.
 */
int
mm_alloc_boot_space(size_t size,
                    log_addr_t *out_base);

#endif /* _CONFIGURE_H */
