/* COPYRIGHT-ENEA-SRC-R2 *
 **************************************************************************
 * Copyright (C) 2004-2007 by Enea Software AB.
 * All rights reserved.
 *
 * This Software is furnished under a software license agreement and
 * may be used only in accordance with the terms of such agreement.
 * Any other use or reproduction is prohibited. No title to and
 * ownership of the Software is hereby transferred.
 *
 * PROPRIETARY NOTICE
 * This Software consists of confidential information.
 * Trade secret law and copyright law protect this Software.
 * The above notice of copyright on this Software does not indicate
 * any actual or intended publication of such Software.
 **************************************************************************
 * COPYRIGHT-END */


/* C runtime include files. */

#include "stdio.h"

/* MM internal include files. */
#include "gmm.h"
#include "zone.h"
#include "mm_cmd.h"

/*
 * See zone.h
 */

extern OSE_SLIST_HEAD_TYPE all_zones;

void
mm_zone_cmd(void)
{
   struct zone *z;

   printf("Zone allocator:\n");
   printf(" number of pages allocated for zones:%d\n", mm_zone_get_page_cnt());
   printf("\n name            #free items   #total items   entry size\n");
   printf(" -------------------------------------------------------\n");
   OSE_SLIST_FOREACH(&all_zones, z)
   {
      printf(" %-16.16s%11.1d%15.1d%13.1d\n",
             z->zname, z->zfreecnt, z->ztotal, z->zsize);
   }
   printf("\n");
}

#ifdef OSPP
void
mm_time_cmd(void)
{
   printf("GMM startup time:\n");
   printf(" open_exception_area: %lld (%lld - %lld)\n",
          gmm_stats.open_exception_area.end -
          gmm_stats.open_exception_area.start,
          gmm_stats.open_exception_area.end,
          gmm_stats.open_exception_area.start);
   printf(" install_exception_handlers: %lld (%lld - %lld)\n",
          gmm_stats.install_exception_handlers.end -
          gmm_stats.install_exception_handlers.start,
          gmm_stats.install_exception_handlers.end,
          gmm_stats.install_exception_handlers.start);
   if (gmm_stats.connect_pmm.start != gmm_stats.connect_pmm.end)
   {
      printf(" connect_pmm: %lld (%lld - %lld)\n",
             gmm_stats.connect_pmm.end -
             gmm_stats.connect_pmm.start,
             gmm_stats.connect_pmm.end,
             gmm_stats.connect_pmm.start);
   }
   else
   {
      printf(" connect_pmm: no PMM_ASSIGN-signal received by GMM.\n");
   }
   printf("\n");
}
#endif

