/* COPYRIGHT-ENEA-SRC-R2 *
 **************************************************************************
 * Copyright (C) 2004-2007 by Enea Software AB.
 * All rights reserved.
 *
 * This Software is furnished under a software license agreement and
 * may be used only in accordance with the terms of such agreement.
 * Any other use or reproduction is prohibited. No title to and
 * ownership of the Software is hereby transferred.
 *
 * PROPRIETARY NOTICE
 * This Software consists of confidential information.
 * Trade secret law and copyright law protect this Software.
 * The above notice of copyright on this Software does not indicate
 * any actual or intended publication of such Software.
 **************************************************************************
 * COPYRIGHT-END */
#ifndef MM_PROFILE_H_
#define MM_PROFILE_H_

#include "osetypes.h"
#include "ose.h"
#include "gmm.h"
#include "ramlog.h"

/* Default Off. */
#if 0
#define MM_PROFILE
#endif

#ifdef MM_PROFILE
#define MM_PROFILE_CHECKPOINT(str1, str2, val)                     \
                               mm_profile_checkpoint(str1, str2, val)

#define MM_PROFILE_START(func_name, reg_name, reg_size, prof_size) \
                                mm_profile_start(func_name,        \
                                                 reg_name,         \
                                                 reg_size,         \
                                                 prof_size)

#define MM_PROFILE_STOP(status, base)                              \
                        mm_profile_stop(status, base)


#else
#define MM_PROFILE_CHECKPOINT(str1, str2, val)
#define MM_PROFILE_START(func_name, reg_name, reg_size, prof_size)
#define MM_PROFILE_STOP(status, base)                              
#endif

#define PROFILE_SIZE 0x3200000
#define XSTR(s)  STR(s)
#define STR(s)  #s

void
mm_profile_checkpoint(const char *str1, const char *str2, const U32 value);


void
mm_profile_start(const char *func_name,
                 const char *reg_name,
                 const U32 reg_size,
                 const char *profile_size);

void
mm_profile_stop(mm_status_t status, log_addr_t base);



#endif /* MM_PROFILE_H_ */
