/* COPYRIGHT-ENEA-SRC-R2 *
 **************************************************************************
 * Copyright (C) 2004-2006 by Enea Software AB.
 * All rights reserved.
 *
 * This Software is furnished under a software license agreement and
 * may be used only in accordance with the terms of such agreement.
 * Any other use or reproduction is prohibited. No title to and
 * ownership of the Software is hereby transferred.
 *
 * PROPRIETARY NOTICE
 * This Software consists of confidential information.
 * Trade secret law and copyright law protect this Software.
 * The above notice of copyright on this Software does not indicate
 * any actual or intended publication of such Software.
 **************************************************************************
 * COPYRIGHT-END */

#ifndef RAM_ALLOC_H_
#define RAM_ALLOC_H_

/* C runtime include files. */
#include "stddef.h"

/* OSE public include files. */
#include "osetypes.h"

/* OSE internal include files. */

/* MM internal include files. */
#include "allocator.h"
#include "common.h"

/*
 * Inform the ram allocator about the range that the boot heap used.
 */
void
set_boot_heap_range(log_addr_t base, log_size_t size);

struct allocator *
mm_create_ram_allocator(const char *name);

/* Tells the ram allocator that the physical memory for the static regions has
 * been allocated. This implies that m_page_alloc can search the entire sase
 * bank list. */
void report_static_phys_mem_reserved(void);

#endif /* RAM_ALLOC_H_ */
