/* COPYRIGHT-ENEA-SRC-R2 *
 **************************************************************************
 * Copyright (C) 2005-2006 by Enea Software AB.
 * All rights reserved.
 *
 * This Software is furnished under a software license agreement and
 * may be used only in accordance with the terms of such agreement.
 * Any other use or reproduction is prohibited. No title to and
 * ownership of the Software is hereby transferred.
 *
 * PROPRIETARY NOTICE
 * This Software consists of confidential information.
 * Trade secret law and copyright law protect this Software.
 * The above notice of copyright on this Software does not indicate
 * any actual or intended publication of such Software.
 **************************************************************************
 * COPYRIGHT-END */

#ifndef MM_CMD_H
#define MM_CMD_H

#include "mmtypes.h"

void
mm_zone_cmd(void);

#ifdef OSPP
void
mm_time_cmd(void);
#endif

#ifdef OSPP
void
mm_time_cmd(void);
#endif

void
mm_hal_info_cmd(void);

/* Returns TRUE if compiled with assert.
 * Providea a way to in runtime
 * check wether mm is compiled with assert or not.
 * Performace measurment should only be performed without assert.
 * (Not foolproof but good enough, generally core lib is build with
 * assert for all files or for none.)
 *
 */
mm_bool_t
mm_compiled_with_assert(void);


/* Returns TRUE if compiled with gcc optimizing flags.
 * Providea a way to in runtime
 * check wether mm is compiled with optimizing.
 * Performace measurment should only be performed with optimizing.
 * (Not foolproof but good enough, generally core lib is build with
 * optimizing for all files or for none.)
 *
 */
mm_bool_t
mm_compiled_with_optimize_gcc(void);

#endif

