/* COPYRIGHT-ENEA-SRC-R2 *
 **************************************************************************
 * Copyright (C) 2004-2006 by Enea Software AB.
 * All rights reserved.
 *
 * This Software is furnished under a software license agreement and
 * may be used only in accordance with the terms of such agreement.
 * Any other use or reproduction is prohibited. No title to and
 * ownership of the Software is hereby transferred.
 *
 * PROPRIETARY NOTICE
 * This Software consists of confidential information.
 * Trade secret law and copyright law protect this Software.
 * The above notice of copyright on this Software does not indicate
 * any actual or intended publication of such Software.
 **************************************************************************
 * COPYRIGHT-END */
#ifndef MM_LOG_H
#define MM_LOG_H

#include "ramlog.h"

/*
 * replace call to ramlog_printf with krintf which requires less stack
 */
#ifdef OSKERNEL
size_t kprintf(const char *fmt, ...);
#define ramlog_printf kprintf
#endif

/*
***************************************************************************
** IF YOU CHANGE ANY OF THESE NAMES OR VALUES YOU MUST ALSO CHANGE THE
** FUNCTION mm_get_log_mask_name() IN FILE mm_interface.c
*/
#define CATEGORY_START             0x00000001
#define CATEGORY_HAL               0x00000002
#define CATEGORY_MALLOC            0x00000004
#define CATEGORY_PAGE              0x00000008
#define CATEGORY_SIGNAL            0x00000010
#define CATEGORY_MISC              0x00000020
                                   
#define CATEGORY_MAS               0x00000080
#define CATEGORY_PARTITION         0x00000100
#define CATEGORY_DOMAIN            0x00000200
#define CATEGORY_HAL_DETAIL        0x00000400
#define CATEGORY_MM_ACCESS         0x00000800
#define CATEGORY_START_DETAIL      0x00001000
#define CATEGORY_MM_TRAP           0x00002000
#define CATEGORY_HAL_GLOBAL        0x00004000
#define CATEGORY_MMU_STAT          0x00008000
#define CATEGORY_FAILED_REQUEST    0x00010000
#define CATEGORY_ALL               0xffffffff
/*
** MAKE SURE YOU HAVE READ THE IMPORTANT NOTICE ABOVE!
***************************************************************************
*/

U32
mm_get_log_mask(void);

U32
mm_set_log_mask(U32 mask);

const char *
mm_get_log_mask_name(U32 bit);

/* Log macro */
#if defined(MM_VERBOSE_MODE)
#define log(category,s)                      \
   do {                                      \
      if (mm_get_log_mask() & category)      \
        ramlog_printf s;                     \
   } while(0)
#else
#define log(category,s)
#endif

#endif /* MM_LOG_H */
