/* COPYRIGHT-ENEA-SRC-R2 *
 **************************************************************************
 * Copyright (C) 2004-2006 by Enea Software AB.
 * All rights reserved.
 *
 * This Software is furnished under a software license agreement and
 * may be used only in accordance with the terms of such agreement.
 * Any other use or reproduction is prohibited. No title to and
 * ownership of the Software is hereby transferred.
 *
 * PROPRIETARY NOTICE
 * This Software consists of confidential information.
 * Trade secret law and copyright law protect this Software.
 * The above notice of copyright on this Software does not indicate
 * any actual or intended publication of such Software.
 **************************************************************************
 * COPYRIGHT-END */

#ifndef OSE_MM_TRAP_INTERNAL_H_
#define OSE_MM_TRAP_INTERNAL_H_

/*
** Validates access to a buffer without accessing it.
** See mm.h for more information.
**
** This function has been superseeded by its equivalent in mman.
** ose_mm_validate_buffer now traps to mman_validate_buffer which uses
** this function in part. mm_validate_buffer is however still exported
** through bios for backwards compatibility. 
*/

size_t
mm_validate_buffer(log_addr_t bbase,	          /* buffer base */
		   size_t bsize,	          /* buffer size */
		   PROCESS pid,		          /* validation context */
		   unsigned int bperm,  	  /* buffer permissions */
		   unsigned int options,	  /* validation options */
		   unsigned int *result);	  /* option results */

size_t
mm_validate_buffer_by_domain(log_addr_t bbase,	      /* buffer base */
                             size_t bsize,	      /* buffer size */
                             OSDOMAIN domain,         /* validation domain */
                             unsigned int bperm,      /* buffer permissions */
                             unsigned int options,    /* validation options */
                             unsigned int *result,    /* option results */
                             OSADDRESS supervisor_mode, /* supervisior mode*/
                             U32 hal_options);

/*
** Lookup the physical address for a logical pointer.
** See mm.h for more information.
*/
mm_status_t mm_l2p_by_domain(OSDOMAIN    domain,
                             log_addr_t  la,
                             phys_addr_t *pa);

#endif /* OSE_MM_TRAP_INTERNAL_H_ */
