/* COPYRIGHT-ENEA-SRC-R2 *
 **************************************************************************
 * Copyright (C) 2004-2006 by Enea Software AB.
 * All rights reserved.
 *
 * This Software is furnished under a software license agreement and
 * may be used only in accordance with the terms of such agreement.
 * Any other use or reproduction is prohibited. No title to and
 * ownership of the Software is hereby transferred.
 *
 * PROPRIETARY NOTICE
 * This Software consists of confidential information.
 * Trade secret law and copyright law protect this Software.
 * The above notice of copyright on this Software does not indicate
 * any actual or intended publication of such Software.
 **************************************************************************
 * COPYRIGHT-END */

#ifndef MM_INTERNAL_UTIL_H_
#define MM_INTERNAL_UTIL_H_

#include "mm_util.h"

/*
 *===========================================================================
 *                        call_region_deleted_event
 *===========================================================================
 *
 * Description
 * -----------
 * Calls all the registered region deleted events.
 *
 * Parameters
 * ----------
 * domain             The domain that got deleted.
 * base               The start address of the deleted region.
 *
 */
void
call_region_deleted_event(OSDOMAIN domain, log_addr_t base);

/*
 *===========================================================================
 *                        call_reclaim_region_event
 *===========================================================================
 *
 * Description
 * -----------
 * Calls all the registered reclaim region events and stops as soon as
 * it has found one that can be deleted.
 *
 */
void
call_reclaim_region_event(struct mm_reclaim_physical_event_t *reclaim);

/*
 *===========================================================================
 *                        mm_util_init
 *===========================================================================
 *
 * Description
 * -----------
 * Initializes the MM util functions.
 *
 */
void
mm_util_init(void);

#endif  /* MM_INTERNAL_UTIL_H_ */
