/* COPYRIGHT-ENEA-SRC-R2 *
 **************************************************************************
 * Copyright (C) 2004-2006 by Enea Software AB.
 * All rights reserved.
 *
 * This Software is furnished under a software license agreement and
 * may be used only in accordance with the terms of such agreement.
 * Any other use or reproduction is prohibited. No title to and
 * ownership of the Software is hereby transferred.
 *
 * PROPRIETARY NOTICE
 * This Software consists of confidential information.
 * Trade secret law and copyright law protect this Software.
 * The above notice of copyright on this Software does not indicate
 * any actual or intended publication of such Software.
 **************************************************************************
 * COPYRIGHT-END */

#ifndef PAGE_H
#define PAGE_H



#include "osetypes.h"
#include "mmtypes.h"


/*
 * Try to allocate a page of size <size>.  Return FALSE on failure,
 * otherwise return TRUE and update <base>.
 * The page is allocated with natural aligned with requested size.
 */
mm_bool_t
mm_page_alloc(size_t size, log_addr_t *base);

/*
 * Free a page.
 */
void
mm_page_free(log_addr_t base, size_t size);

#endif /* PAGE_H */
