/* COPYRIGHT-ENEA-SRC-R2 *
 **************************************************************************
 * Copyright (C) 2012 by Enea Software AB.
 * All rights reserved.
 *
 * This Software is furnished under a software license agreement and
 * may be used only in accordance with the terms of such agreement.
 * Any other use or reproduction is prohibited. No title to and
 * ownership of the Software is hereby transferred.
 *
 * PROPRIETARY NOTICE
 * This Software consists of confidential information.
 * Trade secret law and copyright law protect this Software.
 * The above notice of copyright on this Software does not indicate
 * any actual or intended publication of such Software.
 **************************************************************************
 * COPYRIGHT-END */

/**
 *  @File counter_prof.h
 *  @brief This is the structures and internal interface of the
 *  source profiling.
 *
 */

#ifndef COUNTER_PROF_H_
#define COUNTER_PROF_H_


/*
 * Struct:
 *      MapEntry
 *
 * Description:
 *      Stores a map of rmm clients and counter types..
 */
#define MAP_SIZE 64

typedef struct {
    Offspring *offspring;
    uint32_t type;
    MonitorBoolean enabled;
    uint32_t loss;
    cpuid_t cpu;
} MapEntry;

 /* Struct:
 *      rmm_counter_state
 *
 * Description:
 *      Holds state of debugger.
 */
struct rmm_counter_state {
   PROCESS rmm_pid;
   uint32_t max_reports;
   MapEntry *map[MAP_SIZE];
};


/* "external" functions i.e. called from rmm.c which share object file */

static int handle_set_counter_reports_notify_enabled_request(Offspring *offspring, union SIGNAL *sig);
static int handle_get_counter_type_enabled_request(Offspring *offspring, union SIGNAL *sig);
static int handle_set_counter_type_enabled_request(Offspring *offspring, union SIGNAL *sig);
static int handle_get_counter_reports_notify_enabled_request(Offspring *offspring, union SIGNAL *sig);
static int handle_set_counter_reports_notify_enabled_request(Offspring *offspring, union SIGNAL *sig);

static void handle_buffer_full_notify(struct BufferFullNotify *notify);


static void handle_disconnect_request_counter(Offspring *offspring,union SIGNAL *sig);
static void rmm_counter_prof_init(void);


#endif /* RT_COUNTER_PROF_H_ */
