/* COPYRIGHT-ENEA-SRC-R2 *
 **************************************************************************
 * Copyright (C) 2009 by Enea Software AB.
 * All rights reserved.
 *
 * This Software is furnished under a software license agreement and
 * may be used only in accordance with the terms of such agreement.
 * Any other use or reproduction is prohibited. No title to and
 * ownership of the Software is hereby transferred.
 *
 * PROPRIETARY NOTICE
 * This Software consists of confidential information.
 * Trade secret law and copyright law protect this Software.
 * The above notice of copyright on this Software does not indicate
 * any actual or intended publication of such Software.
 **************************************************************************
 * COPYRIGHT-END */

/*
 * prof_timestamp.h
 *
 *  Created on: Mar 23, 2009
 *      Author: anhe
 */

#ifndef PROF_TIMESTAMP_H_
#define PROF_TIMESTAMP_H_

#include "ose.h"
#include "osetypes.h"
#include "stdint.h"

#ifdef OSPP
#define HAS_TB_TIMER
#define prof_timebase_t unsigned long long
#endif

#ifdef OSMIPS
#define HAS_TB_TIMER
#define READ_CPO_AS_TIMEBASE
#define prof_timebase_t  uint32_t
#endif


struct prof_timestamp
{
#ifdef HAS_TB_TIMER
   prof_timebase_t tb_time;
#else
   OSTICK          ticks;  /* Start of sample interval, ticks. */
   OSTICK          uticks; /* Start of sample interval, microseconds. */
#endif
};

/* functions for the datatype */
void prof_timestamp_set(struct prof_timestamp *timestamp);
uint32_t prof_timestamp_get_diff(struct prof_timestamp b, struct prof_timestamp e);
void prof_timestamp_set_interval_start_ticks(OSTICK *ticks, OSTICK *uticks, struct prof_timestamp timestamp);

void prof_timestamp_reset(struct prof_timestamp *b);

void prof_timestamp_print(char *s, struct prof_timestamp t);

#endif /* PROF_TIMESTAMP_H_ */
