/* COPYRIGHT-ENEA-SRC-R2 *
 **************************************************************************
 * Copyright (C) 2010-2011 by Enea Software AB.
 * All rights reserved.
 *
 * This Software is furnished under a software license agreement and
 * may be used only in accordance with the terms of such agreement.
 * Any other use or reproduction is prohibited. No title to and
 * ownership of the Software is hereby transferred.
 *
 * PROPRIETARY NOTICE
 * This Software consists of confidential information.
 * Trade secret law and copyright law protect this Software.
 * The above notice of copyright on this Software does not indicate
 * any actual or intended publication of such Software.
 **************************************************************************
 * COPYRIGHT-END */


/* Boolean */
/* zzrmm_check_pid_bid_collision(PROCESS pid0, PROCESS bid0); */

/* Boolean */
/* check_bid_sid_collision(PROCESS bid, PROCESS sid); */

/* Boolean */
/* check_pid_sid_collision(PROCESS pid, PROCESS sid); */

/* OSBOOLEAN */
/* process_in_scope(PROCESS pid, MonitorScope * scope); */

#ifndef RMM_UTILITY_H_
#define RMM_UTILITY_H_

#include "osetypes.h"
#include "ose.h"
#include "monitor.sig"
#include "ramlog.h"

/*
 * replace call to ramlog_printf with krintf which requires less stack
 */
#ifdef OSKERNEL
size_t kprintf(const char *fmt, ...);
#define ramlog_printf kprintf
#endif

OSBOOLEAN
zzrmm_process_in_scope(PROCESS pid, MonitorScope * scope);

Boolean
zzrmm_check_scope_collision(MonitorScope * existing_scope, MonitorScope * new_scope);


/**
 * @function get_scope_intersection
 * @brief Calculate the intersection between two scopes.
 */
MonitorScope
zzrmm_get_scope_intersection(MonitorScope * scope_1, MonitorScope * scope_2);

uint32_t
get_last_memory_error(void);

#endif /* RMM_UTILITY_H_ */
