/* COPYRIGHT-ENEA-SRC-R2 *
 **************************************************************************
 * Copyright (C) 2004-2006 by Enea Software AB.
 * All rights reserved.
 *
 * This Software is furnished under a software license agreement and
 * may be used only in accordance with the terms of such agreement.
 * Any other use or reproduction is prohibited. No title to and
 * ownership of the Software is hereby transferred.
 *
 * PROPRIETARY NOTICE
 * This Software consists of confidential information.
 * Trade secret law and copyright law protect this Software.
 * The above notice of copyright on this Software does not indicate
 * any actual or intended publication of such Software.
 **************************************************************************
 * COPYRIGHT-END */
/*
     This module was generated automatically from /vobs/ose5/core_ext/dbgserver/private/dbgserverinterface.stl.
                DO NOT EDIT THIS FILE
*/



#ifndef __dbgserverinterface_sig
#define __dbgserverinterface_sig

#ifndef _GLOBAL
#define _GLOBAL
#endif


#include <convert.h>


/*
 * OSE dbgserver interface features.
 */
typedef enum {
    OSE_FEATURE_END = 0,
    OSE_FEATURE_BASIC_EVACT = 1,  /*  The evact system is supported. */
    OSE_FEATURE_BASIC_MEMORY_PROF_FEATURE = 2,  /*  Memory profiler is supported. */
    OSE_FEATURE_BASIC_CPU_PROF = 3,  /*  CPU profiler is supported. */
    OSE_FEATURE_BASIC_PRH = 4,  /*  List programs are supported. */
    OSE_FEATURE_SIGNAL_SENDING = 5,  /*  Signal sendings are supported. */
    OSE_FEATURE_CHILD_SPAWN = 6,  /*  The dbgserver can spawn itself. */
    OSE_FEATURE_READ_MEMORY = 7,  /*  Can read memory. */
    OSE_FEATURE_FULL_SIG_QUEUE = 8,  /*  List verbose signal queues. */
    OSE_FEATURE_BASIC_SLD = 9,  /*  == LIMITED_SLD + SLD_APPL_SCOPE + SLD_CATCH_SCOPE + SLD_TRIGG_SCOPE + SLD_PROC_STEP + SLD_FULL_SCOPE_SYNTAX */
    OSE_FEATURE_WRITE_MEMORY = 10,  /*  Can write memory. */
    OSE_FEATURE_BASIC_IOPC = 11,  /*  IOPC is supported. */
    OSE_FEATURE_EVACT_SCOPES = 12,  /*  Evact scopes are supported. */
    OSE_FEATURE_DBG_SET_BP = 13,  /*  The new more advanced set bp */
    OSE_FEATURE_NO_EVACT_CREATE_KILL = 14,  /*  NEGATIVE no create/kill evacts. */
    OSE_FEATURE_EVACT_CREATE_KILL = 15,  /*  create / kill evacts */
    OSE_FEATURE_NO_EVACT_STATES = 16,  /*  NEGATIVE evact states. */
    OSE_FEATURE_EVACT_STATES = 17,  /*  evact states. */
    OSE_FEATURE_DEBUG_CONSOLE = 18,  /*  The debug console is supported. */
    OSE_FEATURE_LIMITED_SLD = 19,  /*  Fundamental source level debug (includes SLD_READ_REGISTERS). */
    OSE_FEATURE_SLD_APPL_SCOPE = 20,  /*  Source code application scope. */
    OSE_FEATURE_SLD_CATCH_SCOPE = 21,  /*  SLD breakpoints supports catch scopes. */
    OSE_FEATURE_SLD_TRIGG_SCOPE = 22,  /*  SLD breakpoints supports trigg scopes. */
    OSE_FEATURE_SLD_SINGLE_STEP = 23,  /*  SLD single step (if SLD_CATCH_SCOPE then this is process aware). */
    OSE_FEATURE_SLD_FULL_SCOPE_SYNTAX = 24,  /*  The scopes that are used supports both wild card strings and list of ids. */
    OSE_FEATURE_LDM_VARS = 25,  /*  LDM mode variables can be read and set */
    OSE_FEATURE_CURRENT_PROCESS = 26,  /*  The DBGGetCurrentProcess signal is supported */
    OSE_FEATURE_SLD_READ_REGISTERS = 27  /*  Support reading of registers. */
} OSE_FEATURE;



/*
 *===========================================================================
 * DBGGETTARGETSERVERINFO
 *===========================================================================
 *
 * Description:
 * OSE dbgserver interface features.
  *
 * Parameters:
 */
#define DBGGETTARGETSERVERINFO 32900   /* !-SIGNO(struct DBGGetTargetServerInfo)-! */
struct DBGGetTargetServerInfo {
   U32 sigNo;
   U32 size;
};
#ifdef IS_DBGSERVER_CLIENT
_GLOBAL void create_DBGGetTargetServerInfo(union SIGNAL **_sig);
#endif


#ifdef LITTLE_ENDIAN
void convert_DBGGetTargetServerInfo(struct DBGGetTargetServerInfo *_sig);
#else
#define convert_DBGGetTargetServerInfo(_sig)
#endif





/*
 *===========================================================================
 * DBGTARGETSERVERINFO
 *===========================================================================
 *
 * Description:
 * OSE dbgserver interface features.
  *
 * Parameters:
 *   serverPort:    The port number for the TCP server socket
 *   name:    Target name from SystemServer or created from softkernelName@host:pid
 */
#define DBGTARGETSERVERINFO 32901   /* !-SIGNO(struct DBGTargetServerInfo)-! */
struct DBGTargetServerInfo {
   U32 sigNo;
   U32 size;
   U16 serverPort ;
};
_GLOBAL void create_DBGTargetServerInfo(const U16 _serverPort, const char *_name, union SIGNAL **_sig);


#ifdef LITTLE_ENDIAN
void convert_DBGTargetServerInfo(struct DBGTargetServerInfo *_sig);
#else
#define convert_DBGTargetServerInfo(_sig)
#endif


#define DBGTargetServerInfo_get_name_size(XXsig, XXretVal) do {\
   U8 *XXptr = (U8*)XXsig + ALIGN_SIZE(10);\
   XXretVal = *(U32*)XXptr;\
}while(0)
#define DBGTargetServerInfo_get_name(XXsig, XXretVal) do {\
   U8 *XXptr = (U8*)XXsig + ALIGN_SIZE(10);\
   XXretVal = (char*)(XXptr+4);\
}while(0)



/*
 *===========================================================================
 * DBGINITCONNECTION
 *===========================================================================
 *
 * Description:
  *
 * Parameters:
 *   majorInterfaceVersion:    Version of the interface. The major version
 *   minorInterfaceVersion:    must be equal to the debug servers major
                               * number for a connection and the minor number 
 *   slidingWindowSize:    Take a guess.
 *   connectionBrokenTimeout:   
 *   userHostIdName:    userName@hostName:id. Id is the time the client started.
 */
#define DBGINITCONNECTION 32902   /* !-SIGNO(struct DBGInitConnection)-! */
struct DBGInitConnection {
   U32 sigNo;
   U32 size;
   U32 majorInterfaceVersion ;
   U32 minorInterfaceVersion ;
   S32 slidingWindowSize ;
   U32 connectionBrokenTimeout ;
};
#ifdef IS_DBGSERVER_CLIENT
_GLOBAL void create_DBGInitConnection(const U32 _majorInterfaceVersion, const U32 _minorInterfaceVersion, const S32 _slidingWindowSize, const U32 _connectionBrokenTimeout, const char *_userHostIdName, union SIGNAL **_sig);
#endif


#ifdef LITTLE_ENDIAN
void convert_DBGInitConnection(struct DBGInitConnection *_sig);
#else
#define convert_DBGInitConnection(_sig)
#endif


#define DBGInitConnection_get_userHostIdName_size(XXsig, XXretVal) do {\
   U8 *XXptr = (U8*)XXsig + ALIGN_SIZE(24);\
   XXretVal = *(U32*)XXptr;\
}while(0)
#define DBGInitConnection_get_userHostIdName(XXsig, XXretVal) do {\
   U8 *XXptr = (U8*)XXsig + ALIGN_SIZE(24);\
   XXretVal = (char*)(XXptr+4);\
}while(0)



/*
 *===========================================================================
 * DBGINITCONNECTIONREPLY
 *===========================================================================
 *
 * Description:
  *
 * Parameters:
 *   connectionAccepted:    true or false
 *   majorInterfaceVersion:    Version of the interface. The major version
 *   minorInterfaceVersion:    must be equal to the debug servers major
                               * number for a connection and the minor number 
 *   tickLength:    Number of micro seconds of one tick.
 *   traceBufSize:   
 *   evactMemorySize:   
 */
#define DBGINITCONNECTIONREPLY 32903   /* !-SIGNO(struct DBGInitConnectionReply)-! */
struct DBGInitConnectionReply {
   U32 sigNo;
   U32 size;
   U32 connectionAccepted ;
   U32 majorInterfaceVersion ;
   U32 minorInterfaceVersion ;
   U32 tickLength ;
   U32 traceBufSize ;
   U32 evactMemorySize ;
};
_GLOBAL void create_DBGInitConnectionReply(const U32 _connectionAccepted, const U32 _majorInterfaceVersion, const U32 _minorInterfaceVersion, const U32 _tickLength, const U32 _traceBufSize, const U32 _evactMemorySize, union SIGNAL **_sig);


#ifdef LITTLE_ENDIAN
void convert_DBGInitConnectionReply(struct DBGInitConnectionReply *_sig);
#else
#define convert_DBGInitConnectionReply(_sig)
#endif





/*
 *===========================================================================
 * DBGPING
 *===========================================================================
 *
 * Description:
  *
 * Parameters:
 */
#define DBGPING 32904   /* !-SIGNO(struct DBGPing)-! */
struct DBGPing {
   U32 sigNo;
   U32 size;
};
#ifdef IS_DBGSERVER_CLIENT
_GLOBAL void create_DBGPing(union SIGNAL **_sig);
#endif


#ifdef LITTLE_ENDIAN
void convert_DBGPing(struct DBGPing *_sig);
#else
#define convert_DBGPing(_sig)
#endif





/*
 *===========================================================================
 * DBGPINGREPLY
 *===========================================================================
 *
 * Description:
  *
 * Parameters:
 */
#define DBGPINGREPLY 32905   /* !-SIGNO(struct DBGPingReply)-! */
struct DBGPingReply {
   U32 sigNo;
   U32 size;
};
_GLOBAL void create_DBGPingReply(union SIGNAL **_sig);


#ifdef LITTLE_ENDIAN
void convert_DBGPingReply(struct DBGPingReply *_sig);
#else
#define convert_DBGPingReply(_sig)
#endif





/*
 *===========================================================================
 * DBGDISCONNECT
 *===========================================================================
 *
 * Description:
 * Sent to disconnect the client from the debug server. Typicaly
 * used when a project is closed or the debuger exits.
 *
  *
 * Parameters:
 */
#define DBGDISCONNECT 32906   /* !-SIGNO(struct DBGDisconnect)-! */
struct DBGDisconnect {
   U32 sigNo;
   U32 size;
};
#ifdef IS_DBGSERVER_CLIENT
_GLOBAL void create_DBGDisconnect(union SIGNAL **_sig);
#endif


#ifdef LITTLE_ENDIAN
void convert_DBGDisconnect(struct DBGDisconnect *_sig);
#else
#define convert_DBGDisconnect(_sig)
#endif





/*
 *===========================================================================
 * DBGFLOWCONTROL
 *===========================================================================
 *
 * Description:
 * Sent from the debug client to the server to increase the
 * current flow control value.
 *
 * Reply signal: DBGFLOW_CONTROL_REPLY
 *
  *
 * Parameters:
 *   increment:   
 */
#define DBGFLOWCONTROL 32907   /* !-SIGNO(struct DBGFlowControl)-! */
struct DBGFlowControl {
   U32 sigNo;
   U32 size;
   U32 increment ;
};
#ifdef IS_DBGSERVER_CLIENT
_GLOBAL void create_DBGFlowControl(const U32 _increment, union SIGNAL **_sig);
#endif


#ifdef LITTLE_ENDIAN
void convert_DBGFlowControl(struct DBGFlowControl *_sig);
#else
#define convert_DBGFlowControl(_sig)
#endif





/*
 *===========================================================================
 * DBGFLOWCONTROLREPLY
 *===========================================================================
 *
 * Description:
 * Sent as a reply to DBGFlowControl.
 * NOTE: may also be sent asyncronius in some cases.
  *
 * Parameters:
 *   lossCount:    This is the number of lost monitor signals (may be more than indicated).
 *   async:    0 if reply to DBGFlowControl and 1 if asyncron and part of monitor flow ctrl.
 */
#define DBGFLOWCONTROLREPLY 32908   /* !-SIGNO(struct DBGFlowControlReply)-! */
struct DBGFlowControlReply {
   U32 sigNo;
   U32 size;
   U32 lossCount ;
   U8 async ;
};
_GLOBAL void create_DBGFlowControlReply(const U32 _lossCount, const U8 _async, union SIGNAL **_sig);


#ifdef LITTLE_ENDIAN
void convert_DBGFlowControlReply(struct DBGFlowControlReply *_sig);
#else
#define convert_DBGFlowControlReply(_sig)
#endif





/*
 *===========================================================================
 * DBGTARGETINFO
 *===========================================================================
 *
 * Description: This signal is sent if a successful connection and interface version
   is greater than 1.0
   supported features:
      SUPPORTS_BASIC_CPU_PROF = 3
      SUPPORTS_BASIC_PRH = 4
      SUPPORTS_SIGNAL_SENDING = 5
      SUPPORTS_DBGSERVER_SPAWN = 6
      SUPPORTS_READ_MEMORY = 7
      SUPPORTS_FULL_SIG_QUEUE = 8

   maxSigSize:
      The maximum possible size of a signal to the debug server in bytes

   cpu classes:
      OSE_CPU_PPC = 0     
      OSE_CPU_M68K = 1,    
      OSE_CPU_ARM = 2,     
      OSE_CPU_MIPS = 3,    
      OSE_CPU_X86 = 4

   cpu type:
      CPU class dependent type identification 
 *
 * Parameters:
 *   byteOrder:    BIG = 0x1020304, LITTLE = 0x4030201
 *   maxSigSize:   
 *   cpu_class:   
 *   cpu_type:   
 *   notUsed3:   
 *   notUsed4:   
 *   supportedFeatures:   
 */
#define DBGTARGETINFO 32909   /* !-SIGNO(struct DBGTargetInfo)-! */
struct DBGTargetInfo {
   U32 sigNo;
   U32 size;
   U32 byteOrder ;
   U16 maxSigSize ;
   U16 cpu_class ;
   U32 cpu_type ;
   U32 notUsed3 ;
   U32 notUsed4 ;
};
_GLOBAL void create_DBGTargetInfo(const U32 _byteOrder, const U16 _maxSigSize, const U16 _cpu_class, const U32 _cpu_type, const U32 _notUsed3, const U32 _notUsed4, const U32 *_supportedFeatures, U32 _supportedFeaturesSize, union SIGNAL **_sig);


#ifdef LITTLE_ENDIAN
void convert_DBGTargetInfo(struct DBGTargetInfo *_sig);
#else
#define convert_DBGTargetInfo(_sig)
#endif


#define DBGTargetInfo_get_supportedFeatures_size(XXsig, XXretVal) do {\
   U8 *XXptr = (U8*)XXsig + ALIGN_SIZE(28);\
   XXretVal = *(U32*)XXptr;\
}while(0)
#define DBGTargetInfo_get_supportedFeatures(XXsig, XXretVal) do {\
   U8 *XXptr = (U8*)XXsig + ALIGN_SIZE(28);\
   XXretVal = (U32*)(XXptr+4);\
}while(0)



/*
 *===========================================================================
 * DBGSETSIGNALSIZESREPLY
 *===========================================================================
 *
 * Description: this signal is not used  *
 * Parameters:
 *   status:   
 *   currentMaxTraceSize:   
 *   currentMaxLinkSize:   
 */
#define DBGSETSIGNALSIZESREPLY 32910   /* !-SIGNO(struct DBGSetSignalSizesReply)-! */
struct DBGSetSignalSizesReply {
   U32 sigNo;
   U32 size;
   U32 status ;
   U32 currentMaxTraceSize ;
   U32 currentMaxLinkSize ;
};
_GLOBAL void create_DBGSetSignalSizesReply(const U32 _status, const U32 _currentMaxTraceSize, const U32 _currentMaxLinkSize, union SIGNAL **_sig);


#ifdef LITTLE_ENDIAN
void convert_DBGSetSignalSizesReply(struct DBGSetSignalSizesReply *_sig);
#else
#define convert_DBGSetSignalSizesReply(_sig)
#endif





/*
 *===========================================================================
 * DBGLOCK
 *===========================================================================
 *
 * Description:
 * The Client sends this signal to the server when it wants the target locked.
 * Locking a target means that it can set EventActions in the target.
 * NOTICE This signal may also be sent from an allready connected client.
 * Sending a lock request from an allready connected client should always
 * succeed. The client sends a new lock request if the user loads in
 * new evact settings. The server should respond as it does when it receives a
 * new lock request. The client will send down all the new evact settings
 * and mark the end of the stream with signal DBGEnableEvacts.
  *
 * Parameters:
 */
#define DBGLOCK 32911   /* !-SIGNO(struct DBGLock)-! */
struct DBGLock {
   U32 sigNo;
   U32 size;
};
#ifdef IS_DBGSERVER_CLIENT
_GLOBAL void create_DBGLock(union SIGNAL **_sig);
#endif


#ifdef LITTLE_ENDIAN
void convert_DBGLock(struct DBGLock *_sig);
#else
#define convert_DBGLock(_sig)
#endif





/*
 *===========================================================================
 * DBGFORCELOCK
 *===========================================================================
 *
 * Description:
 * Same as DBGLock except that it makes DBGLockReply always return success
 *
  *
 * Parameters:
 */
#define DBGFORCELOCK 32912   /* !-SIGNO(struct DBGForceLock)-! */
struct DBGForceLock {
   U32 sigNo;
   U32 size;
};
#ifdef IS_DBGSERVER_CLIENT
_GLOBAL void create_DBGForceLock(union SIGNAL **_sig);
#endif


#ifdef LITTLE_ENDIAN
void convert_DBGForceLock(struct DBGForceLock *_sig);
#else
#define convert_DBGForceLock(_sig)
#endif





/*
 *===========================================================================
 * DBGLOCKREPLY
 *===========================================================================
 *
 * Description: Sent by debug server as reply to DBGLock and/or DBGForceLock
  *
 * Parameters:
 *   status:    DBGSuccess if the client got the lock
 *   owner:    The name of the owner of the lock if status == DBGFailure
 */
#define DBGLOCKREPLY 32913   /* !-SIGNO(struct DBGLockReply)-! */
struct DBGLockReply {
   U32 sigNo;
   U32 size;
   U32 status ;
};
_GLOBAL void create_DBGLockReply(const U32 _status, const char *_owner, union SIGNAL **_sig);


#ifdef LITTLE_ENDIAN
void convert_DBGLockReply(struct DBGLockReply *_sig);
#else
#define convert_DBGLockReply(_sig)
#endif


#define DBGLockReply_get_owner_size(XXsig, XXretVal) do {\
   U8 *XXptr = (U8*)XXsig + ALIGN_SIZE(12);\
   XXretVal = *(U32*)XXptr;\
}while(0)
#define DBGLockReply_get_owner(XXsig, XXretVal) do {\
   U8 *XXptr = (U8*)XXsig + ALIGN_SIZE(12);\
   XXretVal = (char*)(XXptr+4);\
}while(0)



/*
 *===========================================================================
 * DBGLOSTLOCK
 *===========================================================================
 *
 * Description: Sent to the looser when the server receives DBGForceLock
  *
 * Parameters:
 *   newOwner:   
 */
#define DBGLOSTLOCK 32914   /* !-SIGNO(struct DBGLostLock)-! */
struct DBGLostLock {
   U32 sigNo;
   U32 size;
};
_GLOBAL void create_DBGLostLock(const char *_newOwner, union SIGNAL **_sig);


#ifdef LITTLE_ENDIAN
void convert_DBGLostLock(struct DBGLostLock *_sig);
#else
#define convert_DBGLostLock(_sig)
#endif


#define DBGLostLock_get_newOwner_size(XXsig, XXretVal) do {\
   U8 *XXptr = (U8*)XXsig + ALIGN_SIZE(8);\
   XXretVal = *(U32*)XXptr;\
}while(0)
#define DBGLostLock_get_newOwner(XXsig, XXretVal) do {\
   U8 *XXptr = (U8*)XXsig + ALIGN_SIZE(8);\
   XXretVal = (char*)(XXptr+4);\
}while(0)



/*
 *===========================================================================
 * DBGUNLOCK
 *===========================================================================
 *
 * Description:
 * Description: The client unlocked a lock.
 *
  *
 * Parameters:
 */
#define DBGUNLOCK 32915   /* !-SIGNO(struct DBGUnlock)-! */
struct DBGUnlock {
   U32 sigNo;
   U32 size;
};
#ifdef IS_DBGSERVER_CLIENT
_GLOBAL void create_DBGUnlock(union SIGNAL **_sig);
#endif


#ifdef LITTLE_ENDIAN
void convert_DBGUnlock(struct DBGUnlock *_sig);
#else
#define convert_DBGUnlock(_sig)
#endif





/*
 *===========================================================================
 * DBGENABLEEVACTS
 *===========================================================================
 *
 * Description: Sent from client to server after the client received a succesfull lockReply
 * and after that the server has installed all its evacts.
 * This signal marks the end of a stream of evacts sent from the client to the
 * server. The server should now remove all old evacts it contained before it
 * received the lock request.
  *
 * Parameters:
 */
#define DBGENABLEEVACTS 32916   /* !-SIGNO(struct DBGEnableEvacts)-! */
struct DBGEnableEvacts {
   U32 sigNo;
   U32 size;
};
#ifdef IS_DBGSERVER_CLIENT
_GLOBAL void create_DBGEnableEvacts(union SIGNAL **_sig);
#endif


#ifdef LITTLE_ENDIAN
void convert_DBGEnableEvacts(struct DBGEnableEvacts *_sig);
#else
#define convert_DBGEnableEvacts(_sig)
#endif





/*
 *===========================================================================
 * DBGCONNECTIONREESTABLISHED
 *===========================================================================
 *
 * Description:
 * Sent from client to debug server just after a reconnect.
 *
 * Parameters:
 * evactId[];                 The list of all known event action id's known
 *                            to the client. The server throws all evacts not
 *                            known to the client. The list is terminated with
 *                            NULL.
 *
  *
 * Parameters:
 *   evactId:   
 */
#define DBGCONNECTIONREESTABLISHED 32917   /* !-SIGNO(struct DBGConnectionReEstablished)-! */
struct DBGConnectionReEstablished {
   U32 sigNo;
   U32 size;
};
#ifdef IS_DBGSERVER_CLIENT
_GLOBAL void create_DBGConnectionReEstablished(const U32 *_evactId, U32 _evactIdSize, union SIGNAL **_sig);
#endif


#ifdef LITTLE_ENDIAN
void convert_DBGConnectionReEstablished(struct DBGConnectionReEstablished *_sig);
#else
#define convert_DBGConnectionReEstablished(_sig)
#endif


#define DBGConnectionReEstablished_get_evactId_size(XXsig, XXretVal) do {\
   U8 *XXptr = (U8*)XXsig + ALIGN_SIZE(8);\
   XXretVal = *(U32*)XXptr;\
}while(0)
#define DBGConnectionReEstablished_get_evactId(XXsig, XXretVal) do {\
   U8 *XXptr = (U8*)XXsig + ALIGN_SIZE(8);\
   XXretVal = (U32*)(XXptr+4);\
}while(0)



/*
 *===========================================================================
 * DBGOUTOFMEMORY
 *===========================================================================
 *
 * Description:
  *
 * Parameters:
 */
#define DBGOUTOFMEMORY 32918   /* !-SIGNO(struct DBGOutOfMemory)-! */
struct DBGOutOfMemory {
   U32 sigNo;
   U32 size;
};
_GLOBAL void create_DBGOutOfMemory(union SIGNAL **_sig);


#ifdef LITTLE_ENDIAN
void convert_DBGOutOfMemory(struct DBGOutOfMemory *_sig);
#else
#define convert_DBGOutOfMemory(_sig)
#endif





/*
 *===========================================================================
 * DBGSETSENDEVACT
 *===========================================================================
 *
 * Description:
 * Sent by the client to create a new send event action.
 * The name lists contains a list of names each name is 0 terminated and the
 * last name is 00 terminated. The name is either a process name or a wildcard
 * The wildcard handling is very simple so wildcards can only be in the
 * form of "*" or "string*" i.e. "process*".
 *
  *
 * Parameters:
 *   action:    Action to take when this event occurs, i.e. Monitor, Trace, Catch or Goto.
 *   countNumber:    The number of events that must occur before the action is trigged.
 *   state:    The state this evact is part of
 *   nextState:    If action == Goto then this is the state to goto.
 *   withSignalData:    True if signal data should be sent to the client
 *   fromSignalNumber:   
 *   toSignalNumber:   
 *   fromName:   
 *   toName:   List of wildcards, each name is 0 terminated, last is 00 term.
 */
#define DBGSETSENDEVACT 32919   /* !-SIGNO(struct DBGSetSendEvact)-! */
struct DBGSetSendEvact {
   U32 sigNo;
   U32 size;
   U32 action ;
   U32 countNumber ;
   U32 state ;
   U32 nextState ;
   U32 withSignalData ;
   U32 fromSignalNumber ;
   U32 toSignalNumber ;
};
#ifdef IS_DBGSERVER_CLIENT
_GLOBAL void create_DBGSetSendEvact(const U32 _action, const U32 _countNumber, const U32 _state, const U32 _nextState, const U32 _withSignalData, const U32 _fromSignalNumber, const U32 _toSignalNumber, const U8 *_fromName, U32 _fromNameSize, const U8 *_toName, U32 _toNameSize, union SIGNAL **_sig);
#endif


#ifdef LITTLE_ENDIAN
void convert_DBGSetSendEvact(struct DBGSetSendEvact *_sig);
#else
#define convert_DBGSetSendEvact(_sig)
#endif


#define DBGSetSendEvact_get_fromName_size(XXsig, XXretVal) do {\
   U8 *XXptr = (U8*)XXsig + ALIGN_SIZE(36);\
   XXretVal = *(U32*)XXptr;\
}while(0)
#define DBGSetSendEvact_get_fromName(XXsig, XXretVal) do {\
   U8 *XXptr = (U8*)XXsig + ALIGN_SIZE(36);\
   XXretVal = (U8*)(XXptr+4);\
}while(0)
#define DBGSetSendEvact_get_toName_size(XXsig, XXretVal) do {\
   U8 *XXptr = (U8*)XXsig + ALIGN_SIZE(36);\
   XXptr += ALIGN_SIZE( *((U32*)XXptr) ) + 4;\
   XXretVal = *(U32*)XXptr;\
}while(0)
#define DBGSetSendEvact_get_toName(XXsig, XXretVal) do {\
   U8 *XXptr = (U8*)XXsig + ALIGN_SIZE(36);\
   XXptr += ALIGN_SIZE( *((U32*)XXptr) ) + 4;\
   XXretVal = (U8*)(XXptr+4);\
}while(0)



/*
 *===========================================================================
 * DBGSETRECEIVEEVACT
 *===========================================================================
 *
 * Description:
 * Sent by the client to create a new receive event action.
 * The name lists contains a list of names each name is 0 terminated and the
 * last name is 00 terminated. The name is either a process name or a wildcard
 * The wildcard handling is very simple so wildcards can only be in the
 * form of "*" or "string*" i.e. "process*".
 *
  *
 * Parameters:
 *   action:    Action to take when this event occurs, i.e. Monitor, Trace, Catch or Goto.
 *   countNumber:    The number of events that must occur before the action is trigged.
 *   state:    The state this evact is part of
 *   nextState:    If action == Goto then this is the state to goto.
 *   withSignalData:    True if signal data should be sent to the client
 *   fromSignalNumber:   
 *   toSignalNumber:   
 *   fromName:   
 *   toName:   List of wildcards, each name is 0 terminated, last is 00 term.
 */
#define DBGSETRECEIVEEVACT 32920   /* !-SIGNO(struct DBGSetReceiveEvact)-! */
struct DBGSetReceiveEvact {
   U32 sigNo;
   U32 size;
   U32 action ;
   U32 countNumber ;
   U32 state ;
   U32 nextState ;
   U32 withSignalData ;
   U32 fromSignalNumber ;
   U32 toSignalNumber ;
};
#ifdef IS_DBGSERVER_CLIENT
_GLOBAL void create_DBGSetReceiveEvact(const U32 _action, const U32 _countNumber, const U32 _state, const U32 _nextState, const U32 _withSignalData, const U32 _fromSignalNumber, const U32 _toSignalNumber, const U8 *_fromName, U32 _fromNameSize, const U8 *_toName, U32 _toNameSize, union SIGNAL **_sig);
#endif


#ifdef LITTLE_ENDIAN
void convert_DBGSetReceiveEvact(struct DBGSetReceiveEvact *_sig);
#else
#define convert_DBGSetReceiveEvact(_sig)
#endif


#define DBGSetReceiveEvact_get_fromName_size(XXsig, XXretVal) do {\
   U8 *XXptr = (U8*)XXsig + ALIGN_SIZE(36);\
   XXretVal = *(U32*)XXptr;\
}while(0)
#define DBGSetReceiveEvact_get_fromName(XXsig, XXretVal) do {\
   U8 *XXptr = (U8*)XXsig + ALIGN_SIZE(36);\
   XXretVal = (U8*)(XXptr+4);\
}while(0)
#define DBGSetReceiveEvact_get_toName_size(XXsig, XXretVal) do {\
   U8 *XXptr = (U8*)XXsig + ALIGN_SIZE(36);\
   XXptr += ALIGN_SIZE( *((U32*)XXptr) ) + 4;\
   XXretVal = *(U32*)XXptr;\
}while(0)
#define DBGSetReceiveEvact_get_toName(XXsig, XXretVal) do {\
   U8 *XXptr = (U8*)XXsig + ALIGN_SIZE(36);\
   XXptr += ALIGN_SIZE( *((U32*)XXptr) ) + 4;\
   XXretVal = (U8*)(XXptr+4);\
}while(0)



/*
 *===========================================================================
 * DBGSETSWAPEVACT
 *===========================================================================
 *
 * Description: Sent by the client to create a new swap (context switch) event action.
 * The name lists contains a list of names each name is 0 terminated and the
 * last name is 00 terminated. The name is either a process name or a wildcard
 * The wildcard handling is very simple so wildcards can only be in the
 * form of "*" or "string*" i.e. "process*".
  *
 * Parameters:
 *   action:   
 *   countNumber:   
 *   state:   
 *   nextState:   
 *   fromName:   List of wildcards, each name is 0 terminated, last is 00 term.
 *   toName:   List of wildcards, each name is 0 terminated, last is 00 term.
 */
#define DBGSETSWAPEVACT 32921   /* !-SIGNO(struct DBGSetSwapEvact)-! */
struct DBGSetSwapEvact {
   U32 sigNo;
   U32 size;
   U32 action ;
   U32 countNumber ;
   U32 state ;
   U32 nextState ;
};
#ifdef IS_DBGSERVER_CLIENT
_GLOBAL void create_DBGSetSwapEvact(const U32 _action, const U32 _countNumber, const U32 _state, const U32 _nextState, const U8 *_fromName, U32 _fromNameSize, const U8 *_toName, U32 _toNameSize, union SIGNAL **_sig);
#endif


#ifdef LITTLE_ENDIAN
void convert_DBGSetSwapEvact(struct DBGSetSwapEvact *_sig);
#else
#define convert_DBGSetSwapEvact(_sig)
#endif


#define DBGSetSwapEvact_get_fromName_size(XXsig, XXretVal) do {\
   U8 *XXptr = (U8*)XXsig + ALIGN_SIZE(24);\
   XXretVal = *(U32*)XXptr;\
}while(0)
#define DBGSetSwapEvact_get_fromName(XXsig, XXretVal) do {\
   U8 *XXptr = (U8*)XXsig + ALIGN_SIZE(24);\
   XXretVal = (U8*)(XXptr+4);\
}while(0)
#define DBGSetSwapEvact_get_toName_size(XXsig, XXretVal) do {\
   U8 *XXptr = (U8*)XXsig + ALIGN_SIZE(24);\
   XXptr += ALIGN_SIZE( *((U32*)XXptr) ) + 4;\
   XXretVal = *(U32*)XXptr;\
}while(0)
#define DBGSetSwapEvact_get_toName(XXsig, XXretVal) do {\
   U8 *XXptr = (U8*)XXsig + ALIGN_SIZE(24);\
   XXptr += ALIGN_SIZE( *((U32*)XXptr) ) + 4;\
   XXretVal = (U8*)(XXptr+4);\
}while(0)



/*
 *===========================================================================
 * DBGSETCREATEEVACT
 *===========================================================================
 *
 * Description:
 * Sent by the client to create a new create process event action.
 * The name lists contains a list of names each name is 0 terminated and the
 * last name is 00 terminated. The name is either a process name or a wildcard
 * The wildcard handling is very simple so wildcards can only be in the
 * form of "*" or "string*" i.e. "process*".
 *
  *
 * Parameters:
 *   action:   
 *   countNumber:   
 *   state:   
 *   nextState:   
 *   name:   List of wildcards, each name is 0 terminated, last is 00 term.
 */
#define DBGSETCREATEEVACT 32922   /* !-SIGNO(struct DBGSetCreateEvact)-! */
struct DBGSetCreateEvact {
   U32 sigNo;
   U32 size;
   U32 action ;
   U32 countNumber ;
   U32 state ;
   U32 nextState ;
};
#ifdef IS_DBGSERVER_CLIENT
_GLOBAL void create_DBGSetCreateEvact(const U32 _action, const U32 _countNumber, const U32 _state, const U32 _nextState, const U8 *_name, U32 _nameSize, union SIGNAL **_sig);
#endif


#ifdef LITTLE_ENDIAN
void convert_DBGSetCreateEvact(struct DBGSetCreateEvact *_sig);
#else
#define convert_DBGSetCreateEvact(_sig)
#endif


#define DBGSetCreateEvact_get_name_size(XXsig, XXretVal) do {\
   U8 *XXptr = (U8*)XXsig + ALIGN_SIZE(24);\
   XXretVal = *(U32*)XXptr;\
}while(0)
#define DBGSetCreateEvact_get_name(XXsig, XXretVal) do {\
   U8 *XXptr = (U8*)XXsig + ALIGN_SIZE(24);\
   XXretVal = (U8*)(XXptr+4);\
}while(0)



/*
 *===========================================================================
 * DBGSETKILLEVACT
 *===========================================================================
 *
 * Description: Sent by the client to create a new kill process event action.
 * The name lists contains a list of names each name is 0 terminated and the
 * last name is 00 terminated. The name is either a process name or a wildcard
 * The wildcard handling is very simple so wildcards can only be in the
 * form of "*" or "string*" i.e. "process*".
 *
  *
 * Parameters:
 *   action:   
 *   countNumber:   
 *   state:   
 *   nextState:   
 *   name:    List of wildcards, each name is 0 terminated, last is 00 term.
 */
#define DBGSETKILLEVACT 32923   /* !-SIGNO(struct DBGSetKillEvact)-! */
struct DBGSetKillEvact {
   U32 sigNo;
   U32 size;
   U32 action ;
   U32 countNumber ;
   U32 state ;
   U32 nextState ;
};
#ifdef IS_DBGSERVER_CLIENT
_GLOBAL void create_DBGSetKillEvact(const U32 _action, const U32 _countNumber, const U32 _state, const U32 _nextState, const U8 *_name, U32 _nameSize, union SIGNAL **_sig);
#endif


#ifdef LITTLE_ENDIAN
void convert_DBGSetKillEvact(struct DBGSetKillEvact *_sig);
#else
#define convert_DBGSetKillEvact(_sig)
#endif


#define DBGSetKillEvact_get_name_size(XXsig, XXretVal) do {\
   U8 *XXptr = (U8*)XXsig + ALIGN_SIZE(24);\
   XXretVal = *(U32*)XXptr;\
}while(0)
#define DBGSetKillEvact_get_name(XXsig, XXretVal) do {\
   U8 *XXptr = (U8*)XXsig + ALIGN_SIZE(24);\
   XXretVal = (U8*)(XXptr+4);\
}while(0)



/*
 *===========================================================================
 * DBGSETERROREVACT
 *===========================================================================
 *
 * Description: Sent by the client to create a new error event action.
 * The name lists contains a list of names each name is 0 terminated and the
 * last name is 00 terminated. The name is either a process name or a wildcard
 * The wildcard handling is very simple so wildcards can only be in the
 * form of "*" or "string*" i.e. "process*".
  *
 * Parameters:
 *   action:   
 *   countNumber:   
 *   state:   
 *   nextState:   
 *   fromErrorNumber:   
 *   toErrorNumber:   
 *   name:    List of wildcards, each name is 0 terminated, last is 00 term.
 */
#define DBGSETERROREVACT 32924   /* !-SIGNO(struct DBGSetErrorEvact)-! */
struct DBGSetErrorEvact {
   U32 sigNo;
   U32 size;
   U32 action ;
   U32 countNumber ;
   U32 state ;
   U32 nextState ;
   U32 fromErrorNumber ;
   U32 toErrorNumber ;
};
#ifdef IS_DBGSERVER_CLIENT
_GLOBAL void create_DBGSetErrorEvact(const U32 _action, const U32 _countNumber, const U32 _state, const U32 _nextState, const U32 _fromErrorNumber, const U32 _toErrorNumber, const U8 *_name, U32 _nameSize, union SIGNAL **_sig);
#endif


#ifdef LITTLE_ENDIAN
void convert_DBGSetErrorEvact(struct DBGSetErrorEvact *_sig);
#else
#define convert_DBGSetErrorEvact(_sig)
#endif


#define DBGSetErrorEvact_get_name_size(XXsig, XXretVal) do {\
   U8 *XXptr = (U8*)XXsig + ALIGN_SIZE(32);\
   XXretVal = *(U32*)XXptr;\
}while(0)
#define DBGSetErrorEvact_get_name(XXsig, XXretVal) do {\
   U8 *XXptr = (U8*)XXsig + ALIGN_SIZE(32);\
   XXretVal = (U8*)(XXptr+4);\
}while(0)



/*
 *===========================================================================
 * DBGSETUSERERROREVACT
 *===========================================================================
 *
 * Description: Sent by the client to create a new user error event action.
 * The name lists contains a list of names each name is 0 terminated and the
 * last name is 00 terminated. The name is either a process name or a wildcard
 * The wildcard handling is very simple so wildcards can only be in the
 * form of "*" or "string*" i.e. "process*".
  *
 * Parameters:
 *   action:   
 *   countNumber:   
 *   state:   
 *   nextState:   
 *   fromErrorNumber:   
 *   toErrorNumber:   
 *   name:    List of wildcards, each name is 0 terminated, last is 00 term.
 */
#define DBGSETUSERERROREVACT 32925   /* !-SIGNO(struct DBGSetUserErrorEvact)-! */
struct DBGSetUserErrorEvact {
   U32 sigNo;
   U32 size;
   U32 action ;
   U32 countNumber ;
   U32 state ;
   U32 nextState ;
   U32 fromErrorNumber ;
   U32 toErrorNumber ;
};
#ifdef IS_DBGSERVER_CLIENT
_GLOBAL void create_DBGSetUserErrorEvact(const U32 _action, const U32 _countNumber, const U32 _state, const U32 _nextState, const U32 _fromErrorNumber, const U32 _toErrorNumber, const U8 *_name, U32 _nameSize, union SIGNAL **_sig);
#endif


#ifdef LITTLE_ENDIAN
void convert_DBGSetUserErrorEvact(struct DBGSetUserErrorEvact *_sig);
#else
#define convert_DBGSetUserErrorEvact(_sig)
#endif


#define DBGSetUserErrorEvact_get_name_size(XXsig, XXretVal) do {\
   U8 *XXptr = (U8*)XXsig + ALIGN_SIZE(32);\
   XXretVal = *(U32*)XXptr;\
}while(0)
#define DBGSetUserErrorEvact_get_name(XXsig, XXretVal) do {\
   U8 *XXptr = (U8*)XXsig + ALIGN_SIZE(32);\
   XXretVal = (U8*)(XXptr+4);\
}while(0)



/*
 *===========================================================================
 * DBGEVACTREPLY
 *===========================================================================
 *
 * Description: Sent by the debug server as reply to all new evact requests
 *              (DBGSEND_EVACT - DBGERROR_EVACT).
  *
 * Parameters:
 *   success:    True if successfull i.e. memory not exchausted
 *   evactId:    An id assigned by the debug server to this evact, this
                 * id is used in following references to this evact.
                 
 *   evactMemoryUsed:   The current Number of evact administration data used by the debug server.
 */
#define DBGEVACTREPLY 32926   /* !-SIGNO(struct DBGEvactReply)-! */
struct DBGEvactReply {
   U32 sigNo;
   U32 size;
   U32 success ;
   U32 evactId ;
   U32 evactMemoryUsed ;
};
_GLOBAL void create_DBGEvactReply(const U32 _success, const U32 _evactId, const U32 _evactMemoryUsed, union SIGNAL **_sig);


#ifdef LITTLE_ENDIAN
void convert_DBGEvactReply(struct DBGEvactReply *_sig);
#else
#define convert_DBGEvactReply(_sig)
#endif





/*
 *===========================================================================
 * DBGREMOVEEVACT
 *===========================================================================
 *
 * Description: Sent from client to the dbgServer when the client wants
 * to remove an event action.
  *
 * Parameters:
 *   evactId:    An id assigned by the debug server to this evact.
 */
#define DBGREMOVEEVACT 32927   /* !-SIGNO(struct DBGRemoveEvact)-! */
struct DBGRemoveEvact {
   U32 sigNo;
   U32 size;
   U32 evactId ;
};
#ifdef IS_DBGSERVER_CLIENT
_GLOBAL void create_DBGRemoveEvact(const U32 _evactId, union SIGNAL **_sig);
#endif


#ifdef LITTLE_ENDIAN
void convert_DBGRemoveEvact(struct DBGRemoveEvact *_sig);
#else
#define convert_DBGRemoveEvact(_sig)
#endif





/*
 *===========================================================================
 * DBGSETSTATE
 *===========================================================================
 *
 * Description: Sent from client to server when user explisitly sets active state
  *
 * Parameters:
 *   state:    The new state number
 */
#define DBGSETSTATE 32928   /* !-SIGNO(struct DBGSetState)-! */
struct DBGSetState {
   U32 sigNo;
   U32 size;
   U16 state ;
};
#ifdef IS_DBGSERVER_CLIENT
_GLOBAL void create_DBGSetState(const U16 _state, union SIGNAL **_sig);
#endif


#ifdef LITTLE_ENDIAN
void convert_DBGSetState(struct DBGSetState *_sig);
#else
#define convert_DBGSetState(_sig)
#endif





/*
 *===========================================================================
 * DBGMONITORSENDRECEIVENOTIFY
 *===========================================================================
 *
 * Description: Sent from the debug server to the client as part of a monitor
 * action as a result of that a monitored send accurd.
 *
  *
 * Parameters:
 *   state:    The current active state
 *   eventType:    4 for send and 5 for receive
 *   notUsed:   
 *   tick:   
 *   utick:   
 *   abstime:   
 *   abstick:   
 *   fromPid:   
 *   toPid:   
 *   signalNo:   
 *   signalId:   
 *   fromName:   
 *   toName:   
 *   data:   
 */
#define DBGMONITORSENDRECEIVENOTIFY 32929   /* !-SIGNO(struct DBGMonitorSendReceiveNotify)-! */
struct DBGMonitorSendReceiveNotify {
   U32 sigNo;
   U32 size;
   U16 state ;
   U8 eventType ;
   U8 notUsed ;
   U32 tick ;
   U32 utick ;
   U32 abstime ;
   U32 abstick ;
   U32 fromPid ;
   U32 toPid ;
   U32 signalNo ;
   U32 signalId ;
};
_GLOBAL void create_DBGMonitorSendReceiveNotify(const U16 _state, const U8 _eventType, const U8 _notUsed, const U32 _tick, const U32 _utick, const U32 _abstime, const U32 _abstick, const U32 _fromPid, const U32 _toPid, const U32 _signalNo, const U32 _signalId, const char *_fromName, const char *_toName, const U8 *_data, U32 _dataSize, union SIGNAL **_sig);


#ifdef LITTLE_ENDIAN
void convert_DBGMonitorSendReceiveNotify(struct DBGMonitorSendReceiveNotify *_sig);
#else
#define convert_DBGMonitorSendReceiveNotify(_sig)
#endif


#define DBGMonitorSendReceiveNotify_get_fromName_size(XXsig, XXretVal) do {\
   U8 *XXptr = (U8*)XXsig + ALIGN_SIZE(44);\
   XXretVal = *(U32*)XXptr;\
}while(0)
#define DBGMonitorSendReceiveNotify_get_fromName(XXsig, XXretVal) do {\
   U8 *XXptr = (U8*)XXsig + ALIGN_SIZE(44);\
   XXretVal = (char*)(XXptr+4);\
}while(0)
#define DBGMonitorSendReceiveNotify_get_toName_size(XXsig, XXretVal) do {\
   U8 *XXptr = (U8*)XXsig + ALIGN_SIZE(44);\
   XXptr += ALIGN_SIZE( *((U32*)XXptr) ) + 4;\
   XXretVal = *(U32*)XXptr;\
}while(0)
#define DBGMonitorSendReceiveNotify_get_toName(XXsig, XXretVal) do {\
   U8 *XXptr = (U8*)XXsig + ALIGN_SIZE(44);\
   XXptr += ALIGN_SIZE( *((U32*)XXptr) ) + 4;\
   XXretVal = (char*)(XXptr+4);\
}while(0)
#define DBGMonitorSendReceiveNotify_get_data_size(XXsig, XXretVal) do {\
   U8 *XXptr = (U8*)XXsig + ALIGN_SIZE(44);\
   XXptr += ALIGN_SIZE( *((U32*)XXptr) ) + 4;\
   XXptr += ALIGN_SIZE( *((U32*)XXptr) ) + 4;\
   XXretVal = *(U32*)XXptr;\
}while(0)
#define DBGMonitorSendReceiveNotify_get_data(XXsig, XXretVal) do {\
   U8 *XXptr = (U8*)XXsig + ALIGN_SIZE(44);\
   XXptr += ALIGN_SIZE( *((U32*)XXptr) ) + 4;\
   XXptr += ALIGN_SIZE( *((U32*)XXptr) ) + 4;\
   XXretVal = (U8*)(XXptr+4);\
}while(0)



/*
 *===========================================================================
 * DBGMONITORCREATEKILLNOTIFY
 *===========================================================================
 *
 * Description:
 * Sent from the debug server to the client as part of a monitor
 * action as a result of that a monitored create accurd.
  *
 * Parameters:
 *   state:    The current active state
 *   eventType:    1 for create and 2 for kill
 *   notUsed:   
 *   procType:   
 *   bid:   
 *   tick:   
 *   utick:   
 *   abstime:   
 *   abstick:   
 *   creatorPid:   
 *   pid:   
 *   name:   
 */
#define DBGMONITORCREATEKILLNOTIFY 32930   /* !-SIGNO(struct DBGMonitorCreateKillNotify)-! */
struct DBGMonitorCreateKillNotify {
   U32 sigNo;
   U32 size;
   U16 state ;
   U8 eventType ;
   U8 notUsed ;
   U32 procType ;
   U32 bid ;
   U32 tick ;
   U32 utick ;
   U32 abstime ;
   U32 abstick ;
   U32 creatorPid ;
   U32 pid ;
};
_GLOBAL void create_DBGMonitorCreateKillNotify(const U16 _state, const U8 _eventType, const U8 _notUsed, const U32 _procType, const U32 _bid, const U32 _tick, const U32 _utick, const U32 _abstime, const U32 _abstick, const U32 _creatorPid, const U32 _pid, const char *_name, union SIGNAL **_sig);


#ifdef LITTLE_ENDIAN
void convert_DBGMonitorCreateKillNotify(struct DBGMonitorCreateKillNotify *_sig);
#else
#define convert_DBGMonitorCreateKillNotify(_sig)
#endif


#define DBGMonitorCreateKillNotify_get_name_size(XXsig, XXretVal) do {\
   U8 *XXptr = (U8*)XXsig + ALIGN_SIZE(44);\
   XXretVal = *(U32*)XXptr;\
}while(0)
#define DBGMonitorCreateKillNotify_get_name(XXsig, XXretVal) do {\
   U8 *XXptr = (U8*)XXsig + ALIGN_SIZE(44);\
   XXretVal = (char*)(XXptr+4);\
}while(0)



/*
 *===========================================================================
 * DBGMONITORSWAPNOTIFY
 *===========================================================================
 *
 * Description:
 * Sent from the debug server to the client as part of a monitor
 * action as a result of that a monitored context switch accurd.
 *
  *
 * Parameters:
 *   state:    The current active state
 *   notUsed:    set to 0
 *   tick:   
 *   utick:   
 *   abstime:   
 *   abstick:   
 *   fromPid:   
 *   toPid:   
 */
#define DBGMONITORSWAPNOTIFY 32931   /* !-SIGNO(struct DBGMonitorSwapNotify)-! */
struct DBGMonitorSwapNotify {
   U32 sigNo;
   U32 size;
   U16 state ;
   U16 notUsed ;
   U32 tick ;
   U32 utick ;
   U32 abstime ;
   U32 abstick ;
   U32 fromPid ;
   U32 toPid ;
};
_GLOBAL void create_DBGMonitorSwapNotify(const U16 _state, const U16 _notUsed, const U32 _tick, const U32 _utick, const U32 _abstime, const U32 _abstick, const U32 _fromPid, const U32 _toPid, union SIGNAL **_sig);


#ifdef LITTLE_ENDIAN
void convert_DBGMonitorSwapNotify(struct DBGMonitorSwapNotify *_sig);
#else
#define convert_DBGMonitorSwapNotify(_sig)
#endif





/*
 *===========================================================================
 * DBGMONITORERRORNOTIFY
 *===========================================================================
 *
 * Description:
 * Sent from the debug server to the client as part of a monitor
 * action as a result of that a monitored user error accurd.
 *
 *
  *
 * Parameters:
 *   state:    The current active state
 *   eventType:    6 for kernel error and 11 for user called.
 *   notUsed:    set to 0
 *   tick:   
 *   utick:   
 *   abstime:   
 *   abstick:   
 *   pid:   
 *   error:   
 *   extra:   
 *   name:    The process name;
 *   miscInfo:   
 */
#define DBGMONITORERRORNOTIFY 32932   /* !-SIGNO(struct DBGMonitorErrorNotify)-! */
struct DBGMonitorErrorNotify {
   U32 sigNo;
   U32 size;
   U16 state ;
   U8 eventType ;
   U8 notUsed ;
   U32 tick ;
   U32 utick ;
   U32 abstime ;
   U32 abstick ;
   U32 pid ;
   U32 error ;
   U32 extra ;
};
_GLOBAL void create_DBGMonitorErrorNotify(const U16 _state, const U8 _eventType, const U8 _notUsed, const U32 _tick, const U32 _utick, const U32 _abstime, const U32 _abstick, const U32 _pid, const U32 _error, const U32 _extra, const char *_name, const char *_miscInfo, union SIGNAL **_sig);


#ifdef LITTLE_ENDIAN
void convert_DBGMonitorErrorNotify(struct DBGMonitorErrorNotify *_sig);
#else
#define convert_DBGMonitorErrorNotify(_sig)
#endif


#define DBGMonitorErrorNotify_get_name_size(XXsig, XXretVal) do {\
   U8 *XXptr = (U8*)XXsig + ALIGN_SIZE(40);\
   XXretVal = *(U32*)XXptr;\
}while(0)
#define DBGMonitorErrorNotify_get_name(XXsig, XXretVal) do {\
   U8 *XXptr = (U8*)XXsig + ALIGN_SIZE(40);\
   XXretVal = (char*)(XXptr+4);\
}while(0)
#define DBGMonitorErrorNotify_get_miscInfo_size(XXsig, XXretVal) do {\
   U8 *XXptr = (U8*)XXsig + ALIGN_SIZE(40);\
   XXptr += ALIGN_SIZE( *((U32*)XXptr) ) + 4;\
   XXretVal = *(U32*)XXptr;\
}while(0)
#define DBGMonitorErrorNotify_get_miscInfo(XXsig, XXretVal) do {\
   U8 *XXptr = (U8*)XXsig + ALIGN_SIZE(40);\
   XXptr += ALIGN_SIZE( *((U32*)XXptr) ) + 4;\
   XXretVal = (char*)(XXptr+4);\
}while(0)



/*
 *===========================================================================
 * DBGTRACEENABLE
 *===========================================================================
 *
 * Description:
 * Sent from the debug server to the client as part of a monitor
 * action as a result of that a monitored user error accurd.
 *
 *
  *
 * Parameters:
 */
#define DBGTRACEENABLE 32933   /* !-SIGNO(struct DBGTraceEnable)-! */
struct DBGTraceEnable {
   U32 sigNo;
   U32 size;
};
#ifdef IS_DBGSERVER_CLIENT
_GLOBAL void create_DBGTraceEnable(union SIGNAL **_sig);
#endif


#ifdef LITTLE_ENDIAN
void convert_DBGTraceEnable(struct DBGTraceEnable *_sig);
#else
#define convert_DBGTraceEnable(_sig)
#endif





/*
 *===========================================================================
 * DBGTRACEDISABLE
 *===========================================================================
 *
 * Description:
 * Sent from the debug server to the client as part of a monitor
 * action as a result of that a monitored user error accurd.
 *
 *
  *
 * Parameters:
 */
#define DBGTRACEDISABLE 32934   /* !-SIGNO(struct DBGTraceDisable)-! */
struct DBGTraceDisable {
   U32 sigNo;
   U32 size;
};
#ifdef IS_DBGSERVER_CLIENT
_GLOBAL void create_DBGTraceDisable(union SIGNAL **_sig);
#endif


#ifdef LITTLE_ENDIAN
void convert_DBGTraceDisable(struct DBGTraceDisable *_sig);
#else
#define convert_DBGTraceDisable(_sig)
#endif





/*
 *===========================================================================
 * DBGCLEARTRACE
 *===========================================================================
 *
 * Description:
 * Clear the trace.
 *
  *
 * Parameters:
 */
#define DBGCLEARTRACE 32935   /* !-SIGNO(struct DBGClearTrace)-! */
struct DBGClearTrace {
   U32 sigNo;
   U32 size;
};
#ifdef IS_DBGSERVER_CLIENT
_GLOBAL void create_DBGClearTrace(union SIGNAL **_sig);
#endif


#ifdef LITTLE_ENDIAN
void convert_DBGClearTrace(struct DBGClearTrace *_sig);
#else
#define convert_DBGClearTrace(_sig)
#endif





/*
 *===========================================================================
 * DBGCLEARTRACEREPLY
 *===========================================================================
 *
 * Description:
 * Clear trace reply.
 *
  *
 * Parameters:
 */
#define DBGCLEARTRACEREPLY 32936   /* !-SIGNO(struct DBGClearTraceReply)-! */
struct DBGClearTraceReply {
   U32 sigNo;
   U32 size;
};
_GLOBAL void create_DBGClearTraceReply(union SIGNAL **_sig);


#ifdef LITTLE_ENDIAN
void convert_DBGClearTraceReply(struct DBGClearTraceReply *_sig);
#else
#define convert_DBGClearTraceReply(_sig)
#endif





/*
 *===========================================================================
 * DBGREADTRACE
 *===========================================================================
 *
 * Description:
 * Request to read the a section in the  trace.
 *
  *
 * Parameters:
 *   start:    The first entry to read. Values larger than the last
		  entry is treated as the last entry - 50. 
 *   end:    The last entry to read. Values larger than the last
		  entry is treated as the last entry. 
 */
#define DBGREADTRACE 32937   /* !-SIGNO(struct DBGReadTrace)-! */
struct DBGReadTrace {
   U32 sigNo;
   U32 size;
   U32 start ;
   U32 end ;
};
#ifdef IS_DBGSERVER_CLIENT
_GLOBAL void create_DBGReadTrace(const U32 _start, const U32 _end, union SIGNAL **_sig);
#endif


#ifdef LITTLE_ENDIAN
void convert_DBGReadTrace(struct DBGReadTrace *_sig);
#else
#define convert_DBGReadTrace(_sig)
#endif





/*
 *===========================================================================
 * DBGREADTRACEENDMARK
 *===========================================================================
 *
 * Description:
 * The endmark, signaling that the last read trace reply is sent.
  *
 * Parameters:
 *   entrys:    Current number of entrys in the trace.
 */
#define DBGREADTRACEENDMARK 32938   /* !-SIGNO(struct DBGReadTraceEndMark)-! */
struct DBGReadTraceEndMark {
   U32 sigNo;
   U32 size;
   U32 entrys ;
};
_GLOBAL void create_DBGReadTraceEndMark(const U32 _entrys, union SIGNAL **_sig);


#ifdef LITTLE_ENDIAN
void convert_DBGReadTraceEndMark(struct DBGReadTraceEndMark *_sig);
#else
#define convert_DBGReadTraceEndMark(_sig)
#endif





/*
 *===========================================================================
 * DBGTRACESENDRECEIVEREPLY
 *===========================================================================
 *
 * Description:
 * Sent as reply to DBGReadTrace.
 * Send/Receive trace entry.
  *
 * Parameters:
 *   traceEntry:    The trace entry number
 *   tick:   
 *   utick:   
 *   abstime:   
 *   abstick:   
 *   type:    4 if send, 5 if receive.
 *   fromProcType:    The type of the process.
 *   toProcType:    The type of the process.
 *   notUsed:    Align field.
 *   fromPid:   
 *   toPid:   
 *   sigSize:    The size of the signal.
 *   address:    The address of the signal. (needed ?).
 *   fromName:   
 *   toName:   
 *   data:    data always contains at least signo.
 */
#define DBGTRACESENDRECEIVEREPLY 32939   /* !-SIGNO(struct DBGTraceSendReceiveReply)-! */
struct DBGTraceSendReceiveReply {
   U32 sigNo;
   U32 size;
   U32 traceEntry ;
   U32 tick ;
   U32 utick ;
   U32 abstime ;
   U32 abstick ;
   U16 type ;
   U16 fromProcType ;
   U16 toProcType ;
   U16 notUsed ;
   U32 fromPid ;
   U32 toPid ;
   U32 sigSize ;
   U32 address ;
};
_GLOBAL void create_DBGTraceSendReceiveReply(const U32 _traceEntry, const U32 _tick, const U32 _utick, const U32 _abstime, const U32 _abstick, const U16 _type, const U16 _fromProcType, const U16 _toProcType, const U16 _notUsed, const U32 _fromPid, const U32 _toPid, const U32 _sigSize, const U32 _address, const char *_fromName, const char *_toName, const U8 *_data, U32 _dataSize, union SIGNAL **_sig);


#ifdef LITTLE_ENDIAN
void convert_DBGTraceSendReceiveReply(struct DBGTraceSendReceiveReply *_sig);
#else
#define convert_DBGTraceSendReceiveReply(_sig)
#endif


#define DBGTraceSendReceiveReply_get_fromName_size(XXsig, XXretVal) do {\
   U8 *XXptr = (U8*)XXsig + ALIGN_SIZE(52);\
   XXretVal = *(U32*)XXptr;\
}while(0)
#define DBGTraceSendReceiveReply_get_fromName(XXsig, XXretVal) do {\
   U8 *XXptr = (U8*)XXsig + ALIGN_SIZE(52);\
   XXretVal = (char*)(XXptr+4);\
}while(0)
#define DBGTraceSendReceiveReply_get_toName_size(XXsig, XXretVal) do {\
   U8 *XXptr = (U8*)XXsig + ALIGN_SIZE(52);\
   XXptr += ALIGN_SIZE( *((U32*)XXptr) ) + 4;\
   XXretVal = *(U32*)XXptr;\
}while(0)
#define DBGTraceSendReceiveReply_get_toName(XXsig, XXretVal) do {\
   U8 *XXptr = (U8*)XXsig + ALIGN_SIZE(52);\
   XXptr += ALIGN_SIZE( *((U32*)XXptr) ) + 4;\
   XXretVal = (char*)(XXptr+4);\
}while(0)
#define DBGTraceSendReceiveReply_get_data_size(XXsig, XXretVal) do {\
   U8 *XXptr = (U8*)XXsig + ALIGN_SIZE(52);\
   XXptr += ALIGN_SIZE( *((U32*)XXptr) ) + 4;\
   XXptr += ALIGN_SIZE( *((U32*)XXptr) ) + 4;\
   XXretVal = *(U32*)XXptr;\
}while(0)
#define DBGTraceSendReceiveReply_get_data(XXsig, XXretVal) do {\
   U8 *XXptr = (U8*)XXsig + ALIGN_SIZE(52);\
   XXptr += ALIGN_SIZE( *((U32*)XXptr) ) + 4;\
   XXptr += ALIGN_SIZE( *((U32*)XXptr) ) + 4;\
   XXretVal = (U8*)(XXptr+4);\
}while(0)



/*
 *===========================================================================
 * DBGTRACECREATEKILLREPLY
 *===========================================================================
 *
 * Description:
 * Sent as reply to DBGReadTrace.
 * Create/Kill trace entry.
  *
 * Parameters:
 *   traceEntry:    The trace entry number
 *   tick:   
 *   utick:   
 *   abstime:   
 *   abstick:   
 *   type:    1 if create, 2 if kill
 *   procType:    The type of the process.
 *   pid:   
 *   name:   
 */
#define DBGTRACECREATEKILLREPLY 32940   /* !-SIGNO(struct DBGTraceCreateKillReply)-! */
struct DBGTraceCreateKillReply {
   U32 sigNo;
   U32 size;
   U32 traceEntry ;
   U32 tick ;
   U32 utick ;
   U32 abstime ;
   U32 abstick ;
   U16 type ;
   U16 procType ;
   U32 pid ;
};
_GLOBAL void create_DBGTraceCreateKillReply(const U32 _traceEntry, const U32 _tick, const U32 _utick, const U32 _abstime, const U32 _abstick, const U16 _type, const U16 _procType, const U32 _pid, const char *_name, union SIGNAL **_sig);


#ifdef LITTLE_ENDIAN
void convert_DBGTraceCreateKillReply(struct DBGTraceCreateKillReply *_sig);
#else
#define convert_DBGTraceCreateKillReply(_sig)
#endif


#define DBGTraceCreateKillReply_get_name_size(XXsig, XXretVal) do {\
   U8 *XXptr = (U8*)XXsig + ALIGN_SIZE(36);\
   XXretVal = *(U32*)XXptr;\
}while(0)
#define DBGTraceCreateKillReply_get_name(XXsig, XXretVal) do {\
   U8 *XXptr = (U8*)XXsig + ALIGN_SIZE(36);\
   XXretVal = (char*)(XXptr+4);\
}while(0)



/*
 *===========================================================================
 * DBGTRACESWAPREPLY
 *===========================================================================
 *
 * Description:
 * Sent as reply to DBGReadTrace.
 * Swap trace entry.
  *
 * Parameters:
 *   traceEntry:    The trace entry number
 *   tick:   
 *   utick:   
 *   abstime:   
 *   abstick:   
 *   fromProcType:    the from proc type.
 *   toProcType:    the to proc type.
 *   fromPid:   
 *   toPid:   
 *   fromName:   
 *   toName:   
 */
#define DBGTRACESWAPREPLY 32941   /* !-SIGNO(struct DBGTraceSwapReply)-! */
struct DBGTraceSwapReply {
   U32 sigNo;
   U32 size;
   U32 traceEntry ;
   U32 tick ;
   U32 utick ;
   U32 abstime ;
   U32 abstick ;
   U16 fromProcType ;
   U16 toProcType ;
   U32 fromPid ;
   U32 toPid ;
};
_GLOBAL void create_DBGTraceSwapReply(const U32 _traceEntry, const U32 _tick, const U32 _utick, const U32 _abstime, const U32 _abstick, const U16 _fromProcType, const U16 _toProcType, const U32 _fromPid, const U32 _toPid, const char *_fromName, const char *_toName, union SIGNAL **_sig);


#ifdef LITTLE_ENDIAN
void convert_DBGTraceSwapReply(struct DBGTraceSwapReply *_sig);
#else
#define convert_DBGTraceSwapReply(_sig)
#endif


#define DBGTraceSwapReply_get_fromName_size(XXsig, XXretVal) do {\
   U8 *XXptr = (U8*)XXsig + ALIGN_SIZE(40);\
   XXretVal = *(U32*)XXptr;\
}while(0)
#define DBGTraceSwapReply_get_fromName(XXsig, XXretVal) do {\
   U8 *XXptr = (U8*)XXsig + ALIGN_SIZE(40);\
   XXretVal = (char*)(XXptr+4);\
}while(0)
#define DBGTraceSwapReply_get_toName_size(XXsig, XXretVal) do {\
   U8 *XXptr = (U8*)XXsig + ALIGN_SIZE(40);\
   XXptr += ALIGN_SIZE( *((U32*)XXptr) ) + 4;\
   XXretVal = *(U32*)XXptr;\
}while(0)
#define DBGTraceSwapReply_get_toName(XXsig, XXretVal) do {\
   U8 *XXptr = (U8*)XXsig + ALIGN_SIZE(40);\
   XXptr += ALIGN_SIZE( *((U32*)XXptr) ) + 4;\
   XXretVal = (char*)(XXptr+4);\
}while(0)



/*
 *===========================================================================
 * DBGTRACEERRORREPLY
 *===========================================================================
 *
 * Description:
 * Sent as reply to DBGReadTrace.
 * Error trace entry.
  *
 * Parameters:
 *   traceEntry:    The trace entry number
 *   tick:   
 *   utick:   
 *   abstime:   
 *   abstick:   
 *   error:   
 *   extra:   
 *   type:    6 for system error and 11 for user called error.
 *   procType:   
 *   pid:   
 *   name:   
 *   extraData:   
 */
#define DBGTRACEERRORREPLY 32942   /* !-SIGNO(struct DBGTraceErrorReply)-! */
struct DBGTraceErrorReply {
   U32 sigNo;
   U32 size;
   U32 traceEntry ;
   U32 tick ;
   U32 utick ;
   U32 abstime ;
   U32 abstick ;
   U32 error ;
   U32 extra ;
   U16 type ;
   U16 procType ;
   U32 pid ;
};
_GLOBAL void create_DBGTraceErrorReply(const U32 _traceEntry, const U32 _tick, const U32 _utick, const U32 _abstime, const U32 _abstick, const U32 _error, const U32 _extra, const U16 _type, const U16 _procType, const U32 _pid, const char *_name, const U8 *_extraData, U32 _extraDataSize, union SIGNAL **_sig);


#ifdef LITTLE_ENDIAN
void convert_DBGTraceErrorReply(struct DBGTraceErrorReply *_sig);
#else
#define convert_DBGTraceErrorReply(_sig)
#endif


#define DBGTraceErrorReply_get_name_size(XXsig, XXretVal) do {\
   U8 *XXptr = (U8*)XXsig + ALIGN_SIZE(44);\
   XXretVal = *(U32*)XXptr;\
}while(0)
#define DBGTraceErrorReply_get_name(XXsig, XXretVal) do {\
   U8 *XXptr = (U8*)XXsig + ALIGN_SIZE(44);\
   XXretVal = (char*)(XXptr+4);\
}while(0)
#define DBGTraceErrorReply_get_extraData_size(XXsig, XXretVal) do {\
   U8 *XXptr = (U8*)XXsig + ALIGN_SIZE(44);\
   XXptr += ALIGN_SIZE( *((U32*)XXptr) ) + 4;\
   XXretVal = *(U32*)XXptr;\
}while(0)
#define DBGTraceErrorReply_get_extraData(XXsig, XXretVal) do {\
   U8 *XXptr = (U8*)XXsig + ALIGN_SIZE(44);\
   XXptr += ALIGN_SIZE( *((U32*)XXptr) ) + 4;\
   XXretVal = (U8*)(XXptr+4);\
}while(0)



/*
 *===========================================================================
 * DBGTRACERESETREPLY
 *===========================================================================
 *
 * Description:
 * Sent as reply to DBGReadTrace.
 * Error trace entry.
  *
 * Parameters:
 *   traceEntry:    The trace entry number
 *   tick:   
 *   utick:   
 *   abstime:   
 *   abstick:   
 *   type:    9 for cold start and 10 for a warm start.
 */
#define DBGTRACERESETREPLY 32943   /* !-SIGNO(struct DBGTraceResetReply)-! */
struct DBGTraceResetReply {
   U32 sigNo;
   U32 size;
   U32 traceEntry ;
   U32 tick ;
   U32 utick ;
   U32 abstime ;
   U32 abstick ;
   U16 type ;
};
_GLOBAL void create_DBGTraceResetReply(const U32 _traceEntry, const U32 _tick, const U32 _utick, const U32 _abstime, const U32 _abstick, const U16 _type, union SIGNAL **_sig);


#ifdef LITTLE_ENDIAN
void convert_DBGTraceResetReply(struct DBGTraceResetReply *_sig);
#else
#define convert_DBGTraceResetReply(_sig)
#endif





/*
 *===========================================================================
 * DBGCATCHSENDRECEIVENOTIFY
 *===========================================================================
 *
 * Description:
 * Sent from the debug server to the client as part of a monitor
 * action as a result of that a monitored send accurd.
 *
 *
  *
 * Parameters:
 *   state:    The current active state
 *   eventType:    4 if send and 5 if recieve
 *   notUsed:   
 *   tick:   
 *   utick:   
 *   abstime:   
 *   abstick:   
 *   fromPid:   
 *   toPid:   
 *   signalNo:   
 *   signalId:   
 *   fromName:   
 *   toName:   
 */
#define DBGCATCHSENDRECEIVENOTIFY 32944   /* !-SIGNO(struct DBGCatchSendReceiveNotify)-! */
struct DBGCatchSendReceiveNotify {
   U32 sigNo;
   U32 size;
   U16 state ;
   U8 eventType ;
   U8 notUsed ;
   U32 tick ;
   U32 utick ;
   U32 abstime ;
   U32 abstick ;
   U32 fromPid ;
   U32 toPid ;
   U32 signalNo ;
   U32 signalId ;
};
_GLOBAL void create_DBGCatchSendReceiveNotify(const U16 _state, const U8 _eventType, const U8 _notUsed, const U32 _tick, const U32 _utick, const U32 _abstime, const U32 _abstick, const U32 _fromPid, const U32 _toPid, const U32 _signalNo, const U32 _signalId, const char *_fromName, const char *_toName, union SIGNAL **_sig);


#ifdef LITTLE_ENDIAN
void convert_DBGCatchSendReceiveNotify(struct DBGCatchSendReceiveNotify *_sig);
#else
#define convert_DBGCatchSendReceiveNotify(_sig)
#endif


#define DBGCatchSendReceiveNotify_get_fromName_size(XXsig, XXretVal) do {\
   U8 *XXptr = (U8*)XXsig + ALIGN_SIZE(44);\
   XXretVal = *(U32*)XXptr;\
}while(0)
#define DBGCatchSendReceiveNotify_get_fromName(XXsig, XXretVal) do {\
   U8 *XXptr = (U8*)XXsig + ALIGN_SIZE(44);\
   XXretVal = (char*)(XXptr+4);\
}while(0)
#define DBGCatchSendReceiveNotify_get_toName_size(XXsig, XXretVal) do {\
   U8 *XXptr = (U8*)XXsig + ALIGN_SIZE(44);\
   XXptr += ALIGN_SIZE( *((U32*)XXptr) ) + 4;\
   XXretVal = *(U32*)XXptr;\
}while(0)
#define DBGCatchSendReceiveNotify_get_toName(XXsig, XXretVal) do {\
   U8 *XXptr = (U8*)XXsig + ALIGN_SIZE(44);\
   XXptr += ALIGN_SIZE( *((U32*)XXptr) ) + 4;\
   XXretVal = (char*)(XXptr+4);\
}while(0)



/*
 *===========================================================================
 * DBGCATCHCREATEKILLNOTIFY
 *===========================================================================
 *
 * Description:
 * Sent from the debug server to the client as part of a monitor
 * action as a result of that a monitored create accurd.
 *
 *
  *
 * Parameters:
 *   state:    The current active state
 *   eventType:    1 if create 2 if kill
 *   notUsed:   
 *   procType:   
 *   bid:   
 *   tick:   
 *   utick:   
 *   abstime:   
 *   abstick:   
 *   creatorPid:   
 *   pid:   
 *   name:   
 */
#define DBGCATCHCREATEKILLNOTIFY 32945   /* !-SIGNO(struct DBGCatchCreateKillNotify)-! */
struct DBGCatchCreateKillNotify {
   U32 sigNo;
   U32 size;
   U16 state ;
   U8 eventType ;
   U8 notUsed ;
   U32 procType ;
   U32 bid ;
   U32 tick ;
   U32 utick ;
   U32 abstime ;
   U32 abstick ;
   U32 creatorPid ;
   U32 pid ;
};
_GLOBAL void create_DBGCatchCreateKillNotify(const U16 _state, const U8 _eventType, const U8 _notUsed, const U32 _procType, const U32 _bid, const U32 _tick, const U32 _utick, const U32 _abstime, const U32 _abstick, const U32 _creatorPid, const U32 _pid, const char *_name, union SIGNAL **_sig);


#ifdef LITTLE_ENDIAN
void convert_DBGCatchCreateKillNotify(struct DBGCatchCreateKillNotify *_sig);
#else
#define convert_DBGCatchCreateKillNotify(_sig)
#endif


#define DBGCatchCreateKillNotify_get_name_size(XXsig, XXretVal) do {\
   U8 *XXptr = (U8*)XXsig + ALIGN_SIZE(44);\
   XXretVal = *(U32*)XXptr;\
}while(0)
#define DBGCatchCreateKillNotify_get_name(XXsig, XXretVal) do {\
   U8 *XXptr = (U8*)XXsig + ALIGN_SIZE(44);\
   XXretVal = (char*)(XXptr+4);\
}while(0)



/*
 *===========================================================================
 * DBGCATCHSWAPNOTIFY
 *===========================================================================
 *
 * Description:
 * Sent from the debug server to the client as part of a monitor
 * action as a result of that a monitored context switch accurd.
 *
 *
  *
 * Parameters:
 *   state:    The current active state
 *   notUsed:   
 *   tick:   
 *   utick:   
 *   abstime:   
 *   abstick:   
 *   fromPid:   
 *   toPid:   
 *   fromName:   
 *   toName:   
 */
#define DBGCATCHSWAPNOTIFY 32946   /* !-SIGNO(struct DBGCatchSwapNotify)-! */
struct DBGCatchSwapNotify {
   U32 sigNo;
   U32 size;
   U16 state ;
   U16 notUsed ;
   U32 tick ;
   U32 utick ;
   U32 abstime ;
   U32 abstick ;
   U32 fromPid ;
   U32 toPid ;
};
_GLOBAL void create_DBGCatchSwapNotify(const U16 _state, const U16 _notUsed, const U32 _tick, const U32 _utick, const U32 _abstime, const U32 _abstick, const U32 _fromPid, const U32 _toPid, const char *_fromName, const char *_toName, union SIGNAL **_sig);


#ifdef LITTLE_ENDIAN
void convert_DBGCatchSwapNotify(struct DBGCatchSwapNotify *_sig);
#else
#define convert_DBGCatchSwapNotify(_sig)
#endif


#define DBGCatchSwapNotify_get_fromName_size(XXsig, XXretVal) do {\
   U8 *XXptr = (U8*)XXsig + ALIGN_SIZE(36);\
   XXretVal = *(U32*)XXptr;\
}while(0)
#define DBGCatchSwapNotify_get_fromName(XXsig, XXretVal) do {\
   U8 *XXptr = (U8*)XXsig + ALIGN_SIZE(36);\
   XXretVal = (char*)(XXptr+4);\
}while(0)
#define DBGCatchSwapNotify_get_toName_size(XXsig, XXretVal) do {\
   U8 *XXptr = (U8*)XXsig + ALIGN_SIZE(36);\
   XXptr += ALIGN_SIZE( *((U32*)XXptr) ) + 4;\
   XXretVal = *(U32*)XXptr;\
}while(0)
#define DBGCatchSwapNotify_get_toName(XXsig, XXretVal) do {\
   U8 *XXptr = (U8*)XXsig + ALIGN_SIZE(36);\
   XXptr += ALIGN_SIZE( *((U32*)XXptr) ) + 4;\
   XXretVal = (char*)(XXptr+4);\
}while(0)



/*
 *===========================================================================
 * DBGCATCHERRORNOTIFY
 *===========================================================================
 *
 * Description:
 * Sent from the debug server to the client as part of a monitor
 * action as a result of that a monitored user error accurd.
 *
 *
  *
 * Parameters:
 *   state:    The current active state
 *   eventType:    6 for system error 11 for user called.
 *   notUsed:   
 *   tick:   
 *   utick:   
 *   abstime:   
 *   abstick:   
 *   error:   
 *   extra:   
 *   pid:   
 *   name:    process name
 *   miscInfo:   
 */
#define DBGCATCHERRORNOTIFY 32947   /* !-SIGNO(struct DBGCatchErrorNotify)-! */
struct DBGCatchErrorNotify {
   U32 sigNo;
   U32 size;
   U16 state ;
   U8 eventType ;
   U8 notUsed ;
   U32 tick ;
   U32 utick ;
   U32 abstime ;
   U32 abstick ;
   U32 error ;
   U32 extra ;
   U32 pid ;
};
_GLOBAL void create_DBGCatchErrorNotify(const U16 _state, const U8 _eventType, const U8 _notUsed, const U32 _tick, const U32 _utick, const U32 _abstime, const U32 _abstick, const U32 _error, const U32 _extra, const U32 _pid, const char *_name, const char *_miscInfo, union SIGNAL **_sig);


#ifdef LITTLE_ENDIAN
void convert_DBGCatchErrorNotify(struct DBGCatchErrorNotify *_sig);
#else
#define convert_DBGCatchErrorNotify(_sig)
#endif


#define DBGCatchErrorNotify_get_name_size(XXsig, XXretVal) do {\
   U8 *XXptr = (U8*)XXsig + ALIGN_SIZE(40);\
   XXretVal = *(U32*)XXptr;\
}while(0)
#define DBGCatchErrorNotify_get_name(XXsig, XXretVal) do {\
   U8 *XXptr = (U8*)XXsig + ALIGN_SIZE(40);\
   XXretVal = (char*)(XXptr+4);\
}while(0)
#define DBGCatchErrorNotify_get_miscInfo_size(XXsig, XXretVal) do {\
   U8 *XXptr = (U8*)XXsig + ALIGN_SIZE(40);\
   XXptr += ALIGN_SIZE( *((U32*)XXptr) ) + 4;\
   XXretVal = *(U32*)XXptr;\
}while(0)
#define DBGCatchErrorNotify_get_miscInfo(XXsig, XXretVal) do {\
   U8 *XXptr = (U8*)XXsig + ALIGN_SIZE(40);\
   XXptr += ALIGN_SIZE( *((U32*)XXptr) ) + 4;\
   XXretVal = (char*)(XXptr+4);\
}while(0)



/*
 *===========================================================================
 * DBGGOTONOTIFY
 *===========================================================================
 *
 * Description:
  *
 * Parameters:
 *   state:    The current active state
 */
#define DBGGOTONOTIFY 32948   /* !-SIGNO(struct DBGGotoNotify)-! */
struct DBGGotoNotify {
   U32 sigNo;
   U32 size;
   U32 state ;
};
_GLOBAL void create_DBGGotoNotify(const U32 _state, union SIGNAL **_sig);


#ifdef LITTLE_ENDIAN
void convert_DBGGotoNotify(struct DBGGotoNotify *_sig);
#else
#define convert_DBGGotoNotify(_sig)
#endif





/*
 *===========================================================================
 * DBGGETCATCHSCOPESTATUS
 *===========================================================================
 *
 * Description:
 * Ask for the catch scope status (running or halted).
  *
 * Parameters:
 */
#define DBGGETCATCHSCOPESTATUS 32949   /* !-SIGNO(struct DBGGetCatchScopeStatus)-! */
struct DBGGetCatchScopeStatus {
   U32 sigNo;
   U32 size;
};
#ifdef IS_DBGSERVER_CLIENT
_GLOBAL void create_DBGGetCatchScopeStatus(union SIGNAL **_sig);
#endif


#ifdef LITTLE_ENDIAN
void convert_DBGGetCatchScopeStatus(struct DBGGetCatchScopeStatus *_sig);
#else
#define convert_DBGGetCatchScopeStatus(_sig)
#endif





/*
 *===========================================================================
 * DBGGETCATCHSCOPESTATUSREPLY
 *===========================================================================
 *
 * Description:
 * Ask for the catch scope status (running or halted).
  *
 * Parameters:
 *   status:    0 if halted and 1 if intercepted.
 */
#define DBGGETCATCHSCOPESTATUSREPLY 32950   /* !-SIGNO(struct DBGGetCatchScopeStatusReply)-! */
struct DBGGetCatchScopeStatusReply {
   U32 sigNo;
   U32 size;
   U8 status ;
};
_GLOBAL void create_DBGGetCatchScopeStatusReply(const U8 _status, union SIGNAL **_sig);


#ifdef LITTLE_ENDIAN
void convert_DBGGetCatchScopeStatusReply(struct DBGGetCatchScopeStatusReply *_sig);
#else
#define convert_DBGGetCatchScopeStatusReply(_sig)
#endif





/*
 *===========================================================================
 * DBGGETPOOLINFO
 *===========================================================================
 *
 * Description:
 * Sent from the debugger client to the debug server to get
 * pool information for specified pool. The signal
 * DBGGetPoolInfoReply is sent from the server as reply.
  *
 * Parameters:
 *   pid:    The pid of the pool
 */
#define DBGGETPOOLINFO 32951   /* !-SIGNO(struct DBGGetPoolInfo)-! */
struct DBGGetPoolInfo {
   U32 sigNo;
   U32 size;
   U32 pid ;
};
#ifdef IS_DBGSERVER_CLIENT
_GLOBAL void create_DBGGetPoolInfo(const U32 _pid, union SIGNAL **_sig);
#endif


#ifdef LITTLE_ENDIAN
void convert_DBGGetPoolInfo(struct DBGGetPoolInfo *_sig);
#else
#define convert_DBGGetPoolInfo(_sig)
#endif





/*
 *===========================================================================
 * DBGGETPOOLINFOREPLY
 *===========================================================================
 *
 * Description:
 * Sent from the debug server to the debugger client as a reply
 * to DBGGetPoolInfo
  *
 * Parameters:
 *   pid:    The pid of the pool that the info is for.
 *   totSize:    total memory size (in bytes) of all pool fragments
 *   freeSize:    Number of bytes available in pool (does not incl. free buffers)
 *   frBaseAddr:    Base addresses of all fragments 0..noFragments-1
 *   frSize:    Sizes of all fragments 0..noFragments-1
 *   frUsedStk:    Bytes used for stacks of all fragments 0..noFragments-1
 *   frUsedSig:    Bytes used for signals of all fragments 0..noFragments-1
 *   stkConfSizes:    Configured stack buffer sizes
 *   sigConfSizes:    Configured signal buffer sizes
 *   stkAllocSizes:    No of currently allocated stack buffers for each size
 *   sigAllocSizes:    No of currently allocated signal buffers for each size
 *   stkFreeSizes:    No of currently free stack buffers for each size
 *   sigFreeSizes:    No of currently free signal buffers for each size
 */
#define DBGGETPOOLINFOREPLY 32952   /* !-SIGNO(struct DBGGetPoolInfoReply)-! */
struct DBGGetPoolInfoReply {
   U32 sigNo;
   U32 size;
   U32 pid ;
   U32 totSize ;
   U32 freeSize ;
};
_GLOBAL void create_DBGGetPoolInfoReply(const U32 _pid, const U32 _totSize, const U32 _freeSize, const U32 *_frBaseAddr, U32 _frBaseAddrSize, const U32 *_frSize, U32 _frSizeSize, const U32 *_frUsedStk, U32 _frUsedStkSize, const U32 *_frUsedSig, U32 _frUsedSigSize, const U32 *_stkConfSizes, U32 _stkConfSizesSize, const U32 *_sigConfSizes, U32 _sigConfSizesSize, const U32 *_stkAllocSizes, U32 _stkAllocSizesSize, const U32 *_sigAllocSizes, U32 _sigAllocSizesSize, const U32 *_stkFreeSizes, U32 _stkFreeSizesSize, const U32 *_sigFreeSizes, U32 _sigFreeSizesSize, union SIGNAL **_sig);


#ifdef LITTLE_ENDIAN
void convert_DBGGetPoolInfoReply(struct DBGGetPoolInfoReply *_sig);
#else
#define convert_DBGGetPoolInfoReply(_sig)
#endif


#define DBGGetPoolInfoReply_get_frBaseAddr_size(XXsig, XXretVal) do {\
   U8 *XXptr = (U8*)XXsig + ALIGN_SIZE(20);\
   XXretVal = *(U32*)XXptr;\
}while(0)
#define DBGGetPoolInfoReply_get_frBaseAddr(XXsig, XXretVal) do {\
   U8 *XXptr = (U8*)XXsig + ALIGN_SIZE(20);\
   XXretVal = (U32*)(XXptr+4);\
}while(0)
#define DBGGetPoolInfoReply_get_frSize_size(XXsig, XXretVal) do {\
   U8 *XXptr = (U8*)XXsig + ALIGN_SIZE(20);\
   XXptr += ALIGN_SIZE( *((U32*)XXptr) ) + 4;\
   XXretVal = *(U32*)XXptr;\
}while(0)
#define DBGGetPoolInfoReply_get_frSize(XXsig, XXretVal) do {\
   U8 *XXptr = (U8*)XXsig + ALIGN_SIZE(20);\
   XXptr += ALIGN_SIZE( *((U32*)XXptr) ) + 4;\
   XXretVal = (U32*)(XXptr+4);\
}while(0)
#define DBGGetPoolInfoReply_get_frUsedStk_size(XXsig, XXretVal) do {\
   U8 *XXptr = (U8*)XXsig + ALIGN_SIZE(20);\
   XXptr += ALIGN_SIZE( *((U32*)XXptr) ) + 4;\
   XXptr += ALIGN_SIZE( *((U32*)XXptr) ) + 4;\
   XXretVal = *(U32*)XXptr;\
}while(0)
#define DBGGetPoolInfoReply_get_frUsedStk(XXsig, XXretVal) do {\
   U8 *XXptr = (U8*)XXsig + ALIGN_SIZE(20);\
   XXptr += ALIGN_SIZE( *((U32*)XXptr) ) + 4;\
   XXptr += ALIGN_SIZE( *((U32*)XXptr) ) + 4;\
   XXretVal = (U32*)(XXptr+4);\
}while(0)
#define DBGGetPoolInfoReply_get_frUsedSig_size(XXsig, XXretVal) do {\
   U8 *XXptr = (U8*)XXsig + ALIGN_SIZE(20);\
   XXptr += ALIGN_SIZE( *((U32*)XXptr) ) + 4;\
   XXptr += ALIGN_SIZE( *((U32*)XXptr) ) + 4;\
   XXptr += ALIGN_SIZE( *((U32*)XXptr) ) + 4;\
   XXretVal = *(U32*)XXptr;\
}while(0)
#define DBGGetPoolInfoReply_get_frUsedSig(XXsig, XXretVal) do {\
   U8 *XXptr = (U8*)XXsig + ALIGN_SIZE(20);\
   XXptr += ALIGN_SIZE( *((U32*)XXptr) ) + 4;\
   XXptr += ALIGN_SIZE( *((U32*)XXptr) ) + 4;\
   XXptr += ALIGN_SIZE( *((U32*)XXptr) ) + 4;\
   XXretVal = (U32*)(XXptr+4);\
}while(0)
#define DBGGetPoolInfoReply_get_stkConfSizes_size(XXsig, XXretVal) do {\
   U8 *XXptr = (U8*)XXsig + ALIGN_SIZE(20);\
   XXptr += ALIGN_SIZE( *((U32*)XXptr) ) + 4;\
   XXptr += ALIGN_SIZE( *((U32*)XXptr) ) + 4;\
   XXptr += ALIGN_SIZE( *((U32*)XXptr) ) + 4;\
   XXptr += ALIGN_SIZE( *((U32*)XXptr) ) + 4;\
   XXretVal = *(U32*)XXptr;\
}while(0)
#define DBGGetPoolInfoReply_get_stkConfSizes(XXsig, XXretVal) do {\
   U8 *XXptr = (U8*)XXsig + ALIGN_SIZE(20);\
   XXptr += ALIGN_SIZE( *((U32*)XXptr) ) + 4;\
   XXptr += ALIGN_SIZE( *((U32*)XXptr) ) + 4;\
   XXptr += ALIGN_SIZE( *((U32*)XXptr) ) + 4;\
   XXptr += ALIGN_SIZE( *((U32*)XXptr) ) + 4;\
   XXretVal = (U32*)(XXptr+4);\
}while(0)
#define DBGGetPoolInfoReply_get_sigConfSizes_size(XXsig, XXretVal) do {\
   U8 *XXptr = (U8*)XXsig + ALIGN_SIZE(20);\
   XXptr += ALIGN_SIZE( *((U32*)XXptr) ) + 4;\
   XXptr += ALIGN_SIZE( *((U32*)XXptr) ) + 4;\
   XXptr += ALIGN_SIZE( *((U32*)XXptr) ) + 4;\
   XXptr += ALIGN_SIZE( *((U32*)XXptr) ) + 4;\
   XXptr += ALIGN_SIZE( *((U32*)XXptr) ) + 4;\
   XXretVal = *(U32*)XXptr;\
}while(0)
#define DBGGetPoolInfoReply_get_sigConfSizes(XXsig, XXretVal) do {\
   U8 *XXptr = (U8*)XXsig + ALIGN_SIZE(20);\
   XXptr += ALIGN_SIZE( *((U32*)XXptr) ) + 4;\
   XXptr += ALIGN_SIZE( *((U32*)XXptr) ) + 4;\
   XXptr += ALIGN_SIZE( *((U32*)XXptr) ) + 4;\
   XXptr += ALIGN_SIZE( *((U32*)XXptr) ) + 4;\
   XXptr += ALIGN_SIZE( *((U32*)XXptr) ) + 4;\
   XXretVal = (U32*)(XXptr+4);\
}while(0)
#define DBGGetPoolInfoReply_get_stkAllocSizes_size(XXsig, XXretVal) do {\
   U8 *XXptr = (U8*)XXsig + ALIGN_SIZE(20);\
   XXptr += ALIGN_SIZE( *((U32*)XXptr) ) + 4;\
   XXptr += ALIGN_SIZE( *((U32*)XXptr) ) + 4;\
   XXptr += ALIGN_SIZE( *((U32*)XXptr) ) + 4;\
   XXptr += ALIGN_SIZE( *((U32*)XXptr) ) + 4;\
   XXptr += ALIGN_SIZE( *((U32*)XXptr) ) + 4;\
   XXptr += ALIGN_SIZE( *((U32*)XXptr) ) + 4;\
   XXretVal = *(U32*)XXptr;\
}while(0)
#define DBGGetPoolInfoReply_get_stkAllocSizes(XXsig, XXretVal) do {\
   U8 *XXptr = (U8*)XXsig + ALIGN_SIZE(20);\
   XXptr += ALIGN_SIZE( *((U32*)XXptr) ) + 4;\
   XXptr += ALIGN_SIZE( *((U32*)XXptr) ) + 4;\
   XXptr += ALIGN_SIZE( *((U32*)XXptr) ) + 4;\
   XXptr += ALIGN_SIZE( *((U32*)XXptr) ) + 4;\
   XXptr += ALIGN_SIZE( *((U32*)XXptr) ) + 4;\
   XXptr += ALIGN_SIZE( *((U32*)XXptr) ) + 4;\
   XXretVal = (U32*)(XXptr+4);\
}while(0)
#define DBGGetPoolInfoReply_get_sigAllocSizes_size(XXsig, XXretVal) do {\
   U8 *XXptr = (U8*)XXsig + ALIGN_SIZE(20);\
   XXptr += ALIGN_SIZE( *((U32*)XXptr) ) + 4;\
   XXptr += ALIGN_SIZE( *((U32*)XXptr) ) + 4;\
   XXptr += ALIGN_SIZE( *((U32*)XXptr) ) + 4;\
   XXptr += ALIGN_SIZE( *((U32*)XXptr) ) + 4;\
   XXptr += ALIGN_SIZE( *((U32*)XXptr) ) + 4;\
   XXptr += ALIGN_SIZE( *((U32*)XXptr) ) + 4;\
   XXptr += ALIGN_SIZE( *((U32*)XXptr) ) + 4;\
   XXretVal = *(U32*)XXptr;\
}while(0)
#define DBGGetPoolInfoReply_get_sigAllocSizes(XXsig, XXretVal) do {\
   U8 *XXptr = (U8*)XXsig + ALIGN_SIZE(20);\
   XXptr += ALIGN_SIZE( *((U32*)XXptr) ) + 4;\
   XXptr += ALIGN_SIZE( *((U32*)XXptr) ) + 4;\
   XXptr += ALIGN_SIZE( *((U32*)XXptr) ) + 4;\
   XXptr += ALIGN_SIZE( *((U32*)XXptr) ) + 4;\
   XXptr += ALIGN_SIZE( *((U32*)XXptr) ) + 4;\
   XXptr += ALIGN_SIZE( *((U32*)XXptr) ) + 4;\
   XXptr += ALIGN_SIZE( *((U32*)XXptr) ) + 4;\
   XXretVal = (U32*)(XXptr+4);\
}while(0)
#define DBGGetPoolInfoReply_get_stkFreeSizes_size(XXsig, XXretVal) do {\
   U8 *XXptr = (U8*)XXsig + ALIGN_SIZE(20);\
   XXptr += ALIGN_SIZE( *((U32*)XXptr) ) + 4;\
   XXptr += ALIGN_SIZE( *((U32*)XXptr) ) + 4;\
   XXptr += ALIGN_SIZE( *((U32*)XXptr) ) + 4;\
   XXptr += ALIGN_SIZE( *((U32*)XXptr) ) + 4;\
   XXptr += ALIGN_SIZE( *((U32*)XXptr) ) + 4;\
   XXptr += ALIGN_SIZE( *((U32*)XXptr) ) + 4;\
   XXptr += ALIGN_SIZE( *((U32*)XXptr) ) + 4;\
   XXptr += ALIGN_SIZE( *((U32*)XXptr) ) + 4;\
   XXretVal = *(U32*)XXptr;\
}while(0)
#define DBGGetPoolInfoReply_get_stkFreeSizes(XXsig, XXretVal) do {\
   U8 *XXptr = (U8*)XXsig + ALIGN_SIZE(20);\
   XXptr += ALIGN_SIZE( *((U32*)XXptr) ) + 4;\
   XXptr += ALIGN_SIZE( *((U32*)XXptr) ) + 4;\
   XXptr += ALIGN_SIZE( *((U32*)XXptr) ) + 4;\
   XXptr += ALIGN_SIZE( *((U32*)XXptr) ) + 4;\
   XXptr += ALIGN_SIZE( *((U32*)XXptr) ) + 4;\
   XXptr += ALIGN_SIZE( *((U32*)XXptr) ) + 4;\
   XXptr += ALIGN_SIZE( *((U32*)XXptr) ) + 4;\
   XXptr += ALIGN_SIZE( *((U32*)XXptr) ) + 4;\
   XXretVal = (U32*)(XXptr+4);\
}while(0)
#define DBGGetPoolInfoReply_get_sigFreeSizes_size(XXsig, XXretVal) do {\
   U8 *XXptr = (U8*)XXsig + ALIGN_SIZE(20);\
   XXptr += ALIGN_SIZE( *((U32*)XXptr) ) + 4;\
   XXptr += ALIGN_SIZE( *((U32*)XXptr) ) + 4;\
   XXptr += ALIGN_SIZE( *((U32*)XXptr) ) + 4;\
   XXptr += ALIGN_SIZE( *((U32*)XXptr) ) + 4;\
   XXptr += ALIGN_SIZE( *((U32*)XXptr) ) + 4;\
   XXptr += ALIGN_SIZE( *((U32*)XXptr) ) + 4;\
   XXptr += ALIGN_SIZE( *((U32*)XXptr) ) + 4;\
   XXptr += ALIGN_SIZE( *((U32*)XXptr) ) + 4;\
   XXptr += ALIGN_SIZE( *((U32*)XXptr) ) + 4;\
   XXretVal = *(U32*)XXptr;\
}while(0)
#define DBGGetPoolInfoReply_get_sigFreeSizes(XXsig, XXretVal) do {\
   U8 *XXptr = (U8*)XXsig + ALIGN_SIZE(20);\
   XXptr += ALIGN_SIZE( *((U32*)XXptr) ) + 4;\
   XXptr += ALIGN_SIZE( *((U32*)XXptr) ) + 4;\
   XXptr += ALIGN_SIZE( *((U32*)XXptr) ) + 4;\
   XXptr += ALIGN_SIZE( *((U32*)XXptr) ) + 4;\
   XXptr += ALIGN_SIZE( *((U32*)XXptr) ) + 4;\
   XXptr += ALIGN_SIZE( *((U32*)XXptr) ) + 4;\
   XXptr += ALIGN_SIZE( *((U32*)XXptr) ) + 4;\
   XXptr += ALIGN_SIZE( *((U32*)XXptr) ) + 4;\
   XXptr += ALIGN_SIZE( *((U32*)XXptr) ) + 4;\
   XXretVal = (U32*)(XXptr+4);\
}while(0)



/*
 *===========================================================================
 * DBGINFOPOOLENDMARK
 *===========================================================================
 *
 * Description:
 *
 * Sent by the debug server as the last signal in a pool info
 * request which can yield into several reply signals.
 *
  *
 * Parameters:
 */
#define DBGINFOPOOLENDMARK 32953   /* !-SIGNO(struct DBGInfoPoolEndMark)-! */
struct DBGInfoPoolEndMark {
   U32 sigNo;
   U32 size;
};
_GLOBAL void create_DBGInfoPoolEndMark(union SIGNAL **_sig);


#ifdef LITTLE_ENDIAN
void convert_DBGInfoPoolEndMark(struct DBGInfoPoolEndMark *_sig);
#else
#define convert_DBGInfoPoolEndMark(_sig)
#endif





/*
 *===========================================================================
 * DBGGETPOOLSIGNALS
 *===========================================================================
 *
 * Description:
 * Sent from the debugger client to the debug server to get
 * pool signal information for specified pool. The signal
 * DBGGetPoolSignalsReply is sent from the server as reply.
  *
 * Parameters:
 *   pid:    The pid of the pool
 *   filter:    A filter that is used to select a subset in the pool
 */
#define DBGGETPOOLSIGNALS 32954   /* !-SIGNO(struct DBGGetPoolSignals)-! */
struct DBGGetPoolSignals {
   U32 sigNo;
   U32 size;
   U32 pid ;
};
#ifdef IS_DBGSERVER_CLIENT
_GLOBAL void create_DBGGetPoolSignals(const U32 _pid, const char *_filter, union SIGNAL **_sig);
#endif


#ifdef LITTLE_ENDIAN
void convert_DBGGetPoolSignals(struct DBGGetPoolSignals *_sig);
#else
#define convert_DBGGetPoolSignals(_sig)
#endif


#define DBGGetPoolSignals_get_filter_size(XXsig, XXretVal) do {\
   U8 *XXptr = (U8*)XXsig + ALIGN_SIZE(12);\
   XXretVal = *(U32*)XXptr;\
}while(0)
#define DBGGetPoolSignals_get_filter(XXsig, XXretVal) do {\
   U8 *XXptr = (U8*)XXsig + ALIGN_SIZE(12);\
   XXretVal = (char*)(XXptr+4);\
}while(0)



/*
 *===========================================================================
 * DBGGETPOOLSIGNALSREPLY
 *===========================================================================
 *
 * Description:
 * Sent from the debug server to the debugger client as a reply
 * to DBGGetPoolSignals
 * Signals are grouped with 8 fields:
 * sig_no, owner, sender, addressee, sigsize, size_in_pool, sigptr and sigstatus
  *
 * Parameters:
 *   pid:    The pid of the pool that the info is for.
 *   data:    An array, where signal info contains eight entries
 */
#define DBGGETPOOLSIGNALSREPLY 32955   /* !-SIGNO(struct DBGGetPoolSignalsReply)-! */
struct DBGGetPoolSignalsReply {
   U32 sigNo;
   U32 size;
   U32 pid ;
};
_GLOBAL void create_DBGGetPoolSignalsReply(const U32 _pid, const U32 *_data, U32 _dataSize, union SIGNAL **_sig);


#ifdef LITTLE_ENDIAN
void convert_DBGGetPoolSignalsReply(struct DBGGetPoolSignalsReply *_sig);
#else
#define convert_DBGGetPoolSignalsReply(_sig)
#endif


#define DBGGetPoolSignalsReply_get_data_size(XXsig, XXretVal) do {\
   U8 *XXptr = (U8*)XXsig + ALIGN_SIZE(12);\
   XXretVal = *(U32*)XXptr;\
}while(0)
#define DBGGetPoolSignalsReply_get_data(XXsig, XXretVal) do {\
   U8 *XXptr = (U8*)XXsig + ALIGN_SIZE(12);\
   XXretVal = (U32*)(XXptr+4);\
}while(0)



/*
 *===========================================================================
 * DBGPOOLSIGNALSENDMARK
 *===========================================================================
 *
 * Description:
 *
 * Sent by the debug server as the last signal in a pool info
 * request which can yield into several reply signals.
 *
  *
 * Parameters:
 *   pid:    The pid of the pool that the info is for.
 */
#define DBGPOOLSIGNALSENDMARK 32956   /* !-SIGNO(struct DBGPoolSignalsEndMark)-! */
struct DBGPoolSignalsEndMark {
   U32 sigNo;
   U32 size;
   U32 pid ;
};
_GLOBAL void create_DBGPoolSignalsEndMark(const U32 _pid, union SIGNAL **_sig);


#ifdef LITTLE_ENDIAN
void convert_DBGPoolSignalsEndMark(struct DBGPoolSignalsEndMark *_sig);
#else
#define convert_DBGPoolSignalsEndMark(_sig)
#endif





/*
 *===========================================================================
 * DBGMONITORENABLE
 *===========================================================================
 *
 * Description:
 * Sent from the debugger client to the debug server to enable
 * monitor (monitor is by defualt disabled).
  *
 * Parameters:
 *   wantProcessInfo:    If true the debug server will besides enabling
                         * monitoring respond with all processes wich is
                         * currently in the monitor scope. They are sent in
                         * the DBGMONITOR_CREATE signal and a end mark
                         * signal are sent as well.
                         
 */
#define DBGMONITORENABLE 32957   /* !-SIGNO(struct DBGMonitorEnable)-! */
struct DBGMonitorEnable {
   U32 sigNo;
   U32 size;
   U32 wantProcessInfo ;
};
#ifdef IS_DBGSERVER_CLIENT
_GLOBAL void create_DBGMonitorEnable(const U32 _wantProcessInfo, union SIGNAL **_sig);
#endif


#ifdef LITTLE_ENDIAN
void convert_DBGMonitorEnable(struct DBGMonitorEnable *_sig);
#else
#define convert_DBGMonitorEnable(_sig)
#endif





/*
 *===========================================================================
 * DBGMONITORDISABLE
 *===========================================================================
 *
 * Description:
 * Sent from the debugger client to the debug server to disable
 * monitor (monitor is by defualt disabled).
 *
  *
 * Parameters:
 */
#define DBGMONITORDISABLE 32958   /* !-SIGNO(struct DBGMonitorDisable)-! */
struct DBGMonitorDisable {
   U32 sigNo;
   U32 size;
};
#ifdef IS_DBGSERVER_CLIENT
_GLOBAL void create_DBGMonitorDisable(union SIGNAL **_sig);
#endif


#ifdef LITTLE_ENDIAN
void convert_DBGMonitorDisable(struct DBGMonitorDisable *_sig);
#else
#define convert_DBGMonitorDisable(_sig)
#endif





/*
 *===========================================================================
 * DBGGETPROCESSINFO
 *===========================================================================
 *
 * Description:
 * This signal requests a list of processes which matches
 * the wild card pattern in processNames.
 *
 * Reply signal: DBGGET_PROCESS_INFO_REPLY.
  *
 * Parameters:
 *   fullInfo:   
 *   pid:   
 */
#define DBGGETPROCESSINFO 32959   /* !-SIGNO(struct DBGGetProcessInfo)-! */
struct DBGGetProcessInfo {
   U32 sigNo;
   U32 size;
   U32 fullInfo ;
   U32 pid ;
};
#ifdef IS_DBGSERVER_CLIENT
_GLOBAL void create_DBGGetProcessInfo(const U32 _fullInfo, const U32 _pid, union SIGNAL **_sig);
#endif


#ifdef LITTLE_ENDIAN
void convert_DBGGetProcessInfo(struct DBGGetProcessInfo *_sig);
#else
#define convert_DBGGetProcessInfo(_sig)
#endif





/*
 *===========================================================================
 * DBGGETBLOCKPROCINFO
 *===========================================================================
 *
 * Description:
 * This signal requests a list of processes for a specific block.
 * Reply signal: DBGGET_PROCESS_INFO_REPLY.
  *
 * Parameters:
 *   bid:    Block id of the block to list procs in.
 *   fullInfo:   
 */
#define DBGGETBLOCKPROCINFO 32960   /* !-SIGNO(struct DBGGetBlockProcInfo)-! */
struct DBGGetBlockProcInfo {
   U32 sigNo;
   U32 size;
   U32 bid ;
   U32 fullInfo ;
};
#ifdef IS_DBGSERVER_CLIENT
_GLOBAL void create_DBGGetBlockProcInfo(const U32 _bid, const U32 _fullInfo, union SIGNAL **_sig);
#endif


#ifdef LITTLE_ENDIAN
void convert_DBGGetBlockProcInfo(struct DBGGetBlockProcInfo *_sig);
#else
#define convert_DBGGetBlockProcInfo(_sig)
#endif





/*
 *===========================================================================
 * DBGGETPROCESSINFOREPLY
 *===========================================================================
 *
 * Description:
 * Sent as reply to DBGGET_PROCESS_INFO or DBGGET_BLOCK_PROC_INFO
 * (any number of signals).
 * Flow control: YES
 * Asyncron: NO
 *
  *
 * Parameters:
 *   pid:   
 *   bid:   
 *   parent:   
 *   procType:   
 *   status:   
 *   priority:   
 *   unused1:   
 *   unused2:   
 *   processName:   
 */
#define DBGGETPROCESSINFOREPLY 32961   /* !-SIGNO(struct DBGGetProcessInfoReply)-! */
struct DBGGetProcessInfoReply {
   U32 sigNo;
   U32 size;
   U32 pid ;
   U32 bid ;
   U32 parent ;
   U16 procType ;
   U16 status ;
   U16 priority ;
   U8 unused1 ;
   U8 unused2 ;
};
_GLOBAL void create_DBGGetProcessInfoReply(const U32 _pid, const U32 _bid, const U32 _parent, const U16 _procType, const U16 _status, const U16 _priority, const U8 _unused1, const U8 _unused2, const char *_processName, union SIGNAL **_sig);


#ifdef LITTLE_ENDIAN
void convert_DBGGetProcessInfoReply(struct DBGGetProcessInfoReply *_sig);
#else
#define convert_DBGGetProcessInfoReply(_sig)
#endif


#define DBGGetProcessInfoReply_get_processName_size(XXsig, XXretVal) do {\
   U8 *XXptr = (U8*)XXsig + ALIGN_SIZE(28);\
   XXretVal = *(U32*)XXptr;\
}while(0)
#define DBGGetProcessInfoReply_get_processName(XXsig, XXretVal) do {\
   U8 *XXptr = (U8*)XXsig + ALIGN_SIZE(28);\
   XXretVal = (char*)(XXptr+4);\
}while(0)



/*
 *===========================================================================
 * DBGGETPROCESSFULLINFOREPLY
 *===========================================================================
 *
 * Description:
 * Sent as reply to DBGGET_PROCESS_INFO or DBGGET_BLOCK_PROC_INFO
 * if fullInfo flag is true (=1). Any number of signals may be
 * sent and the last signal i a DBGINFO_END_MARK signal.
  *
 * Parameters:
 *   pid:    Pid of the process.
 *   bid:    Bid of the processes block.
 *   parent:    Pid of this process creator.
 *   userId:    The user i of this process.
 *   procType:    Process type (see defines above).
 *   status:   
 *   priority:    If valid for process type, this field contains the priority of the process.
 *   signalsInQueue:    Number of signals in the receive queue.
 *   entryPoint:   
 *   createTimeTick:   
 *   createTimeUTick:   
 *   fsemValue:   The value of the fsem counter.
 *   stackSize:   The stack size of this process.
 *   lineNumber:    If the process is in a system call and the source
                         * is compiled with OS_DEBUG defined this is the
                         * lineNumber
                         
 *   signalBuffers:    Number of signal buffers owned.
 *   wantedSignals:   
 *   processName:   
 *   fileName:   
 *   CPURegisters:   
 */
#define DBGGETPROCESSFULLINFOREPLY 32962   /* !-SIGNO(struct DBGGetProcessFullInfoReply)-! */
struct DBGGetProcessFullInfoReply {
   U32 sigNo;
   U32 size;
   U32 pid ;
   U32 bid ;
   U32 parent ;
   U32 userId ;
   U16 procType ;
   U16 status ;
   U16 priority ;
   U16 signalsInQueue ;
   U32 entryPoint ;
   U32 createTimeTick ;
   U32 createTimeUTick ;
   U32 fsemValue ;
   U32 stackSize ;
   U32 lineNumber ;
   U32 signalBuffers ;
};
_GLOBAL void create_DBGGetProcessFullInfoReply(const U32 _pid, const U32 _bid, const U32 _parent, const U32 _userId, const U16 _procType, const U16 _status, const U16 _priority, const U16 _signalsInQueue, const U32 _entryPoint, const U32 _createTimeTick, const U32 _createTimeUTick, const U32 _fsemValue, const U32 _stackSize, const U32 _lineNumber, const U32 _signalBuffers, const U32 *_wantedSignals, U32 _wantedSignalsSize, const char *_processName, const char *_fileName, const char *_CPURegisters, union SIGNAL **_sig);


#ifdef LITTLE_ENDIAN
void convert_DBGGetProcessFullInfoReply(struct DBGGetProcessFullInfoReply *_sig);
#else
#define convert_DBGGetProcessFullInfoReply(_sig)
#endif


#define DBGGetProcessFullInfoReply_get_wantedSignals_size(XXsig, XXretVal) do {\
   U8 *XXptr = (U8*)XXsig + ALIGN_SIZE(60);\
   XXretVal = *(U32*)XXptr;\
}while(0)
#define DBGGetProcessFullInfoReply_get_wantedSignals(XXsig, XXretVal) do {\
   U8 *XXptr = (U8*)XXsig + ALIGN_SIZE(60);\
   XXretVal = (U32*)(XXptr+4);\
}while(0)
#define DBGGetProcessFullInfoReply_get_processName_size(XXsig, XXretVal) do {\
   U8 *XXptr = (U8*)XXsig + ALIGN_SIZE(60);\
   XXptr += ALIGN_SIZE( *((U32*)XXptr) ) + 4;\
   XXretVal = *(U32*)XXptr;\
}while(0)
#define DBGGetProcessFullInfoReply_get_processName(XXsig, XXretVal) do {\
   U8 *XXptr = (U8*)XXsig + ALIGN_SIZE(60);\
   XXptr += ALIGN_SIZE( *((U32*)XXptr) ) + 4;\
   XXretVal = (char*)(XXptr+4);\
}while(0)
#define DBGGetProcessFullInfoReply_get_fileName_size(XXsig, XXretVal) do {\
   U8 *XXptr = (U8*)XXsig + ALIGN_SIZE(60);\
   XXptr += ALIGN_SIZE( *((U32*)XXptr) ) + 4;\
   XXptr += ALIGN_SIZE( *((U32*)XXptr) ) + 4;\
   XXretVal = *(U32*)XXptr;\
}while(0)
#define DBGGetProcessFullInfoReply_get_fileName(XXsig, XXretVal) do {\
   U8 *XXptr = (U8*)XXsig + ALIGN_SIZE(60);\
   XXptr += ALIGN_SIZE( *((U32*)XXptr) ) + 4;\
   XXptr += ALIGN_SIZE( *((U32*)XXptr) ) + 4;\
   XXretVal = (char*)(XXptr+4);\
}while(0)
#define DBGGetProcessFullInfoReply_get_CPURegisters_size(XXsig, XXretVal) do {\
   U8 *XXptr = (U8*)XXsig + ALIGN_SIZE(60);\
   XXptr += ALIGN_SIZE( *((U32*)XXptr) ) + 4;\
   XXptr += ALIGN_SIZE( *((U32*)XXptr) ) + 4;\
   XXptr += ALIGN_SIZE( *((U32*)XXptr) ) + 4;\
   XXretVal = *(U32*)XXptr;\
}while(0)
#define DBGGetProcessFullInfoReply_get_CPURegisters(XXsig, XXretVal) do {\
   U8 *XXptr = (U8*)XXsig + ALIGN_SIZE(60);\
   XXptr += ALIGN_SIZE( *((U32*)XXptr) ) + 4;\
   XXptr += ALIGN_SIZE( *((U32*)XXptr) ) + 4;\
   XXptr += ALIGN_SIZE( *((U32*)XXptr) ) + 4;\
   XXretVal = (char*)(XXptr+4);\
}while(0)



/*
 *===========================================================================
 * DBGGETBLOCKINFO
 *===========================================================================
 *
 * Description:
  *
 * Parameters:
 *   bid:   
 */
#define DBGGETBLOCKINFO 32963   /* !-SIGNO(struct DBGGetBlockInfo)-! */
struct DBGGetBlockInfo {
   U32 sigNo;
   U32 size;
   U32 bid ;
};
#ifdef IS_DBGSERVER_CLIENT
_GLOBAL void create_DBGGetBlockInfo(const U32 _bid, union SIGNAL **_sig);
#endif


#ifdef LITTLE_ENDIAN
void convert_DBGGetBlockInfo(struct DBGGetBlockInfo *_sig);
#else
#define convert_DBGGetBlockInfo(_sig)
#endif





/*
 *===========================================================================
 * DBGGETBLOCKINFOREPLY
 *===========================================================================
 *
 * Description:
 * Sent as reply to DBGGET_BLOCK_INFO (any number of signals).
 *
 * Flow control: YES
 * Asyncron: NO
 *
  *
 * Parameters:
 *   bid:   
 *   creator:   
 *   createTimeTick:   
 *   createTimeUTick:   
 *   userId:   
 *   blockName:   
 */
#define DBGGETBLOCKINFOREPLY 32964   /* !-SIGNO(struct DBGGetBlockInfoReply)-! */
struct DBGGetBlockInfoReply {
   U32 sigNo;
   U32 size;
   U32 bid ;
   U32 creator ;
   U32 createTimeTick ;
   U32 createTimeUTick ;
   U32 userId ;
};
_GLOBAL void create_DBGGetBlockInfoReply(const U32 _bid, const U32 _creator, const U32 _createTimeTick, const U32 _createTimeUTick, const U32 _userId, const char *_blockName, union SIGNAL **_sig);


#ifdef LITTLE_ENDIAN
void convert_DBGGetBlockInfoReply(struct DBGGetBlockInfoReply *_sig);
#else
#define convert_DBGGetBlockInfoReply(_sig)
#endif


#define DBGGetBlockInfoReply_get_blockName_size(XXsig, XXretVal) do {\
   U8 *XXptr = (U8*)XXsig + ALIGN_SIZE(28);\
   XXretVal = *(U32*)XXptr;\
}while(0)
#define DBGGetBlockInfoReply_get_blockName(XXsig, XXretVal) do {\
   U8 *XXptr = (U8*)XXsig + ALIGN_SIZE(28);\
   XXretVal = (char*)(XXptr+4);\
}while(0)



/*
 *===========================================================================
 * DBGINFOPROCENDMARK
 *===========================================================================
 *
 * Description:
 * Sent by the debug server as the last signal in a process info
 * request which can yield into several reply signals.
 *
  *
 * Parameters:
 */
#define DBGINFOPROCENDMARK 32965   /* !-SIGNO(struct DBGInfoProcEndMark)-! */
struct DBGInfoProcEndMark {
   U32 sigNo;
   U32 size;
};
_GLOBAL void create_DBGInfoProcEndMark(union SIGNAL **_sig);


#ifdef LITTLE_ENDIAN
void convert_DBGInfoProcEndMark(struct DBGInfoProcEndMark *_sig);
#else
#define convert_DBGInfoProcEndMark(_sig)
#endif





/*
 *===========================================================================
 * DBGINFOBLOCKENDMARK
 *===========================================================================
 *
 * Description:
 *
 * Sent by the debug server as the last signal in a process info
 * request which can yield into several reply signals.
 *
  *
 * Parameters:
 */
#define DBGINFOBLOCKENDMARK 32966   /* !-SIGNO(struct DBGInfoBlockEndMark)-! */
struct DBGInfoBlockEndMark {
   U32 sigNo;
   U32 size;
};
_GLOBAL void create_DBGInfoBlockEndMark(union SIGNAL **_sig);


#ifdef LITTLE_ENDIAN
void convert_DBGInfoBlockEndMark(struct DBGInfoBlockEndMark *_sig);
#else
#define convert_DBGInfoBlockEndMark(_sig)
#endif





/*
 *===========================================================================
 * DBGGETSTACKUSAGE
 *===========================================================================
 *
 * Description:
 * Sent from the debugger client to the debug server to get
 * stack usage information for specified process. The signal
 * DBGGET_STACK_USAGE_REPLY is sent from the server as reply.
  *
 * Parameters:
 *   pid:   The pid of the process to get stack usage for.
 */
#define DBGGETSTACKUSAGE 32967   /* !-SIGNO(struct DBGGetStackUsage)-! */
struct DBGGetStackUsage {
   U32 sigNo;
   U32 size;
   U32 pid ;
};
#ifdef IS_DBGSERVER_CLIENT
_GLOBAL void create_DBGGetStackUsage(const U32 _pid, union SIGNAL **_sig);
#endif


#ifdef LITTLE_ENDIAN
void convert_DBGGetStackUsage(struct DBGGetStackUsage *_sig);
#else
#define convert_DBGGetStackUsage(_sig)
#endif





/*
 *===========================================================================
 * DBGGETSTACKUSAGEREPLY
 *===========================================================================
 *
 * Description:
 * Sent from the debug server to the debugger client as a reply
 * to DBGGET_STACK_USAGE.
  *
 * Parameters:
 *   pid:    The pid of the process that the info is for.
 *   status:    0 if Ok, -1 if process is dead.
 *   stackStart:    The start of the stack.
 *   stackEnd:    The end of the stack.
 *   max:    The peak value of used stack.
 */
#define DBGGETSTACKUSAGEREPLY 32968   /* !-SIGNO(struct DBGGetStackUsageReply)-! */
struct DBGGetStackUsageReply {
   U32 sigNo;
   U32 size;
   U32 pid ;
   S32 status ;
   U32 stackStart ;
   U32 stackEnd ;
   U32 max ;
};
_GLOBAL void create_DBGGetStackUsageReply(const U32 _pid, const S32 _status, const U32 _stackStart, const U32 _stackEnd, const U32 _max, union SIGNAL **_sig);


#ifdef LITTLE_ENDIAN
void convert_DBGGetStackUsageReply(struct DBGGetStackUsageReply *_sig);
#else
#define convert_DBGGetStackUsageReply(_sig)
#endif





/*
 *===========================================================================
 * DBGGETENVLIST
 *===========================================================================
 *
 * Description:
 * Sent by the debugger to list the environment variables
 * for a process or block. Will be followed by any number
 * of DBGGET_ENV_LIST_REPLY and one DBGGET_ENV_LIST_END_MARK.
  *
 * Parameters:
 *   pid:    The pid of the block/process
 */
#define DBGGETENVLIST 32969   /* !-SIGNO(struct DBGGetEnvList)-! */
struct DBGGetEnvList {
   U32 sigNo;
   U32 size;
   U32 pid ;
};
#ifdef IS_DBGSERVER_CLIENT
_GLOBAL void create_DBGGetEnvList(const U32 _pid, union SIGNAL **_sig);
#endif


#ifdef LITTLE_ENDIAN
void convert_DBGGetEnvList(struct DBGGetEnvList *_sig);
#else
#define convert_DBGGetEnvList(_sig)
#endif





/*
 *===========================================================================
 * DBGGETENVLISTREPLY
 *===========================================================================
 *
 * Description:
 * Sent by the server as reply to DBGGET_ENV_LIST
 * and contains one environment variable name
 * and its value.
 *
  *
 * Parameters:
 *   pid:    The pid which has the variables.
 *   name:    An environment variable name.
 *   value:    The value of the variable.
 */
#define DBGGETENVLISTREPLY 32970   /* !-SIGNO(struct DBGGetEnvListReply)-! */
struct DBGGetEnvListReply {
   U32 sigNo;
   U32 size;
   U32 pid ;
};
_GLOBAL void create_DBGGetEnvListReply(const U32 _pid, const char *_name, const char *_value, union SIGNAL **_sig);


#ifdef LITTLE_ENDIAN
void convert_DBGGetEnvListReply(struct DBGGetEnvListReply *_sig);
#else
#define convert_DBGGetEnvListReply(_sig)
#endif


#define DBGGetEnvListReply_get_name_size(XXsig, XXretVal) do {\
   U8 *XXptr = (U8*)XXsig + ALIGN_SIZE(12);\
   XXretVal = *(U32*)XXptr;\
}while(0)
#define DBGGetEnvListReply_get_name(XXsig, XXretVal) do {\
   U8 *XXptr = (U8*)XXsig + ALIGN_SIZE(12);\
   XXretVal = (char*)(XXptr+4);\
}while(0)
#define DBGGetEnvListReply_get_value_size(XXsig, XXretVal) do {\
   U8 *XXptr = (U8*)XXsig + ALIGN_SIZE(12);\
   XXptr += ALIGN_SIZE( *((U32*)XXptr) ) + 4;\
   XXretVal = *(U32*)XXptr;\
}while(0)
#define DBGGetEnvListReply_get_value(XXsig, XXretVal) do {\
   U8 *XXptr = (U8*)XXsig + ALIGN_SIZE(12);\
   XXptr += ALIGN_SIZE( *((U32*)XXptr) ) + 4;\
   XXretVal = (char*)(XXptr+4);\
}while(0)



/*
 *===========================================================================
 * DBGGETENVLISTENDMARK
 *===========================================================================
 *
 * Description:
 * Sent by the server as the last reply to DBGGET_ENV_LIST.
  *
 * Parameters:
 *   pid:   
 */
#define DBGGETENVLISTENDMARK 32971   /* !-SIGNO(struct DBGGetEnvListEndMark)-! */
struct DBGGetEnvListEndMark {
   U32 sigNo;
   U32 size;
   U32 pid ;
};
_GLOBAL void create_DBGGetEnvListEndMark(const U32 _pid, union SIGNAL **_sig);


#ifdef LITTLE_ENDIAN
void convert_DBGGetEnvListEndMark(struct DBGGetEnvListEndMark *_sig);
#else
#define convert_DBGGetEnvListEndMark(_sig)
#endif





/*
 *===========================================================================
 * DBGSETENVIRONMENTVARIABLE
 *===========================================================================
 *
 * Description:
 * Sent by the debugger to set an environment variable
 * for a process or block.
  *
 * Parameters:
 *   pid:    The pid which has the variables
 *   variable:    The environment variablel name.
 *   value:    The value for env variable.
 */
#define DBGSETENVIRONMENTVARIABLE 32972   /* !-SIGNO(struct DBGSetEnvironmentVariable)-! */
struct DBGSetEnvironmentVariable {
   U32 sigNo;
   U32 size;
   U32 pid ;
};
#ifdef IS_DBGSERVER_CLIENT
_GLOBAL void create_DBGSetEnvironmentVariable(const U32 _pid, const char *_variable, const char *_value, union SIGNAL **_sig);
#endif


#ifdef LITTLE_ENDIAN
void convert_DBGSetEnvironmentVariable(struct DBGSetEnvironmentVariable *_sig);
#else
#define convert_DBGSetEnvironmentVariable(_sig)
#endif


#define DBGSetEnvironmentVariable_get_variable_size(XXsig, XXretVal) do {\
   U8 *XXptr = (U8*)XXsig + ALIGN_SIZE(12);\
   XXretVal = *(U32*)XXptr;\
}while(0)
#define DBGSetEnvironmentVariable_get_variable(XXsig, XXretVal) do {\
   U8 *XXptr = (U8*)XXsig + ALIGN_SIZE(12);\
   XXretVal = (char*)(XXptr+4);\
}while(0)
#define DBGSetEnvironmentVariable_get_value_size(XXsig, XXretVal) do {\
   U8 *XXptr = (U8*)XXsig + ALIGN_SIZE(12);\
   XXptr += ALIGN_SIZE( *((U32*)XXptr) ) + 4;\
   XXretVal = *(U32*)XXptr;\
}while(0)
#define DBGSetEnvironmentVariable_get_value(XXsig, XXretVal) do {\
   U8 *XXptr = (U8*)XXsig + ALIGN_SIZE(12);\
   XXptr += ALIGN_SIZE( *((U32*)XXptr) ) + 4;\
   XXretVal = (char*)(XXptr+4);\
}while(0)



/*
 *===========================================================================
 * DBGDEFINECATCHSCOPE
 *===========================================================================
 *
 * Description:
 * Sent by the debugger to redefine the catch scope. The catch
 * is defined by a set of entry points, blocks and processes.
 * The name lists contains a list of names each name is 0 terminated and the
 * last name is 00 terminated. The name is either a process name or a wildcard
 * The wildcard handling is very simple so wildcards can only be in the
 * form of "*" or "string*" i.e. "process*".
  *
 * Parameters:
 *   count:    Number of fields in names.
 *   unused1:   
 *   unused2:   
 *   names:    List of wildcards, each name is 0 terminated, last is 00 term.
 */
#define DBGDEFINECATCHSCOPE 32973   /* !-SIGNO(struct DBGDefineCatchScope)-! */
struct DBGDefineCatchScope {
   U32 sigNo;
   U32 size;
   U16 count ;
   U8 unused1 ;
   U8 unused2 ;
};
#ifdef IS_DBGSERVER_CLIENT
_GLOBAL void create_DBGDefineCatchScope(const U16 _count, const U8 _unused1, const U8 _unused2, const U8 *_names, U32 _namesSize, union SIGNAL **_sig);
#endif


#ifdef LITTLE_ENDIAN
void convert_DBGDefineCatchScope(struct DBGDefineCatchScope *_sig);
#else
#define convert_DBGDefineCatchScope(_sig)
#endif


#define DBGDefineCatchScope_get_names_size(XXsig, XXretVal) do {\
   U8 *XXptr = (U8*)XXsig + ALIGN_SIZE(12);\
   XXretVal = *(U32*)XXptr;\
}while(0)
#define DBGDefineCatchScope_get_names(XXsig, XXretVal) do {\
   U8 *XXptr = (U8*)XXsig + ALIGN_SIZE(12);\
   XXretVal = (U8*)(XXptr+4);\
}while(0)



/*
 *===========================================================================
 * DBGDEFINEMONTRACESCOPE
 *===========================================================================
 *
 * Description:
 * Sent by the debugger to redefine the monitor/trace scope.
 * The monitor scope is defined by a set of entry points, blocks
 * and processes.
 * The name lists contains a list of names each name is 0 terminated and the
 * last name is 00 terminated. The name is either a process name or a wildcard
 * The wildcard handling is very simple so wildcards can only be in the
 * form of "*" or "string*" i.e. "process*".
  *
 * Parameters:
 *   count:    Number of fields in names.
 *   unused1:   
 *   unused2:   
 *   names:    List of wildcards, each name is 0 terminated, last is 00 term.
 */
#define DBGDEFINEMONTRACESCOPE 32974   /* !-SIGNO(struct DBGDefineMonTraceScope)-! */
struct DBGDefineMonTraceScope {
   U32 sigNo;
   U32 size;
   U16 count ;
   U8 unused1 ;
   U8 unused2 ;
};
#ifdef IS_DBGSERVER_CLIENT
_GLOBAL void create_DBGDefineMonTraceScope(const U16 _count, const U8 _unused1, const U8 _unused2, const U8 *_names, U32 _namesSize, union SIGNAL **_sig);
#endif


#ifdef LITTLE_ENDIAN
void convert_DBGDefineMonTraceScope(struct DBGDefineMonTraceScope *_sig);
#else
#define convert_DBGDefineMonTraceScope(_sig)
#endif


#define DBGDefineMonTraceScope_get_names_size(XXsig, XXretVal) do {\
   U8 *XXptr = (U8*)XXsig + ALIGN_SIZE(12);\
   XXretVal = *(U32*)XXptr;\
}while(0)
#define DBGDefineMonTraceScope_get_names(XXsig, XXretVal) do {\
   U8 *XXptr = (U8*)XXsig + ALIGN_SIZE(12);\
   XXretVal = (U8*)(XXptr+4);\
}while(0)



/*
 *===========================================================================
 * DBGKILLPROCESS
 *===========================================================================
 *
 * Description:
 * Sent by the debugger to kill a process. If it is posseble for
 * the debug server to kill the process it done otherwise no
 * action is taken.
  *
 * Parameters:
 *   pid:   The id of the process to kill.
 */
#define DBGKILLPROCESS 32975   /* !-SIGNO(struct DBGKillProcess)-! */
struct DBGKillProcess {
   U32 sigNo;
   U32 size;
   U32 pid ;
};
#ifdef IS_DBGSERVER_CLIENT
_GLOBAL void create_DBGKillProcess(const U32 _pid, union SIGNAL **_sig);
#endif


#ifdef LITTLE_ENDIAN
void convert_DBGKillProcess(struct DBGKillProcess *_sig);
#else
#define convert_DBGKillProcess(_sig)
#endif





/*
 *===========================================================================
 * DBGSTARTPROCESS
 *===========================================================================
 *
 * Description:
 * Sent by the debugger to start a process.
  *
 * Parameters:
 *   pid:   The id of the process to kill.
 */
#define DBGSTARTPROCESS 32976   /* !-SIGNO(struct DBGStartProcess)-! */
struct DBGStartProcess {
   U32 sigNo;
   U32 size;
   U32 pid ;
};
#ifdef IS_DBGSERVER_CLIENT
_GLOBAL void create_DBGStartProcess(const U32 _pid, union SIGNAL **_sig);
#endif


#ifdef LITTLE_ENDIAN
void convert_DBGStartProcess(struct DBGStartProcess *_sig);
#else
#define convert_DBGStartProcess(_sig)
#endif





/*
 *===========================================================================
 * DBGSTOPPROCESS
 *===========================================================================
 *
 * Description:
 * Sent by the debugger to stop a process.
  *
 * Parameters:
 *   pid:   
 */
#define DBGSTOPPROCESS 32977   /* !-SIGNO(struct DBGStopProcess)-! */
struct DBGStopProcess {
   U32 sigNo;
   U32 size;
   U32 pid ;
};
#ifdef IS_DBGSERVER_CLIENT
_GLOBAL void create_DBGStopProcess(const U32 _pid, union SIGNAL **_sig);
#endif


#ifdef LITTLE_ENDIAN
void convert_DBGStopProcess(struct DBGStopProcess *_sig);
#else
#define convert_DBGStopProcess(_sig)
#endif





/*
 *===========================================================================
 * DBGINTERCEPTPROCESS
 *===========================================================================
 *
 * Description:
 * Sent by the debugger to intercept a process.
  *
 * Parameters:
 *   pid:   
 */
#define DBGINTERCEPTPROCESS 32978   /* !-SIGNO(struct DBGInterceptProcess)-! */
struct DBGInterceptProcess {
   U32 sigNo;
   U32 size;
   U32 pid ;
};
#ifdef IS_DBGSERVER_CLIENT
_GLOBAL void create_DBGInterceptProcess(const U32 _pid, union SIGNAL **_sig);
#endif


#ifdef LITTLE_ENDIAN
void convert_DBGInterceptProcess(struct DBGInterceptProcess *_sig);
#else
#define convert_DBGInterceptProcess(_sig)
#endif





/*
 *===========================================================================
 * DBGRESUMEPROCESS
 *===========================================================================
 *
 * Description:
 * Sent by the debugger to resume a process.
  *
 * Parameters:
 *   pid:   
 */
#define DBGRESUMEPROCESS 32979   /* !-SIGNO(struct DBGResumeProcess)-! */
struct DBGResumeProcess {
   U32 sigNo;
   U32 size;
   U32 pid ;
};
#ifdef IS_DBGSERVER_CLIENT
_GLOBAL void create_DBGResumeProcess(const U32 _pid, union SIGNAL **_sig);
#endif


#ifdef LITTLE_ENDIAN
void convert_DBGResumeProcess(struct DBGResumeProcess *_sig);
#else
#define convert_DBGResumeProcess(_sig)
#endif





/*
 *===========================================================================
 * DBGINTERCEPTCATCHSCOPE
 *===========================================================================
 *
 * Description:
 * Sent from the debugger client to the debug server to disable
 * monitor (monitor is by defualt disabled).
  *
 * Parameters:
 */
#define DBGINTERCEPTCATCHSCOPE 32980   /* !-SIGNO(struct DBGInterceptCatchScope)-! */
struct DBGInterceptCatchScope {
   U32 sigNo;
   U32 size;
};
#ifdef IS_DBGSERVER_CLIENT
_GLOBAL void create_DBGInterceptCatchScope(union SIGNAL **_sig);
#endif


#ifdef LITTLE_ENDIAN
void convert_DBGInterceptCatchScope(struct DBGInterceptCatchScope *_sig);
#else
#define convert_DBGInterceptCatchScope(_sig)
#endif





/*
 *===========================================================================
 * DBGRESUMECATCHSCOPE
 *===========================================================================
 *
 * Description:
 * Sent from the debugger client to the debug server to disable
 * monitor (monitor is by defualt disabled).
  *
 * Parameters:
 */
#define DBGRESUMECATCHSCOPE 32981   /* !-SIGNO(struct DBGResumeCatchScope)-! */
struct DBGResumeCatchScope {
   U32 sigNo;
   U32 size;
};
#ifdef IS_DBGSERVER_CLIENT
_GLOBAL void create_DBGResumeCatchScope(union SIGNAL **_sig);
#endif


#ifdef LITTLE_ENDIAN
void convert_DBGResumeCatchScope(struct DBGResumeCatchScope *_sig);
#else
#define convert_DBGResumeCatchScope(_sig)
#endif





/*
 *===========================================================================
 * DBGGETSIGNALQUEUE
 *===========================================================================
 *
 * Description:
 * Sent from the debugger client to the debug server to get the
 * signal queue for a process (without signal contents).
  *
 * Parameters:
 *   pid:    The pid of the process wich have the signal queue
 */
#define DBGGETSIGNALQUEUE 32982   /* !-SIGNO(struct DBGGetSignalQueue)-! */
struct DBGGetSignalQueue {
   U32 sigNo;
   U32 size;
   U32 pid ;
};
#ifdef IS_DBGSERVER_CLIENT
_GLOBAL void create_DBGGetSignalQueue(const U32 _pid, union SIGNAL **_sig);
#endif


#ifdef LITTLE_ENDIAN
void convert_DBGGetSignalQueue(struct DBGGetSignalQueue *_sig);
#else
#define convert_DBGGetSignalQueue(_sig)
#endif





/*
 *===========================================================================
 * DBGGETSIGNALQUEUEREPLY
 *===========================================================================
 *
 * Description:
 * Sent from the debug server to the debug client as a reply
 * to DBG_GET_SIGNAL_QUEUE. The signal contains one entry in
 * the signal queue. The Last signal sent is followed by
 * a DBGINFO_QUEUE_END_MARK signal.
  *
 * Parameters:
 *   pid:    The pid of the process holding the signal queue.
 *   from:    Pid of the sender.
 *   addressee:    The pid of the addressee.
 *   signalSize:    Number of bytes in the signal.
 *   signalNumber:    The signal number.
 *   entry:    Position in the signal queue.
 */
#define DBGGETSIGNALQUEUEREPLY 32983   /* !-SIGNO(struct DBGGetSignalQueueReply)-! */
struct DBGGetSignalQueueReply {
   U32 sigNo;
   U32 size;
   U32 pid ;
   U32 from ;
   U32 addressee ;
   U32 signalSize ;
   U32 signalNumber ;
   U32 entry ;
};
_GLOBAL void create_DBGGetSignalQueueReply(const U32 _pid, const U32 _from, const U32 _addressee, const U32 _signalSize, const U32 _signalNumber, const U32 _entry, union SIGNAL **_sig);


#ifdef LITTLE_ENDIAN
void convert_DBGGetSignalQueueReply(struct DBGGetSignalQueueReply *_sig);
#else
#define convert_DBGGetSignalQueueReply(_sig)
#endif





/*
 *===========================================================================
 * DBGINFOQUEUEENDMARK
 *===========================================================================
 *
 * Description:
 * Sent by the debug server as the last signal in a getSignalQueue
 * request which can yield into several reply signals.
  *
 * Parameters:
 *   pid:    The pid for which the request conserned
 */
#define DBGINFOQUEUEENDMARK 32984   /* !-SIGNO(struct DBGInfoQueueEndMark)-! */
struct DBGInfoQueueEndMark {
   U32 sigNo;
   U32 size;
   U32 pid ;
};
_GLOBAL void create_DBGInfoQueueEndMark(const U32 _pid, union SIGNAL **_sig);


#ifdef LITTLE_ENDIAN
void convert_DBGInfoQueueEndMark(struct DBGInfoQueueEndMark *_sig);
#else
#define convert_DBGInfoQueueEndMark(_sig)
#endif





/*
 *===========================================================================
 * DBGREQUESTSIGNALINFO
 *===========================================================================
 *
 * Description:
 * This is a temporary signal which should be replaced by a more sofisticated
 * signal in the future. This signal contains the signal ID and name from the
 * confsig table. The signal is sent from the server to the client after the
 * client requested a lock. 
  *
 * Parameters:
 */
#define DBGREQUESTSIGNALINFO 32985   /* !-SIGNO(struct DBGRequestSignalInfo)-! */
struct DBGRequestSignalInfo {
   U32 sigNo;
   U32 size;
};
#ifdef IS_DBGSERVER_CLIENT
_GLOBAL void create_DBGRequestSignalInfo(union SIGNAL **_sig);
#endif


#ifdef LITTLE_ENDIAN
void convert_DBGRequestSignalInfo(struct DBGRequestSignalInfo *_sig);
#else
#define convert_DBGRequestSignalInfo(_sig)
#endif





/*
 *===========================================================================
 * DBGSIGNALINFOREPLY
 *===========================================================================
 *
 * Description:
 * This is a temporary signal which should be replaced by a more sofisticated
 * signal in the future. This signal contains the signal ID and name from the
 * confsig table. The signal is sent from the server to the client after the
 * client requested a lock. 
  *
 * Parameters:
 *   signalNumber:   
 *   name:   
 */
#define DBGSIGNALINFOREPLY 32986   /* !-SIGNO(struct DBGSignalInfoReply)-! */
struct DBGSignalInfoReply {
   U32 sigNo;
   U32 size;
   U32 signalNumber ;
};
_GLOBAL void create_DBGSignalInfoReply(const U32 _signalNumber, const char *_name, union SIGNAL **_sig);


#ifdef LITTLE_ENDIAN
void convert_DBGSignalInfoReply(struct DBGSignalInfoReply *_sig);
#else
#define convert_DBGSignalInfoReply(_sig)
#endif


#define DBGSignalInfoReply_get_name_size(XXsig, XXretVal) do {\
   U8 *XXptr = (U8*)XXsig + ALIGN_SIZE(12);\
   XXretVal = *(U32*)XXptr;\
}while(0)
#define DBGSignalInfoReply_get_name(XXsig, XXretVal) do {\
   U8 *XXptr = (U8*)XXsig + ALIGN_SIZE(12);\
   XXretVal = (char*)(XXptr+4);\
}while(0)



/*
 *===========================================================================
 * DBGSINGLESTEP
 *===========================================================================
 *
 * Description:
 * Perform an OSE event single step. All processes in the catch
 * scope is single steped. An catch event report is returned after
 * the signal step has been performed.
 * The eventMask selects the events to halt on with the following
 * values:
 *        0x01 = Send a signal.
 *        0x02 = Receive a signal.
 *        0x04 = Process created.
 *        0x08 = Process killed.
 *        0x10 = Error detected by OSE.
 *        0x20 = User reported error.
 *        0x40 = A warm restart.
  *
 * Parameters:
 *   eventMask:    The mask containing the events to stop on.
 */
#define DBGSINGLESTEP 32987   /* !-SIGNO(struct DBGSingleStep)-! */
struct DBGSingleStep {
   U32 sigNo;
   U32 size;
   U32 eventMask ;
};
#ifdef IS_DBGSERVER_CLIENT
_GLOBAL void create_DBGSingleStep(const U32 _eventMask, union SIGNAL **_sig);
#endif


#ifdef LITTLE_ENDIAN
void convert_DBGSingleStep(struct DBGSingleStep *_sig);
#else
#define convert_DBGSingleStep(_sig)
#endif





/*
 *===========================================================================
 * DBGGETBLOCKFULLINFO
 *===========================================================================
 *
 * Description:
 * Request to display long block info for a block
  *
 * Parameters:
 *   bid:   
 */
#define DBGGETBLOCKFULLINFO 32988   /* !-SIGNO(struct DBGGetBlockFullInfo)-! */
struct DBGGetBlockFullInfo {
   U32 sigNo;
   U32 size;
   U32 bid ;
};
#ifdef IS_DBGSERVER_CLIENT
_GLOBAL void create_DBGGetBlockFullInfo(const U32 _bid, union SIGNAL **_sig);
#endif


#ifdef LITTLE_ENDIAN
void convert_DBGGetBlockFullInfo(struct DBGGetBlockFullInfo *_sig);
#else
#define convert_DBGGetBlockFullInfo(_sig)
#endif





/*
 *===========================================================================
 * DBGGETBLOCKFULLINFOREPLY
 *===========================================================================
 *
 * Description:
 * Sent as reply to DBGGetBlockFullInfo (any number of signals).
 *
  *
 * Parameters:
 *   bid:   
 *   creator:   
 *   createTimeTick:   
 *   createTimeUTick:   
 *   userId:   
 *   maxSigSize:   
 *   segId:   
 *   sigPoolId:   
 *   stackPoolId:   
 *   blockName:   
 */
#define DBGGETBLOCKFULLINFOREPLY 32989   /* !-SIGNO(struct DBGGetBlockFullInfoReply)-! */
struct DBGGetBlockFullInfoReply {
   U32 sigNo;
   U32 size;
   U32 bid ;
   U32 creator ;
   U32 createTimeTick ;
   U32 createTimeUTick ;
   U32 userId ;
   U32 maxSigSize ;
   U32 segId ;
   U32 sigPoolId ;
   U32 stackPoolId ;
};
_GLOBAL void create_DBGGetBlockFullInfoReply(const U32 _bid, const U32 _creator, const U32 _createTimeTick, const U32 _createTimeUTick, const U32 _userId, const U32 _maxSigSize, const U32 _segId, const U32 _sigPoolId, const U32 _stackPoolId, const char *_blockName, union SIGNAL **_sig);


#ifdef LITTLE_ENDIAN
void convert_DBGGetBlockFullInfoReply(struct DBGGetBlockFullInfoReply *_sig);
#else
#define convert_DBGGetBlockFullInfoReply(_sig)
#endif


#define DBGGetBlockFullInfoReply_get_blockName_size(XXsig, XXretVal) do {\
   U8 *XXptr = (U8*)XXsig + ALIGN_SIZE(44);\
   XXretVal = *(U32*)XXptr;\
}while(0)
#define DBGGetBlockFullInfoReply_get_blockName(XXsig, XXretVal) do {\
   U8 *XXptr = (U8*)XXsig + ALIGN_SIZE(44);\
   XXretVal = (char*)(XXptr+4);\
}while(0)



/*
 *===========================================================================
 * DBGSENDSIGNAL
 *===========================================================================
 *
 * Description:
 * Send a signal to a process.
  *
 * Parameters:
 *   receiverPid:   
 *   senderPid:   
 *   signalNo:   
 *   signalData:   
 */
#define DBGSENDSIGNAL 32990   /* !-SIGNO(struct DBGSendSignal)-! */
struct DBGSendSignal {
   U32 sigNo;
   U32 size;
   U32 receiverPid ;
   U32 senderPid ;
   U32 signalNo ;
};
#ifdef IS_DBGSERVER_CLIENT
_GLOBAL void create_DBGSendSignal(const U32 _receiverPid, const U32 _senderPid, const U32 _signalNo, const U8 *_signalData, U32 _signalDataSize, union SIGNAL **_sig);
#endif


#ifdef LITTLE_ENDIAN
void convert_DBGSendSignal(struct DBGSendSignal *_sig);
#else
#define convert_DBGSendSignal(_sig)
#endif


#define DBGSendSignal_get_signalData_size(XXsig, XXretVal) do {\
   U8 *XXptr = (U8*)XXsig + ALIGN_SIZE(20);\
   XXretVal = *(U32*)XXptr;\
}while(0)
#define DBGSendSignal_get_signalData(XXsig, XXretVal) do {\
   U8 *XXptr = (U8*)XXsig + ALIGN_SIZE(20);\
   XXretVal = (U8*)(XXptr+4);\
}while(0)



/*
 *===========================================================================
 * DBGSENDSIGNALREPLY
 *===========================================================================
 *
 * Description:
 * Reply to the DBGSendSignal signal.
  *
 * Parameters:
 */
#define DBGSENDSIGNALREPLY 32991   /* !-SIGNO(struct DBGSendSignalReply)-! */
struct DBGSendSignalReply {
   U32 sigNo;
   U32 size;
};
_GLOBAL void create_DBGSendSignalReply(union SIGNAL **_sig);


#ifdef LITTLE_ENDIAN
void convert_DBGSendSignalReply(struct DBGSendSignalReply *_sig);
#else
#define convert_DBGSendSignalReply(_sig)
#endif





/*
 *===========================================================================
 * DBGNEWDBGSERVER
 *===========================================================================
 *
 * Description:
 *  Create a new debug server for a different LDM.
  *
 * Parameters:
 *   serverPort:   
 *   broadcastPort:   
 *   priority:   
 *   huntPath:   
 */
#define DBGNEWDBGSERVER 32992   /* !-SIGNO(struct DBGNewDbgServer)-! */
struct DBGNewDbgServer {
   U32 sigNo;
   U32 size;
   U32 serverPort ;
   U32 broadcastPort ;
   U32 priority ;
};
#ifdef IS_DBGSERVER_CLIENT
_GLOBAL void create_DBGNewDbgServer(const U32 _serverPort, const U32 _broadcastPort, const U32 _priority, const char *_huntPath, union SIGNAL **_sig);
#endif


#ifdef LITTLE_ENDIAN
void convert_DBGNewDbgServer(struct DBGNewDbgServer *_sig);
#else
#define convert_DBGNewDbgServer(_sig)
#endif


#define DBGNewDbgServer_get_huntPath_size(XXsig, XXretVal) do {\
   U8 *XXptr = (U8*)XXsig + ALIGN_SIZE(20);\
   XXretVal = *(U32*)XXptr;\
}while(0)
#define DBGNewDbgServer_get_huntPath(XXsig, XXretVal) do {\
   U8 *XXptr = (U8*)XXsig + ALIGN_SIZE(20);\
   XXretVal = (char*)(XXptr+4);\
}while(0)



/*
 *===========================================================================
 * DBGNEWDBGSERVERREPLY
 *===========================================================================
 *
 * Description:
 *  Create a new debug server for a different LDM.
  *
 * Parameters:
 *   status:    0 = ok, 1 = target not found (spawned process is killed).
 */
#define DBGNEWDBGSERVERREPLY 32993   /* !-SIGNO(struct DBGNewDbgServerReply)-! */
struct DBGNewDbgServerReply {
   U32 sigNo;
   U32 size;
   U8 status ;
};
_GLOBAL void create_DBGNewDbgServerReply(const U8 _status, union SIGNAL **_sig);


#ifdef LITTLE_ENDIAN
void convert_DBGNewDbgServerReply(struct DBGNewDbgServerReply *_sig);
#else
#define convert_DBGNewDbgServerReply(_sig)
#endif





/*
 *===========================================================================
 * DBGREADMEMORY
 *===========================================================================
 *
 * Description:
 *  Create a new debug server for a different LDM.
  *
 * Parameters:
 *   blockid:    Read the memory in the context of this block.
 *   address:    Start address
 *   noBytes:    The size
 */
#define DBGREADMEMORY 32994   /* !-SIGNO(struct DBGReadMemory)-! */
struct DBGReadMemory {
   U32 sigNo;
   U32 size;
   U32 blockid ;
   U32 address ;
   U32 noBytes ;
};
#ifdef IS_DBGSERVER_CLIENT
_GLOBAL void create_DBGReadMemory(const U32 _blockid, const U32 _address, const U32 _noBytes, union SIGNAL **_sig);
#endif


#ifdef LITTLE_ENDIAN
void convert_DBGReadMemory(struct DBGReadMemory *_sig);
#else
#define convert_DBGReadMemory(_sig)
#endif





/*
 *===========================================================================
 * DBGREADMEMORYREPLY
 *===========================================================================
 *
 * Description:
 *  Create a new debug server for a different LDM.
  *
 * Parameters:
 *   status:    1 if successful otherwise 0
 *   unused1:   
 *   unused2:   
 *   unused3:   
 *   bytes:    the reply is sent as a serie of packets.
 */
#define DBGREADMEMORYREPLY 32995   /* !-SIGNO(struct DBGReadMemoryReply)-! */
struct DBGReadMemoryReply {
   U32 sigNo;
   U32 size;
   U8 status ;
   U8 unused1 ;
   U8 unused2 ;
   U8 unused3 ;
};
_GLOBAL void create_DBGReadMemoryReply(const U8 _status, const U8 _unused1, const U8 _unused2, const U8 _unused3, const U8 *_bytes, U32 _bytesSize, union SIGNAL **_sig);


#ifdef LITTLE_ENDIAN
void convert_DBGReadMemoryReply(struct DBGReadMemoryReply *_sig);
#else
#define convert_DBGReadMemoryReply(_sig)
#endif


#define DBGReadMemoryReply_get_bytes_size(XXsig, XXretVal) do {\
   U8 *XXptr = (U8*)XXsig + ALIGN_SIZE(12);\
   XXretVal = *(U32*)XXptr;\
}while(0)
#define DBGReadMemoryReply_get_bytes(XXsig, XXretVal) do {\
   U8 *XXptr = (U8*)XXsig + ALIGN_SIZE(12);\
   XXretVal = (U8*)(XXptr+4);\
}while(0)



/*
 *===========================================================================
 * DBGGETCPUMEASUREMENTSTATUS
 *===========================================================================
 *
 * Description: Start CPU profiler changes bjjo
 * Sent to query about current state of the CPU measurement
  *
 * Parameters:
 */
#define DBGGETCPUMEASUREMENTSTATUS 32996   /* !-SIGNO(struct DBGGetCPUMeasurementStatus)-! */
struct DBGGetCPUMeasurementStatus {
   U32 sigNo;
   U32 size;
};
#ifdef IS_DBGSERVER_CLIENT
_GLOBAL void create_DBGGetCPUMeasurementStatus(union SIGNAL **_sig);
#endif


#ifdef LITTLE_ENDIAN
void convert_DBGGetCPUMeasurementStatus(struct DBGGetCPUMeasurementStatus *_sig);
#else
#define convert_DBGGetCPUMeasurementStatus(_sig)
#endif





/*
 *===========================================================================
 * DBGGETCPUMEASUREMENTSTATUSREPLY
 *===========================================================================
 *
 * Description:
 * Sent as reply to DBGGetCPUMeasurementStatus
  *
 * Parameters:
 *   measurementStatus:    0 if inactive, 1 if active
 *   uInterval:    integration interval in microseconds, valid if active
 *   currentTimeTick:    Tick at current time
 *   currentTimeUTick:    microseconds after tick stamp
 */
#define DBGGETCPUMEASUREMENTSTATUSREPLY 32997   /* !-SIGNO(struct DBGGetCPUMeasurementStatusReply)-! */
struct DBGGetCPUMeasurementStatusReply {
   U32 sigNo;
   U32 size;
   U32 measurementStatus ;
   U32 uInterval ;
   U32 currentTimeTick ;
   U32 currentTimeUTick ;
};
_GLOBAL void create_DBGGetCPUMeasurementStatusReply(const U32 _measurementStatus, const U32 _uInterval, const U32 _currentTimeTick, const U32 _currentTimeUTick, union SIGNAL **_sig);


#ifdef LITTLE_ENDIAN
void convert_DBGGetCPUMeasurementStatusReply(struct DBGGetCPUMeasurementStatusReply *_sig);
#else
#define convert_DBGGetCPUMeasurementStatusReply(_sig)
#endif





/*
 *===========================================================================
 * DBGGETPRIMEASUREMENTSTATUS
 *===========================================================================
 *
 * Description:
 * Sent to query about current state of the Priority level measurement
  *
 * Parameters:
 */
#define DBGGETPRIMEASUREMENTSTATUS 32998   /* !-SIGNO(struct DBGGetPriMeasurementStatus)-! */
struct DBGGetPriMeasurementStatus {
   U32 sigNo;
   U32 size;
};
#ifdef IS_DBGSERVER_CLIENT
_GLOBAL void create_DBGGetPriMeasurementStatus(union SIGNAL **_sig);
#endif


#ifdef LITTLE_ENDIAN
void convert_DBGGetPriMeasurementStatus(struct DBGGetPriMeasurementStatus *_sig);
#else
#define convert_DBGGetPriMeasurementStatus(_sig)
#endif





/*
 *===========================================================================
 * DBGGETPRIMEASUREMENTSTATUSREPLY
 *===========================================================================
 *
 * Description:
 * Sent as reply to DBGGetCPUMeasurementStatus
  *
 * Parameters:
 *   measurementStatus:    0 if inactive, 1 if active
 *   uInterval:    integration interval in microseconds, valid if active
 *   currentTimeTick:    Tick at current time
 *   currentTimeUTick:    microseconds after tick stamp
 */
#define DBGGETPRIMEASUREMENTSTATUSREPLY 32999   /* !-SIGNO(struct DBGGetPriMeasurementStatusReply)-! */
struct DBGGetPriMeasurementStatusReply {
   U32 sigNo;
   U32 size;
   U32 measurementStatus ;
   U32 uInterval ;
   U32 currentTimeTick ;
   U32 currentTimeUTick ;
};
_GLOBAL void create_DBGGetPriMeasurementStatusReply(const U32 _measurementStatus, const U32 _uInterval, const U32 _currentTimeTick, const U32 _currentTimeUTick, union SIGNAL **_sig);


#ifdef LITTLE_ENDIAN
void convert_DBGGetPriMeasurementStatusReply(struct DBGGetPriMeasurementStatusReply *_sig);
#else
#define convert_DBGGetPriMeasurementStatusReply(_sig)
#endif





/*
 *===========================================================================
 * DBGSETPRIMEASUREMENTSTATUS
 *===========================================================================
 *
 * Description:
 * Sent to change current state of the Process level measurement
  *
 * Parameters:
 *   measurementStatus:    0 to inactive, 1 to activate
 *   uInterval:    integration interval in microseconds, valid if active
 */
#define DBGSETPRIMEASUREMENTSTATUS 33000   /* !-SIGNO(struct DBGSetPriMeasurementStatus)-! */
struct DBGSetPriMeasurementStatus {
   U32 sigNo;
   U32 size;
   U32 measurementStatus ;
   U32 uInterval ;
};
#ifdef IS_DBGSERVER_CLIENT
_GLOBAL void create_DBGSetPriMeasurementStatus(const U32 _measurementStatus, const U32 _uInterval, union SIGNAL **_sig);
#endif


#ifdef LITTLE_ENDIAN
void convert_DBGSetPriMeasurementStatus(struct DBGSetPriMeasurementStatus *_sig);
#else
#define convert_DBGSetPriMeasurementStatus(_sig)
#endif





/*
 *===========================================================================
 * DBGSETPRIMEASUREMENTSTATUSREPLY
 *===========================================================================
 *
 * Description:
 * Sent as reply to DBGSetPriMeasurementStatus
  *
 * Parameters:
 *   measurementStatus:    0 if inactive, 1 if active
 *   uInterval:    integration interval in microseconds, valid if active
 *   currentTimeTick:    Tick at current time
 *   currentTimeUTick:    microseconds after tick stamp
 */
#define DBGSETPRIMEASUREMENTSTATUSREPLY 33001   /* !-SIGNO(struct DBGSetPriMeasurementStatusReply)-! */
struct DBGSetPriMeasurementStatusReply {
   U32 sigNo;
   U32 size;
   U32 measurementStatus ;
   U32 uInterval ;
   U32 currentTimeTick ;
   U32 currentTimeUTick ;
};
_GLOBAL void create_DBGSetPriMeasurementStatusReply(const U32 _measurementStatus, const U32 _uInterval, const U32 _currentTimeTick, const U32 _currentTimeUTick, union SIGNAL **_sig);


#ifdef LITTLE_ENDIAN
void convert_DBGSetPriMeasurementStatusReply(struct DBGSetPriMeasurementStatusReply *_sig);
#else
#define convert_DBGSetPriMeasurementStatusReply(_sig)
#endif





/*
 *===========================================================================
 * DBGGETPROCMEASUREMENTSTATUS
 *===========================================================================
 *
 * Description:
 * Sent to query about current state of the Process level measurement
  *
 * Parameters:
 */
#define DBGGETPROCMEASUREMENTSTATUS 33002   /* !-SIGNO(struct DBGGetProcMeasurementStatus)-! */
struct DBGGetProcMeasurementStatus {
   U32 sigNo;
   U32 size;
};
#ifdef IS_DBGSERVER_CLIENT
_GLOBAL void create_DBGGetProcMeasurementStatus(union SIGNAL **_sig);
#endif


#ifdef LITTLE_ENDIAN
void convert_DBGGetProcMeasurementStatus(struct DBGGetProcMeasurementStatus *_sig);
#else
#define convert_DBGGetProcMeasurementStatus(_sig)
#endif





/*
 *===========================================================================
 * DBGGETPROCMEASUREMENTSTATUSREPLY
 *===========================================================================
 *
 * Description:
 * Sent as reply to DBGGetCPUMeasurementStatus
  *
 * Parameters:
 *   measurementStatus:    0 if inactive, 1 if active
 *   uInterval:    integration interval in microseconds, valid if active
 *   currentTimeTick:    Tick at current time
 *   currentTimeUTick:    microseconds after tick stamp
 *   procSpec:    concatenated wildcard strings. Each is 0 term, last is 00 term.
 */
#define DBGGETPROCMEASUREMENTSTATUSREPLY 33003   /* !-SIGNO(struct DBGGetProcMeasurementStatusReply)-! */
struct DBGGetProcMeasurementStatusReply {
   U32 sigNo;
   U32 size;
   U32 measurementStatus ;
   U32 uInterval ;
   U32 currentTimeTick ;
   U32 currentTimeUTick ;
};
_GLOBAL void create_DBGGetProcMeasurementStatusReply(const U32 _measurementStatus, const U32 _uInterval, const U32 _currentTimeTick, const U32 _currentTimeUTick, const U8 *_procSpec, U32 _procSpecSize, union SIGNAL **_sig);


#ifdef LITTLE_ENDIAN
void convert_DBGGetProcMeasurementStatusReply(struct DBGGetProcMeasurementStatusReply *_sig);
#else
#define convert_DBGGetProcMeasurementStatusReply(_sig)
#endif


#define DBGGetProcMeasurementStatusReply_get_procSpec_size(XXsig, XXretVal) do {\
   U8 *XXptr = (U8*)XXsig + ALIGN_SIZE(24);\
   XXretVal = *(U32*)XXptr;\
}while(0)
#define DBGGetProcMeasurementStatusReply_get_procSpec(XXsig, XXretVal) do {\
   U8 *XXptr = (U8*)XXsig + ALIGN_SIZE(24);\
   XXretVal = (U8*)(XXptr+4);\
}while(0)



/*
 *===========================================================================
 * DBGSETPROCMEASUREMENTSTATUS
 *===========================================================================
 *
 * Description:
 * Sent to change current state of the Priority level measurement
  *
 * Parameters:
 *   measurementStatus:    0 to inactive, 1 to activate
 *   uInterval:    integration interval in microseconds, valid if active
 *   procSpec:    concatenated wildcard strings. Each is 0 term, last is 00 term.
 */
#define DBGSETPROCMEASUREMENTSTATUS 33004   /* !-SIGNO(struct DBGSetProcMeasurementStatus)-! */
struct DBGSetProcMeasurementStatus {
   U32 sigNo;
   U32 size;
   U32 measurementStatus ;
   U32 uInterval ;
};
#ifdef IS_DBGSERVER_CLIENT
_GLOBAL void create_DBGSetProcMeasurementStatus(const U32 _measurementStatus, const U32 _uInterval, const U8 *_procSpec, U32 _procSpecSize, union SIGNAL **_sig);
#endif


#ifdef LITTLE_ENDIAN
void convert_DBGSetProcMeasurementStatus(struct DBGSetProcMeasurementStatus *_sig);
#else
#define convert_DBGSetProcMeasurementStatus(_sig)
#endif


#define DBGSetProcMeasurementStatus_get_procSpec_size(XXsig, XXretVal) do {\
   U8 *XXptr = (U8*)XXsig + ALIGN_SIZE(16);\
   XXretVal = *(U32*)XXptr;\
}while(0)
#define DBGSetProcMeasurementStatus_get_procSpec(XXsig, XXretVal) do {\
   U8 *XXptr = (U8*)XXsig + ALIGN_SIZE(16);\
   XXretVal = (U8*)(XXptr+4);\
}while(0)



/*
 *===========================================================================
 * DBGSETPROCMEASUREMENTSTATUSREPLY
 *===========================================================================
 *
 * Description:
 * Sent as reply to DBGSetProcMeasurementStatus
  *
 * Parameters:
 *   measurementStatus:    0 if inactive, 1 if active
 *   uInterval:    integration interval in microseconds, valid if active
 *   currentTimeTick:    Tick at current time
 *   currentTimeUTick:    microseconds after tick stamp
 */
#define DBGSETPROCMEASUREMENTSTATUSREPLY 33005   /* !-SIGNO(struct DBGSetProcMeasurementStatusReply)-! */
struct DBGSetProcMeasurementStatusReply {
   U32 sigNo;
   U32 size;
   U32 measurementStatus ;
   U32 uInterval ;
   U32 currentTimeTick ;
   U32 currentTimeUTick ;
};
_GLOBAL void create_DBGSetProcMeasurementStatusReply(const U32 _measurementStatus, const U32 _uInterval, const U32 _currentTimeTick, const U32 _currentTimeUTick, union SIGNAL **_sig);


#ifdef LITTLE_ENDIAN
void convert_DBGSetProcMeasurementStatusReply(struct DBGSetProcMeasurementStatusReply *_sig);
#else
#define convert_DBGSetProcMeasurementStatusReply(_sig)
#endif





/*
 *===========================================================================
 * DBGGETCPULOADREPORTS
 *===========================================================================
 *
 * Description:
 * Sent to query a number of load reports from a
 * CPU load measurement
 * Requests are made for a number of reports that have a later time stamp
 * (tick and microtick), but not equal, than that specified.
  *
 * Parameters:
 *   receivedTimeTick:    send reports having later tick stamp
 *   receivedTimeUTick:    microseconds after tick stamp, if stamps zero get all
 *   count:    Number of reports to get.
 */
#define DBGGETCPULOADREPORTS 33006   /* !-SIGNO(struct DBGGetCPULoadReports)-! */
struct DBGGetCPULoadReports {
   U32 sigNo;
   U32 size;
   U32 receivedTimeTick ;
   U32 receivedTimeUTick ;
   U16 count ;
};
#ifdef IS_DBGSERVER_CLIENT
_GLOBAL void create_DBGGetCPULoadReports(const U32 _receivedTimeTick, const U32 _receivedTimeUTick, const U16 _count, union SIGNAL **_sig);
#endif


#ifdef LITTLE_ENDIAN
void convert_DBGGetCPULoadReports(struct DBGGetCPULoadReports *_sig);
#else
#define convert_DBGGetCPULoadReports(_sig)
#endif





/*
 *===========================================================================
 * DBGGETCPULOADREPORTSREPLY
 *===========================================================================
 *
 * Description:
 * Sent as reply to DBGGetCPULoadReports
 * reports contains load reports, the contents 16 bytes
 * is specified as:
 * U32 createTimeTick;    // tick stamp of report
 * U32 createTimeUTick;   // microseconds after tick stamp
 * U32 busy;              // in percent or another unit, always use 100*busy/total
 * U32 total;             // 100 percent or another unit
 *
  *
 * Parameters:
 *   measurementStatus:    0 if inactive, 1 if active
 *   currentTimeTick:    Tick at current time
 *   currentTimeUTick:    microseconds after tick stamp
 *   reports:    Reports grouped 16 bytes each. See above for mapping
 */
#define DBGGETCPULOADREPORTSREPLY 33007   /* !-SIGNO(struct DBGGetCPULoadReportsReply)-! */
struct DBGGetCPULoadReportsReply {
   U32 sigNo;
   U32 size;
   U32 measurementStatus ;
   U32 currentTimeTick ;
   U32 currentTimeUTick ;
};
_GLOBAL void create_DBGGetCPULoadReportsReply(const U32 _measurementStatus, const U32 _currentTimeTick, const U32 _currentTimeUTick, const U32 *_reports, U32 _reportsSize, union SIGNAL **_sig);


#ifdef LITTLE_ENDIAN
void convert_DBGGetCPULoadReportsReply(struct DBGGetCPULoadReportsReply *_sig);
#else
#define convert_DBGGetCPULoadReportsReply(_sig)
#endif


#define DBGGetCPULoadReportsReply_get_reports_size(XXsig, XXretVal) do {\
   U8 *XXptr = (U8*)XXsig + ALIGN_SIZE(20);\
   XXretVal = *(U32*)XXptr;\
}while(0)
#define DBGGetCPULoadReportsReply_get_reports(XXsig, XXretVal) do {\
   U8 *XXptr = (U8*)XXsig + ALIGN_SIZE(20);\
   XXretVal = (U32*)(XXptr+4);\
}while(0)



/*
 *===========================================================================
 * DBGINFOCPULOADREPORTSENDMARK
 *===========================================================================
 *
 * Description:
 * Signals the end of CPU load reports
  *
 * Parameters:
 */
#define DBGINFOCPULOADREPORTSENDMARK 33008   /* !-SIGNO(struct DBGInfoCPULoadReportsEndMark)-! */
struct DBGInfoCPULoadReportsEndMark {
   U32 sigNo;
   U32 size;
};
_GLOBAL void create_DBGInfoCPULoadReportsEndMark(union SIGNAL **_sig);


#ifdef LITTLE_ENDIAN
void convert_DBGInfoCPULoadReportsEndMark(struct DBGInfoCPULoadReportsEndMark *_sig);
#else
#define convert_DBGInfoCPULoadReportsEndMark(_sig)
#endif





/*
 *===========================================================================
 * DBGGETPRILOADREPORTS
 *===========================================================================
 *
 * Description:
 * Sent to query a number of load reports from a
 * Pri load measurement
 * Requests are made for a number of reports that have a later time stamp
 * (tick and microtick), but not equal, than that specified.
  *
 * Parameters:
 *   receivedTimeTick:    send reports having later tick stamp
 *   receivedTimeUTick:    microseconds after tick stamp, if stamps zero get all
 *   count:    Number of reports to get.
 */
#define DBGGETPRILOADREPORTS 33009   /* !-SIGNO(struct DBGGetPriLoadReports)-! */
struct DBGGetPriLoadReports {
   U32 sigNo;
   U32 size;
   U32 receivedTimeTick ;
   U32 receivedTimeUTick ;
   U16 count ;
};
#ifdef IS_DBGSERVER_CLIENT
_GLOBAL void create_DBGGetPriLoadReports(const U32 _receivedTimeTick, const U32 _receivedTimeUTick, const U16 _count, union SIGNAL **_sig);
#endif


#ifdef LITTLE_ENDIAN
void convert_DBGGetPriLoadReports(struct DBGGetPriLoadReports *_sig);
#else
#define convert_DBGGetPriLoadReports(_sig)
#endif





/*
 *===========================================================================
 * DBGGETPRILOADREPORTSREPLY
 *===========================================================================
 *
 * Description:
 * Sent as reply to DBGGetPriLoadReports
 * reports contains load reports, the contents 37*4 bytes
 * is specified as:
 * U32 createTimeTick;    // tick stamp of report
 * U32 createTimeUTick;   // microseconds after tick stamp
 * U32 intBusy;           // in percent or another unit, always use 100*intBusy/total
 * U32 bgBusy;            // in percent or another unit, always use 100*bgBusy/total
 * U32 total;             // 100 percent or another unit
 * U32 priBusy[ 32 ]      // in percent or another unit, always use 100*priBusy/total
 *
  *
 * Parameters:
 *   measurementStatus:    0 if inactive, 1 if active
 *   currentTimeTick:    Tick at current time
 *   currentTimeUTick:    microseconds after tick stamp
 *   reports:    Reports grouped 37*4 bytes each. See above for mapping
 */
#define DBGGETPRILOADREPORTSREPLY 33010   /* !-SIGNO(struct DBGGetPriLoadReportsReply)-! */
struct DBGGetPriLoadReportsReply {
   U32 sigNo;
   U32 size;
   U32 measurementStatus ;
   U32 currentTimeTick ;
   U32 currentTimeUTick ;
};
_GLOBAL void create_DBGGetPriLoadReportsReply(const U32 _measurementStatus, const U32 _currentTimeTick, const U32 _currentTimeUTick, const U32 *_reports, U32 _reportsSize, union SIGNAL **_sig);


#ifdef LITTLE_ENDIAN
void convert_DBGGetPriLoadReportsReply(struct DBGGetPriLoadReportsReply *_sig);
#else
#define convert_DBGGetPriLoadReportsReply(_sig)
#endif


#define DBGGetPriLoadReportsReply_get_reports_size(XXsig, XXretVal) do {\
   U8 *XXptr = (U8*)XXsig + ALIGN_SIZE(20);\
   XXretVal = *(U32*)XXptr;\
}while(0)
#define DBGGetPriLoadReportsReply_get_reports(XXsig, XXretVal) do {\
   U8 *XXptr = (U8*)XXsig + ALIGN_SIZE(20);\
   XXretVal = (U32*)(XXptr+4);\
}while(0)



/*
 *===========================================================================
 * DBGINFOPRILOADREPORTSENDMARK
 *===========================================================================
 *
 * Description:
 * Signals the end of CPU load reports
  *
 * Parameters:
 */
#define DBGINFOPRILOADREPORTSENDMARK 33011   /* !-SIGNO(struct DBGInfoPriLoadReportsEndMark)-! */
struct DBGInfoPriLoadReportsEndMark {
   U32 sigNo;
   U32 size;
};
_GLOBAL void create_DBGInfoPriLoadReportsEndMark(union SIGNAL **_sig);


#ifdef LITTLE_ENDIAN
void convert_DBGInfoPriLoadReportsEndMark(struct DBGInfoPriLoadReportsEndMark *_sig);
#else
#define convert_DBGInfoPriLoadReportsEndMark(_sig)
#endif





/*
 *===========================================================================
 * DBGGETPROCLOADREPORTS
 *===========================================================================
 *
 * Description:
 * Sent to query a number of load reports from a
 * Proc load measurement
 * Requests are made for a number of reports that have a later time stamp
 * (tick and microtick), but not equal, than that specified.
  *
 * Parameters:
 *   receivedTimeTick:    send reports having later tick stamp
 *   receivedTimeUTick:    microseconds after tick stamp, if stamps zero get all
 *   count:    Number of reports to get.
 */
#define DBGGETPROCLOADREPORTS 33012   /* !-SIGNO(struct DBGGetProcLoadReports)-! */
struct DBGGetProcLoadReports {
   U32 sigNo;
   U32 size;
   U32 receivedTimeTick ;
   U32 receivedTimeUTick ;
   U16 count ;
};
#ifdef IS_DBGSERVER_CLIENT
_GLOBAL void create_DBGGetProcLoadReports(const U32 _receivedTimeTick, const U32 _receivedTimeUTick, const U16 _count, union SIGNAL **_sig);
#endif


#ifdef LITTLE_ENDIAN
void convert_DBGGetProcLoadReports(struct DBGGetProcLoadReports *_sig);
#else
#define convert_DBGGetProcLoadReports(_sig)
#endif





/*
 *===========================================================================
 * DBGGETPROCLOADREPORTSREPLY
 *===========================================================================
 *
 * Description:
 * Sent as reply to DBGGetProcLoadReports
 * reports contains load reports, the contents 20*4 bytes
 * is specified as:
 * U32 createTimeTick;    // tick stamp of report
 * U32 createTimeUTick;   // microseconds after tick stamp
 * U32 otherBusy;         // in percent or another unit, always use 100*otherBusy/total
 * U32 total;             // 100 percent or another unit
 * U32 pids[ 8 ];         // pids of processes
 * U32 procBusy[ 8 ]      // in percent or another unit, always use 100*procBusy/total
 *
  *
 * Parameters:
 *   measurementStatus:    0 if inactive, 1 if active
 *   currentTimeTick:    Tick at current time
 *   currentTimeUTick:    microseconds after tick stamp
 *   reports:    Reports grouped 20*4 bytes each. See above for mapping
 */
#define DBGGETPROCLOADREPORTSREPLY 33013   /* !-SIGNO(struct DBGGetProcLoadReportsReply)-! */
struct DBGGetProcLoadReportsReply {
   U32 sigNo;
   U32 size;
   U32 measurementStatus ;
   U32 currentTimeTick ;
   U32 currentTimeUTick ;
};
_GLOBAL void create_DBGGetProcLoadReportsReply(const U32 _measurementStatus, const U32 _currentTimeTick, const U32 _currentTimeUTick, const U32 *_reports, U32 _reportsSize, union SIGNAL **_sig);


#ifdef LITTLE_ENDIAN
void convert_DBGGetProcLoadReportsReply(struct DBGGetProcLoadReportsReply *_sig);
#else
#define convert_DBGGetProcLoadReportsReply(_sig)
#endif


#define DBGGetProcLoadReportsReply_get_reports_size(XXsig, XXretVal) do {\
   U8 *XXptr = (U8*)XXsig + ALIGN_SIZE(20);\
   XXretVal = *(U32*)XXptr;\
}while(0)
#define DBGGetProcLoadReportsReply_get_reports(XXsig, XXretVal) do {\
   U8 *XXptr = (U8*)XXsig + ALIGN_SIZE(20);\
   XXretVal = (U32*)(XXptr+4);\
}while(0)



/*
 *===========================================================================
 * DBGINFOPROCLOADREPORTSENDMARK
 *===========================================================================
 *
 * Description:
 * Signals the end of CPU load reports
 * End CPU profiler changes bjjo
  *
 * Parameters:
 */
#define DBGINFOPROCLOADREPORTSENDMARK 33014   /* !-SIGNO(struct DBGInfoProcLoadReportsEndMark)-! */
struct DBGInfoProcLoadReportsEndMark {
   U32 sigNo;
   U32 size;
};
_GLOBAL void create_DBGInfoProcLoadReportsEndMark(union SIGNAL **_sig);


#ifdef LITTLE_ENDIAN
void convert_DBGInfoProcLoadReportsEndMark(struct DBGInfoProcLoadReportsEndMark *_sig);
#else
#define convert_DBGInfoProcLoadReportsEndMark(_sig)
#endif





/*
 *===========================================================================
 * DBGGETSIGNALQUEUEFULL
 *===========================================================================
 *
 * Description:
 * Sent from the debugger client to the debug server to get the
 * signal queue for a process (without signal contents).
 * see also DBGGetSignalQueue.
  *
 * Parameters:
 *   pid:    The pid of the process wich have the signal queue
 */
#define DBGGETSIGNALQUEUEFULL 33015   /* !-SIGNO(struct DBGGetSignalQueueFull)-! */
struct DBGGetSignalQueueFull {
   U32 sigNo;
   U32 size;
   U32 pid ;
};
#ifdef IS_DBGSERVER_CLIENT
_GLOBAL void create_DBGGetSignalQueueFull(const U32 _pid, union SIGNAL **_sig);
#endif


#ifdef LITTLE_ENDIAN
void convert_DBGGetSignalQueueFull(struct DBGGetSignalQueueFull *_sig);
#else
#define convert_DBGGetSignalQueueFull(_sig)
#endif





/*
 *===========================================================================
 * DBGGETSIGNALQUEUEFULLREPLY
 *===========================================================================
 *
 * Description:
 * Sent from the debug server to the debug client as a reply
 * to DBG_GET_SIGNAL_QUEUE_FULL. The signal contains one entry in
 * the signal queue. The Last signal sent is followed by
 * a DBGINFO_QUEUE_END_MARK signal.
  *
 * Parameters:
 *   pid:    The pid of the process holding the signal queue.
 *   from:    Pid of the sender.
 *   addressee:    The pid of the addressee.
 *   signalSize:    Number of bytes in the signal.
 *   signalNumber:    The signal number.
 *   entry:    Position in the signal queue.
 *   data:    Signal contents (including signo).
 */
#define DBGGETSIGNALQUEUEFULLREPLY 33016   /* !-SIGNO(struct DBGGetSignalQueueFullReply)-! */
struct DBGGetSignalQueueFullReply {
   U32 sigNo;
   U32 size;
   U32 pid ;
   U32 from ;
   U32 addressee ;
   U32 signalSize ;
   U32 signalNumber ;
   U32 entry ;
};
_GLOBAL void create_DBGGetSignalQueueFullReply(const U32 _pid, const U32 _from, const U32 _addressee, const U32 _signalSize, const U32 _signalNumber, const U32 _entry, const U8 *_data, U32 _dataSize, union SIGNAL **_sig);


#ifdef LITTLE_ENDIAN
void convert_DBGGetSignalQueueFullReply(struct DBGGetSignalQueueFullReply *_sig);
#else
#define convert_DBGGetSignalQueueFullReply(_sig)
#endif


#define DBGGetSignalQueueFullReply_get_data_size(XXsig, XXretVal) do {\
   U8 *XXptr = (U8*)XXsig + ALIGN_SIZE(32);\
   XXretVal = *(U32*)XXptr;\
}while(0)
#define DBGGetSignalQueueFullReply_get_data(XXsig, XXretVal) do {\
   U8 *XXptr = (U8*)XXsig + ALIGN_SIZE(32);\
   XXretVal = (U8*)(XXptr+4);\
}while(0)



/*
 *===========================================================================
 * DBGINFOQUEUEFULLENDMARK
 *===========================================================================
 *
 * Description:
 * Sent by the debug server as the last signal in a getSignalQueueFull
 * request which can yield into several reply signals.
  *
 * Parameters:
 *   pid:    The pid for which the request conserned
 */
#define DBGINFOQUEUEFULLENDMARK 33017   /* !-SIGNO(struct DBGInfoQueueFullEndMark)-! */
struct DBGInfoQueueFullEndMark {
   U32 sigNo;
   U32 size;
   U32 pid ;
};
_GLOBAL void create_DBGInfoQueueFullEndMark(const U32 _pid, union SIGNAL **_sig);


#ifdef LITTLE_ENDIAN
void convert_DBGInfoQueueFullEndMark(struct DBGInfoQueueFullEndMark *_sig);
#else
#define convert_DBGInfoQueueFullEndMark(_sig)
#endif





/*
 *===========================================================================
 * DBGIOPCSESSIONINIT
 *===========================================================================
 *
 * Description:
 * Illuminator to OSE process communication, bjjo
 *
 * Sent to initiate an IOPC Session.
 * Server process can be identified either by pid,
 * or by hunt path (if pid zero).
 * An array of signal numbers has the following use:
 * If the dbgserver receives any of these signals, it
 * signals the end of the session.
 *
 * An DBGIOPCSessionStatus is sent to Illuminator,
 * either as response to the initiation
 * of a session, or as a result of reception of an
 * endmark signal. 
  *
 * Parameters:
 *   pid:    The pid of the process to which the signal is sent.
 *   huntTimeout:    Millisecond timeout for hunt completion.
 *   endMarkSignals:    An array of signal numbers that ends the session.
 *   huntPath:    If pid zero, hunt path to use instead.
 */
#define DBGIOPCSESSIONINIT 33018   /* !-SIGNO(struct DBGIOPCSessionInit)-! */
struct DBGIOPCSessionInit {
   U32 sigNo;
   U32 size;
   U32 pid ;
   U32 huntTimeout ;
};
_GLOBAL void create_DBGIOPCSessionInit(const U32 _pid, const U32 _huntTimeout, const U32 *_endMarkSignals, U32 _endMarkSignalsSize, const char *_huntPath, union SIGNAL **_sig);


#ifdef LITTLE_ENDIAN
void convert_DBGIOPCSessionInit(struct DBGIOPCSessionInit *_sig);
#else
#define convert_DBGIOPCSessionInit(_sig)
#endif


#define DBGIOPCSessionInit_get_endMarkSignals_size(XXsig, XXretVal) do {\
   U8 *XXptr = (U8*)XXsig + ALIGN_SIZE(16);\
   XXretVal = *(U32*)XXptr;\
}while(0)
#define DBGIOPCSessionInit_get_endMarkSignals(XXsig, XXretVal) do {\
   U8 *XXptr = (U8*)XXsig + ALIGN_SIZE(16);\
   XXretVal = (U32*)(XXptr+4);\
}while(0)
#define DBGIOPCSessionInit_get_huntPath_size(XXsig, XXretVal) do {\
   U8 *XXptr = (U8*)XXsig + ALIGN_SIZE(16);\
   XXptr += ALIGN_SIZE( *((U32*)XXptr) ) + 4;\
   XXretVal = *(U32*)XXptr;\
}while(0)
#define DBGIOPCSessionInit_get_huntPath(XXsig, XXretVal) do {\
   U8 *XXptr = (U8*)XXsig + ALIGN_SIZE(16);\
   XXptr += ALIGN_SIZE( *((U32*)XXptr) ) + 4;\
   XXretVal = (char*)(XXptr+4);\
}while(0)



/*
 *===========================================================================
 * DBGIOPCSESSIONTERMINATE
 *===========================================================================
 *
 * Description:
 * Sent to terminate an IOPC Session
 * Session handle is received in the DBGIOPCSessionStatus message.
  *
 * Parameters:
 *   sessionHandle:    Session handle
 */
#define DBGIOPCSESSIONTERMINATE 33019   /* !-SIGNO(struct DBGIOPCSessionTerminate)-! */
struct DBGIOPCSessionTerminate {
   U32 sigNo;
   U32 size;
   U32 sessionHandle ;
};
#ifdef IS_DBGSERVER_CLIENT
_GLOBAL void create_DBGIOPCSessionTerminate(const U32 _sessionHandle, union SIGNAL **_sig);
#endif


#ifdef LITTLE_ENDIAN
void convert_DBGIOPCSessionTerminate(struct DBGIOPCSessionTerminate *_sig);
#else
#define convert_DBGIOPCSessionTerminate(_sig)
#endif





/*
 *===========================================================================
 * DBGIOPCSESSIONSTATUS
 *===========================================================================
 *
 * Description:
 * Received to indicate status of a session
 * status:
 *   0 - session established
 *   non-zero: session terminated
 *     1 - target process couldn't be found (hunt timeout)
 *     2 - invalid target process
 *     3 - lost connection to target process.
 *     4 - session terminated gracefully.
 *
 * sessionHandle:
 *   This is a handle to the initiated session.
 *   If status is 1 or 2, a session couldn't be established and sessionHandle == 0
 *
 * targetPid:
 *   Pid of attached target process. (Only valid if status == 0, 3 or 4)
 *
 * data
 *   Optional signal received from target process.
  *
 * Parameters:
 *   status:    Status of the session (see above)
 *   sessionHandle:    The current session. (zero if status == 1)
 *   targetPid:    The pid of the attached target process.
 */
#define DBGIOPCSESSIONSTATUS 33020   /* !-SIGNO(struct DBGIOPCSessionStatus)-! */
struct DBGIOPCSessionStatus {
   U32 sigNo;
   U32 size;
   U32 status ;
   U32 sessionHandle ;
   U32 targetPid ;
};
_GLOBAL void create_DBGIOPCSessionStatus(const U32 _status, const U32 _sessionHandle, const U32 _targetPid, union SIGNAL **_sig);


#ifdef LITTLE_ENDIAN
void convert_DBGIOPCSessionStatus(struct DBGIOPCSessionStatus *_sig);
#else
#define convert_DBGIOPCSessionStatus(_sig)
#endif





/*
 *===========================================================================
 * DBGIOPCSIGNAL
 *===========================================================================
 *
 * Description:
 * This signal encapsulates a signal received from or to be sent to
 * the target process.
  *
 * Parameters:
 *   sessionHandle:    The current session.
 *   pid:    The receiver or sender of the signal.
 *   data:    Signal (including signo) data.
 */
#define DBGIOPCSIGNAL 33021   /* !-SIGNO(struct DBGIOPCSignal)-! */
struct DBGIOPCSignal {
   U32 sigNo;
   U32 size;
   U32 sessionHandle ;
   U32 pid ;
};
_GLOBAL void create_DBGIOPCSignal(const U32 _sessionHandle, const U32 _pid, const U8 *_data, U32 _dataSize, union SIGNAL **_sig);


#ifdef LITTLE_ENDIAN
void convert_DBGIOPCSignal(struct DBGIOPCSignal *_sig);
#else
#define convert_DBGIOPCSignal(_sig)
#endif


#define DBGIOPCSignal_get_data_size(XXsig, XXretVal) do {\
   U8 *XXptr = (U8*)XXsig + ALIGN_SIZE(16);\
   XXretVal = *(U32*)XXptr;\
}while(0)
#define DBGIOPCSignal_get_data(XXsig, XXretVal) do {\
   U8 *XXptr = (U8*)XXsig + ALIGN_SIZE(16);\
   XXretVal = (U8*)(XXptr+4);\
}while(0)



/*
 *===========================================================================
 * DBGWRITEMEMORY
 *===========================================================================
 *
 * Description:
 * Sent to write a block of memory
  *
 * Parameters:
 *   blockid:    Read the memory in the context of this block.
 *   address:    Start address
 *   bytes:    The data
 */
#define DBGWRITEMEMORY 33022   /* !-SIGNO(struct DBGWriteMemory)-! */
struct DBGWriteMemory {
   U32 sigNo;
   U32 size;
   U32 blockid ;
   U32 address ;
};
#ifdef IS_DBGSERVER_CLIENT
_GLOBAL void create_DBGWriteMemory(const U32 _blockid, const U32 _address, const U8 *_bytes, U32 _bytesSize, union SIGNAL **_sig);
#endif


#ifdef LITTLE_ENDIAN
void convert_DBGWriteMemory(struct DBGWriteMemory *_sig);
#else
#define convert_DBGWriteMemory(_sig)
#endif


#define DBGWriteMemory_get_bytes_size(XXsig, XXretVal) do {\
   U8 *XXptr = (U8*)XXsig + ALIGN_SIZE(16);\
   XXretVal = *(U32*)XXptr;\
}while(0)
#define DBGWriteMemory_get_bytes(XXsig, XXretVal) do {\
   U8 *XXptr = (U8*)XXsig + ALIGN_SIZE(16);\
   XXretVal = (U8*)(XXptr+4);\
}while(0)



/*
 *===========================================================================
 * DBGWRITEMEMORYREPLY
 *===========================================================================
 *
 * Description:
 * Sent to write a block of memory
  *
 * Parameters:
 *   status:    0 if OK
 */
#define DBGWRITEMEMORYREPLY 33023   /* !-SIGNO(struct DBGWriteMemoryReply)-! */
struct DBGWriteMemoryReply {
   U32 sigNo;
   U32 size;
   U32 status ;
};
_GLOBAL void create_DBGWriteMemoryReply(const U32 _status, union SIGNAL **_sig);


#ifdef LITTLE_ENDIAN
void convert_DBGWriteMemoryReply(struct DBGWriteMemoryReply *_sig);
#else
#define convert_DBGWriteMemoryReply(_sig)
#endif





/*
 *===========================================================================
 * DBGREADREGISTER
 *===========================================================================
 *
 * Description:
 * Sent to read a set of registers
  *
 * Parameters:
 *   pid:    The process of which to read registers
 *   regVal:    The registers to read 
 */
#define DBGREADREGISTER 33024   /* !-SIGNO(struct DBGReadRegister)-! */
struct DBGReadRegister {
   U32 sigNo;
   U32 size;
   U32 pid ;
};
#ifdef IS_DBGSERVER_CLIENT
_GLOBAL void create_DBGReadRegister(const U32 _pid, const U32 *_regVal, U32 _regValSize, union SIGNAL **_sig);
#endif


#ifdef LITTLE_ENDIAN
void convert_DBGReadRegister(struct DBGReadRegister *_sig);
#else
#define convert_DBGReadRegister(_sig)
#endif


#define DBGReadRegister_get_regVal_size(XXsig, XXretVal) do {\
   U8 *XXptr = (U8*)XXsig + ALIGN_SIZE(12);\
   XXretVal = *(U32*)XXptr;\
}while(0)
#define DBGReadRegister_get_regVal(XXsig, XXretVal) do {\
   U8 *XXptr = (U8*)XXsig + ALIGN_SIZE(12);\
   XXretVal = (U32*)(XXptr+4);\
}while(0)



/*
 *===========================================================================
 * DBGREADREGISTERREPLY
 *===========================================================================
 *
 * Description:
 * Sent to read a set of registers
  *
 * Parameters:
 *   status:    0 if OK
 *   regVal:    The registers and their values	
 */
#define DBGREADREGISTERREPLY 33025   /* !-SIGNO(struct DBGReadRegisterReply)-! */
struct DBGReadRegisterReply {
   U32 sigNo;
   U32 size;
   U32 status ;
};
_GLOBAL void create_DBGReadRegisterReply(const U32 _status, const U32 *_regVal, U32 _regValSize, union SIGNAL **_sig);


#ifdef LITTLE_ENDIAN
void convert_DBGReadRegisterReply(struct DBGReadRegisterReply *_sig);
#else
#define convert_DBGReadRegisterReply(_sig)
#endif


#define DBGReadRegisterReply_get_regVal_size(XXsig, XXretVal) do {\
   U8 *XXptr = (U8*)XXsig + ALIGN_SIZE(12);\
   XXretVal = *(U32*)XXptr;\
}while(0)
#define DBGReadRegisterReply_get_regVal(XXsig, XXretVal) do {\
   U8 *XXptr = (U8*)XXsig + ALIGN_SIZE(12);\
   XXretVal = (U32*)(XXptr+4);\
}while(0)



/*
 *===========================================================================
 * DBGWRITEREGISTER
 *===========================================================================
 *
 * Description:
 * Sent to write a set of registers 
  *
 * Parameters:
 *   pid:    The process of which to write registers 
 *   regVal:    The registers and their values
 */
#define DBGWRITEREGISTER 33026   /* !-SIGNO(struct DBGWriteRegister)-! */
struct DBGWriteRegister {
   U32 sigNo;
   U32 size;
   U32 pid ;
};
#ifdef IS_DBGSERVER_CLIENT
_GLOBAL void create_DBGWriteRegister(const U32 _pid, const U32 *_regVal, U32 _regValSize, union SIGNAL **_sig);
#endif


#ifdef LITTLE_ENDIAN
void convert_DBGWriteRegister(struct DBGWriteRegister *_sig);
#else
#define convert_DBGWriteRegister(_sig)
#endif


#define DBGWriteRegister_get_regVal_size(XXsig, XXretVal) do {\
   U8 *XXptr = (U8*)XXsig + ALIGN_SIZE(12);\
   XXretVal = *(U32*)XXptr;\
}while(0)
#define DBGWriteRegister_get_regVal(XXsig, XXretVal) do {\
   U8 *XXptr = (U8*)XXsig + ALIGN_SIZE(12);\
   XXretVal = (U32*)(XXptr+4);\
}while(0)



/*
 *===========================================================================
 * DBGWRITEREGISTERREPLY
 *===========================================================================
 *
 * Description:
 * Sent to write a set of registers 
  *
 * Parameters:
 *   status:    0 if OK
 *   regVal:    The registers and their values
 */
#define DBGWRITEREGISTERREPLY 33027   /* !-SIGNO(struct DBGWriteRegisterReply)-! */
struct DBGWriteRegisterReply {
   U32 sigNo;
   U32 size;
   U32 status ;
};
_GLOBAL void create_DBGWriteRegisterReply(const U32 _status, const U32 *_regVal, U32 _regValSize, union SIGNAL **_sig);


#ifdef LITTLE_ENDIAN
void convert_DBGWriteRegisterReply(struct DBGWriteRegisterReply *_sig);
#else
#define convert_DBGWriteRegisterReply(_sig)
#endif


#define DBGWriteRegisterReply_get_regVal_size(XXsig, XXretVal) do {\
   U8 *XXptr = (U8*)XXsig + ALIGN_SIZE(12);\
   XXretVal = *(U32*)XXptr;\
}while(0)
#define DBGWriteRegisterReply_get_regVal(XXsig, XXretVal) do {\
   U8 *XXptr = (U8*)XXsig + ALIGN_SIZE(12);\
   XXretVal = (U32*)(XXptr+4);\
}while(0)



/*
 *===========================================================================
 * DBGSETAPPLICATIONSCOPE
 *===========================================================================
 *
 * Description:
 * Sent to define the SDM application scope
  *
 * Parameters:
 *   scope_def:    The scope definition
 */
#define DBGSETAPPLICATIONSCOPE 33028   /* !-SIGNO(struct DBGSetApplicationScope)-! */
struct DBGSetApplicationScope {
   U32 sigNo;
   U32 size;
};
#ifdef IS_DBGSERVER_CLIENT
_GLOBAL void create_DBGSetApplicationScope(const U8 *_scope_def, U32 _scope_defSize, union SIGNAL **_sig);
#endif


#ifdef LITTLE_ENDIAN
void convert_DBGSetApplicationScope(struct DBGSetApplicationScope *_sig);
#else
#define convert_DBGSetApplicationScope(_sig)
#endif


#define DBGSetApplicationScope_get_scope_def_size(XXsig, XXretVal) do {\
   U8 *XXptr = (U8*)XXsig + ALIGN_SIZE(8);\
   XXretVal = *(U32*)XXptr;\
}while(0)
#define DBGSetApplicationScope_get_scope_def(XXsig, XXretVal) do {\
   U8 *XXptr = (U8*)XXsig + ALIGN_SIZE(8);\
   XXretVal = (U8*)(XXptr+4);\
}while(0)



/*
 *===========================================================================
 * DBGSETAPPLICATIONSCOPEREPLY
 *===========================================================================
 *
 * Description:
 * Sent to define the SDM application scope
  *
 * Parameters:
 *   status:    0 if OK
 */
#define DBGSETAPPLICATIONSCOPEREPLY 33029   /* !-SIGNO(struct DBGSetApplicationScopeReply)-! */
struct DBGSetApplicationScopeReply {
   U32 sigNo;
   U32 size;
   U32 status ;
};
_GLOBAL void create_DBGSetApplicationScopeReply(const U32 _status, union SIGNAL **_sig);


#ifdef LITTLE_ENDIAN
void convert_DBGSetApplicationScopeReply(struct DBGSetApplicationScopeReply *_sig);
#else
#define convert_DBGSetApplicationScopeReply(_sig)
#endif





/*
 *===========================================================================
 * DBGSETSOFTBP
 *===========================================================================
 *
 * Description:
 * Sent to define a soft breakpoint
 * NOTE If the dbgserver supports DBGSetBp that signal should be used
 * instead of this.
  *
 * Parameters:
 *   address:    The address of the breakpoint
 *   count:    The number of hits to be ignored
 *   triggCatch:    The trig and catch scopes
 */
#define DBGSETSOFTBP 33030   /* !-SIGNO(struct DBGSetSoftBp)-! */
struct DBGSetSoftBp {
   U32 sigNo;
   U32 size;
   U32 address ;
   U32 count ;
};
#ifdef IS_DBGSERVER_CLIENT
_GLOBAL void create_DBGSetSoftBp(const U32 _address, const U32 _count, const U8 *_triggCatch, U32 _triggCatchSize, union SIGNAL **_sig);
#endif


#ifdef LITTLE_ENDIAN
void convert_DBGSetSoftBp(struct DBGSetSoftBp *_sig);
#else
#define convert_DBGSetSoftBp(_sig)
#endif


#define DBGSetSoftBp_get_triggCatch_size(XXsig, XXretVal) do {\
   U8 *XXptr = (U8*)XXsig + ALIGN_SIZE(16);\
   XXretVal = *(U32*)XXptr;\
}while(0)
#define DBGSetSoftBp_get_triggCatch(XXsig, XXretVal) do {\
   U8 *XXptr = (U8*)XXsig + ALIGN_SIZE(16);\
   XXretVal = (U8*)(XXptr+4);\
}while(0)



/*
 *===========================================================================
 * DBGSETBPREPLY
 *===========================================================================
 *
 * Description:
 * Reply to DBGSetBp or DBGSetSoftBp
  *
 * Parameters:
 *   status:    0 if OK
 *   bpid:    The ID of the breakpoint
 */
#define DBGSETBPREPLY 33031   /* !-SIGNO(struct DBGSetBpReply)-! */
struct DBGSetBpReply {
   U32 sigNo;
   U32 size;
   U32 status ;
   U32 bpid ;
};
_GLOBAL void create_DBGSetBpReply(const U32 _status, const U32 _bpid, union SIGNAL **_sig);


#ifdef LITTLE_ENDIAN
void convert_DBGSetBpReply(struct DBGSetBpReply *_sig);
#else
#define convert_DBGSetBpReply(_sig)
#endif





/*
 *===========================================================================
 * DBGBPFIRED
 *===========================================================================
 *
 * Description:
 * Sent from DebugServer to responble client when a breakpoint is fired
  *
 * Parameters:
 *   bpid:    The ID of the breakpoint
 *   pid:    The process that trigged the breakpoint
 */
#define DBGBPFIRED 33032   /* !-SIGNO(struct DBGBpFired)-! */
struct DBGBpFired {
   U32 sigNo;
   U32 size;
   U32 bpid ;
   U32 pid ;
};
_GLOBAL void create_DBGBpFired(const U32 _bpid, const U32 _pid, union SIGNAL **_sig);


#ifdef LITTLE_ENDIAN
void convert_DBGBpFired(struct DBGBpFired *_sig);
#else
#define convert_DBGBpFired(_sig)
#endif





/*
 *===========================================================================
 * DBGCLEARBP
 *===========================================================================
 *
 * Description:
 * Sent to remove a breakpoint
  *
 * Parameters:
 *   bpid:    The ID of the breakpoint
 */
#define DBGCLEARBP 33033   /* !-SIGNO(struct DBGClearBp)-! */
struct DBGClearBp {
   U32 sigNo;
   U32 size;
   U32 bpid ;
};
#ifdef IS_DBGSERVER_CLIENT
_GLOBAL void create_DBGClearBp(const U32 _bpid, union SIGNAL **_sig);
#endif


#ifdef LITTLE_ENDIAN
void convert_DBGClearBp(struct DBGClearBp *_sig);
#else
#define convert_DBGClearBp(_sig)
#endif





/*
 *===========================================================================
 * DBGCLEARBPREPLY
 *===========================================================================
 *
 * Description:
 * Sent to remove a breakpoint
  *
 * Parameters:
 *   status:    0 if OK
 */
#define DBGCLEARBPREPLY 33034   /* !-SIGNO(struct DBGClearBpReply)-! */
struct DBGClearBpReply {
   U32 sigNo;
   U32 size;
   U32 status ;
};
_GLOBAL void create_DBGClearBpReply(const U32 _status, union SIGNAL **_sig);


#ifdef LITTLE_ENDIAN
void convert_DBGClearBpReply(struct DBGClearBpReply *_sig);
#else
#define convert_DBGClearBpReply(_sig)
#endif





/*
 *===========================================================================
 * DBGSTEPPROCESS
 *===========================================================================
 *
 * Description:
 * Sent to step a process over an address range
  *
 * Parameters:
 *   pid:    The process to step
 *   type:    Type: 1 over / 0 within
 *   start:    The start address
 *   end:    The end address
 */
#define DBGSTEPPROCESS 33035   /* !-SIGNO(struct DBGStepProcess)-! */
struct DBGStepProcess {
   U32 sigNo;
   U32 size;
   U32 pid ;
   U32 type ;
   U32 start ;
   U32 end ;
};
#ifdef IS_DBGSERVER_CLIENT
_GLOBAL void create_DBGStepProcess(const U32 _pid, const U32 _type, const U32 _start, const U32 _end, union SIGNAL **_sig);
#endif


#ifdef LITTLE_ENDIAN
void convert_DBGStepProcess(struct DBGStepProcess *_sig);
#else
#define convert_DBGStepProcess(_sig)
#endif





/*
 *===========================================================================
 * DBGSTEPPROCESSREPLY
 *===========================================================================
 *
 * Description:
 * Sent to step a process over an address range
  *
 * Parameters:
 *   status:    0 if OK
 */
#define DBGSTEPPROCESSREPLY 33036   /* !-SIGNO(struct DBGStepProcessReply)-! */
struct DBGStepProcessReply {
   U32 sigNo;
   U32 size;
   U32 status ;
};
_GLOBAL void create_DBGStepProcessReply(const U32 _status, union SIGNAL **_sig);


#ifdef LITTLE_ENDIAN
void convert_DBGStepProcessReply(struct DBGStepProcessReply *_sig);
#else
#define convert_DBGStepProcessReply(_sig)
#endif





/*
 *===========================================================================
 * DBGSTEPPROCESSCOMPLETE
 *===========================================================================
 *
 * Description:
 * Sent to step a process over an address range
  *
 * Parameters:
 *   pid:    The process that was stepped
 *   pc:    The current program counter
 *   status:    0 if OK
 */
#define DBGSTEPPROCESSCOMPLETE 33037   /* !-SIGNO(struct DBGStepProcessComplete)-! */
struct DBGStepProcessComplete {
   U32 sigNo;
   U32 size;
   U32 pid ;
   U32 pc ;
   U32 status ;
};
_GLOBAL void create_DBGStepProcessComplete(const U32 _pid, const U32 _pc, const U32 _status, union SIGNAL **_sig);


#ifdef LITTLE_ENDIAN
void convert_DBGStepProcessComplete(struct DBGStepProcessComplete *_sig);
#else
#define convert_DBGStepProcessComplete(_sig)
#endif





/*
 *===========================================================================
 * DBGINTERCEPTSCOPE
 *===========================================================================
 *
 * Description:
 * Sent to intercept a set of processes
  *
 * Parameters:
 *   scope:    The scope to intercept
 */
#define DBGINTERCEPTSCOPE 33038   /* !-SIGNO(struct DBGInterceptScope)-! */
struct DBGInterceptScope {
   U32 sigNo;
   U32 size;
};
#ifdef IS_DBGSERVER_CLIENT
_GLOBAL void create_DBGInterceptScope(const U8 *_scope, U32 _scopeSize, union SIGNAL **_sig);
#endif


#ifdef LITTLE_ENDIAN
void convert_DBGInterceptScope(struct DBGInterceptScope *_sig);
#else
#define convert_DBGInterceptScope(_sig)
#endif


#define DBGInterceptScope_get_scope_size(XXsig, XXretVal) do {\
   U8 *XXptr = (U8*)XXsig + ALIGN_SIZE(8);\
   XXretVal = *(U32*)XXptr;\
}while(0)
#define DBGInterceptScope_get_scope(XXsig, XXretVal) do {\
   U8 *XXptr = (U8*)XXsig + ALIGN_SIZE(8);\
   XXretVal = (U8*)(XXptr+4);\
}while(0)



/*
 *===========================================================================
 * DBGINTERCEPTSCOPEREPLY
 *===========================================================================
 *
 * Description:
 * Sent to intercept a set of processes
  *
 * Parameters:
 *   status:    0 if OK
 */
#define DBGINTERCEPTSCOPEREPLY 33039   /* !-SIGNO(struct DBGInterceptScopeReply)-! */
struct DBGInterceptScopeReply {
   U32 sigNo;
   U32 size;
   U32 status ;
};
_GLOBAL void create_DBGInterceptScopeReply(const U32 _status, union SIGNAL **_sig);


#ifdef LITTLE_ENDIAN
void convert_DBGInterceptScopeReply(struct DBGInterceptScopeReply *_sig);
#else
#define convert_DBGInterceptScopeReply(_sig)
#endif





/*
 *===========================================================================
 * DBGRESUMESCOPE
 *===========================================================================
 *
 * Description:
 * Sent to resume a set of processes
  *
 * Parameters:
 *   scope:    The scope to resume
 */
#define DBGRESUMESCOPE 33040   /* !-SIGNO(struct DBGResumeScope)-! */
struct DBGResumeScope {
   U32 sigNo;
   U32 size;
};
#ifdef IS_DBGSERVER_CLIENT
_GLOBAL void create_DBGResumeScope(const U8 *_scope, U32 _scopeSize, union SIGNAL **_sig);
#endif


#ifdef LITTLE_ENDIAN
void convert_DBGResumeScope(struct DBGResumeScope *_sig);
#else
#define convert_DBGResumeScope(_sig)
#endif


#define DBGResumeScope_get_scope_size(XXsig, XXretVal) do {\
   U8 *XXptr = (U8*)XXsig + ALIGN_SIZE(8);\
   XXretVal = *(U32*)XXptr;\
}while(0)
#define DBGResumeScope_get_scope(XXsig, XXretVal) do {\
   U8 *XXptr = (U8*)XXsig + ALIGN_SIZE(8);\
   XXretVal = (U8*)(XXptr+4);\
}while(0)



/*
 *===========================================================================
 * DBGRESUMESCOPEREPLY
 *===========================================================================
 *
 * Description:
 * Sent to resume a set of processes
  *
 * Parameters:
 *   status:    0 if OK
 */
#define DBGRESUMESCOPEREPLY 33041   /* !-SIGNO(struct DBGResumeScopeReply)-! */
struct DBGResumeScopeReply {
   U32 sigNo;
   U32 size;
   U32 status ;
};
_GLOBAL void create_DBGResumeScopeReply(const U32 _status, union SIGNAL **_sig);


#ifdef LITTLE_ENDIAN
void convert_DBGResumeScopeReply(struct DBGResumeScopeReply *_sig);
#else
#define convert_DBGResumeScopeReply(_sig)
#endif





/*
 *===========================================================================
 * DBGGETPROGRAMINFO
 *===========================================================================
 *
 * Description:
 * Sent to request a list of all programs
  *
 * Parameters:
 */
#define DBGGETPROGRAMINFO 33042   /* !-SIGNO(struct DBGGetProgramInfo)-! */
struct DBGGetProgramInfo {
   U32 sigNo;
   U32 size;
};
#ifdef IS_DBGSERVER_CLIENT
_GLOBAL void create_DBGGetProgramInfo(union SIGNAL **_sig);
#endif


#ifdef LITTLE_ENDIAN
void convert_DBGGetProgramInfo(struct DBGGetProgramInfo *_sig);
#else
#define convert_DBGGetProgramInfo(_sig)
#endif





/*
 *===========================================================================
 * DBGGETPROGRAMINFOREPLY
 *===========================================================================
 *
 * Description:
 * Sent as reply to DBGGETPROGRAMINFO (any number of signals)
 * Each section is described as:
 * U32 startaddress
 * U32 size
 * U32 attributes
  *
 * Parameters:
 *   status:   
 *   prgHandle:   
 *   prgStatus:   
 *   entrypoint:   
 *   resident:   
 *   bid:   
 *   sid:   
 *   pid:   
 *   uid:   
 *   section:   
 *   sectionNames:   
 *   name:   
 *   args:   
 *   env:   
 */
#define DBGGETPROGRAMINFOREPLY 33043   /* !-SIGNO(struct DBGGetProgramInfoReply)-! */
struct DBGGetProgramInfoReply {
   U32 sigNo;
   U32 size;
   U32 status ;
   U32 prgHandle ;
   U32 prgStatus ;
   U32 entrypoint ;
   U32 resident ;
   U32 bid ;
   U32 sid ;
   U32 pid ;
   U32 uid ;
};
_GLOBAL void create_DBGGetProgramInfoReply(const U32 _status, const U32 _prgHandle, const U32 _prgStatus, const U32 _entrypoint, const U32 _resident, const U32 _bid, const U32 _sid, const U32 _pid, const U32 _uid, const U32 *_section, U32 _sectionSize, const U8 *_sectionNames, U32 _sectionNamesSize, const char *_name, const char *_args, const U8 *_env, U32 _envSize, union SIGNAL **_sig);


#ifdef LITTLE_ENDIAN
void convert_DBGGetProgramInfoReply(struct DBGGetProgramInfoReply *_sig);
#else
#define convert_DBGGetProgramInfoReply(_sig)
#endif


#define DBGGetProgramInfoReply_get_section_size(XXsig, XXretVal) do {\
   U8 *XXptr = (U8*)XXsig + ALIGN_SIZE(44);\
   XXretVal = *(U32*)XXptr;\
}while(0)
#define DBGGetProgramInfoReply_get_section(XXsig, XXretVal) do {\
   U8 *XXptr = (U8*)XXsig + ALIGN_SIZE(44);\
   XXretVal = (U32*)(XXptr+4);\
}while(0)
#define DBGGetProgramInfoReply_get_sectionNames_size(XXsig, XXretVal) do {\
   U8 *XXptr = (U8*)XXsig + ALIGN_SIZE(44);\
   XXptr += ALIGN_SIZE( *((U32*)XXptr) ) + 4;\
   XXretVal = *(U32*)XXptr;\
}while(0)
#define DBGGetProgramInfoReply_get_sectionNames(XXsig, XXretVal) do {\
   U8 *XXptr = (U8*)XXsig + ALIGN_SIZE(44);\
   XXptr += ALIGN_SIZE( *((U32*)XXptr) ) + 4;\
   XXretVal = (U8*)(XXptr+4);\
}while(0)
#define DBGGetProgramInfoReply_get_name_size(XXsig, XXretVal) do {\
   U8 *XXptr = (U8*)XXsig + ALIGN_SIZE(44);\
   XXptr += ALIGN_SIZE( *((U32*)XXptr) ) + 4;\
   XXptr += ALIGN_SIZE( *((U32*)XXptr) ) + 4;\
   XXretVal = *(U32*)XXptr;\
}while(0)
#define DBGGetProgramInfoReply_get_name(XXsig, XXretVal) do {\
   U8 *XXptr = (U8*)XXsig + ALIGN_SIZE(44);\
   XXptr += ALIGN_SIZE( *((U32*)XXptr) ) + 4;\
   XXptr += ALIGN_SIZE( *((U32*)XXptr) ) + 4;\
   XXretVal = (char*)(XXptr+4);\
}while(0)
#define DBGGetProgramInfoReply_get_args_size(XXsig, XXretVal) do {\
   U8 *XXptr = (U8*)XXsig + ALIGN_SIZE(44);\
   XXptr += ALIGN_SIZE( *((U32*)XXptr) ) + 4;\
   XXptr += ALIGN_SIZE( *((U32*)XXptr) ) + 4;\
   XXptr += ALIGN_SIZE( *((U32*)XXptr) ) + 4;\
   XXretVal = *(U32*)XXptr;\
}while(0)
#define DBGGetProgramInfoReply_get_args(XXsig, XXretVal) do {\
   U8 *XXptr = (U8*)XXsig + ALIGN_SIZE(44);\
   XXptr += ALIGN_SIZE( *((U32*)XXptr) ) + 4;\
   XXptr += ALIGN_SIZE( *((U32*)XXptr) ) + 4;\
   XXptr += ALIGN_SIZE( *((U32*)XXptr) ) + 4;\
   XXretVal = (char*)(XXptr+4);\
}while(0)
#define DBGGetProgramInfoReply_get_env_size(XXsig, XXretVal) do {\
   U8 *XXptr = (U8*)XXsig + ALIGN_SIZE(44);\
   XXptr += ALIGN_SIZE( *((U32*)XXptr) ) + 4;\
   XXptr += ALIGN_SIZE( *((U32*)XXptr) ) + 4;\
   XXptr += ALIGN_SIZE( *((U32*)XXptr) ) + 4;\
   XXptr += ALIGN_SIZE( *((U32*)XXptr) ) + 4;\
   XXretVal = *(U32*)XXptr;\
}while(0)
#define DBGGetProgramInfoReply_get_env(XXsig, XXretVal) do {\
   U8 *XXptr = (U8*)XXsig + ALIGN_SIZE(44);\
   XXptr += ALIGN_SIZE( *((U32*)XXptr) ) + 4;\
   XXptr += ALIGN_SIZE( *((U32*)XXptr) ) + 4;\
   XXptr += ALIGN_SIZE( *((U32*)XXptr) ) + 4;\
   XXptr += ALIGN_SIZE( *((U32*)XXptr) ) + 4;\
   XXretVal = (U8*)(XXptr+4);\
}while(0)



/*
 *===========================================================================
 * DBGINFOPROGRAMENDMARK
 *===========================================================================
 *
 * Description:
 * Sent by the debugserver as the last signal in a progam info
 * request which can yield into several reply signals.
  *
 * Parameters:
 */
#define DBGINFOPROGRAMENDMARK 33044   /* !-SIGNO(struct DBGInfoProgramEndMark)-! */
struct DBGInfoProgramEndMark {
   U32 sigNo;
   U32 size;
};
_GLOBAL void create_DBGInfoProgramEndMark(union SIGNAL **_sig);


#ifdef LITTLE_ENDIAN
void convert_DBGInfoProgramEndMark(struct DBGInfoProgramEndMark *_sig);
#else
#define convert_DBGInfoProgramEndMark(_sig)
#endif





/*
 *===========================================================================
 * DBGNOTIFYRESULT
 *===========================================================================
 *
 * Description:
 * Sent from DebugServer to client when the state of one or more processes 
 * on the target changes
  *
 * Parameters:
 *   cookie:   
 */
#define DBGNOTIFYRESULT 33045   /* !-SIGNO(struct DBGNotifyResult)-! */
struct DBGNotifyResult {
   U32 sigNo;
   U32 size;
   U32 cookie ;
};
_GLOBAL void create_DBGNotifyResult(const U32 _cookie, union SIGNAL **_sig);


#ifdef LITTLE_ENDIAN
void convert_DBGNotifyResult(struct DBGNotifyResult *_sig);
#else
#define convert_DBGNotifyResult(_sig)
#endif





/*
 *===========================================================================
 * DBGNOTIFYREQUEST
 *===========================================================================
 *
 * Description:
 * Sent from DebugServer to client when the state of one or more processes 
 * on the target changes
  *
 * Parameters:
 *   cookie:   
 */
#define DBGNOTIFYREQUEST 33046   /* !-SIGNO(struct DBGNotifyRequest)-! */
struct DBGNotifyRequest {
   U32 sigNo;
   U32 size;
   U32 cookie ;
};
#ifdef IS_DBGSERVER_CLIENT
_GLOBAL void create_DBGNotifyRequest(const U32 _cookie, union SIGNAL **_sig);
#endif


#ifdef LITTLE_ENDIAN
void convert_DBGNotifyRequest(struct DBGNotifyRequest *_sig);
#else
#define convert_DBGNotifyRequest(_sig)
#endif





/*
 *===========================================================================
 * DBGNOTIFYREPLY
 *===========================================================================
 *
 * Description:
 * Sent from DebugServer to client when the state of one or more processes 
 * on the target changes
  *
 * Parameters:
 *   status:   
 */
#define DBGNOTIFYREPLY 33047   /* !-SIGNO(struct DBGNotifyReply)-! */
struct DBGNotifyReply {
   U32 sigNo;
   U32 size;
   U32 status ;
};
_GLOBAL void create_DBGNotifyReply(const U32 _status, union SIGNAL **_sig);


#ifdef LITTLE_ENDIAN
void convert_DBGNotifyReply(struct DBGNotifyReply *_sig);
#else
#define convert_DBGNotifyReply(_sig)
#endif





/*
 *===========================================================================
 * DBGREQUESTSOURCEDEBUG
 *===========================================================================
 *
 * Description:
 * This signal is normaly sent from the Illuminator when the
 * user wants to debug a process or program. The signal is
 * forwarded to all clients that has set an application scope.
 * If the source debugger client is not running on the same
 * host and by the same user the client should ignore the
 * request.
  *
 * Parameters:
 *   pid:    The pid of the process that should be debugged.
 *   programHandle:    If not zero the request applies to this program.
 *   hostName:    The host name where the requester runs.
 *   userName:    If not empty the debugger should be run by this user.
 *   execFileName:    If known this is the program elf file.
 */
#define DBGREQUESTSOURCEDEBUG 33048   /* !-SIGNO(struct DBGRequestSourceDebug)-! */
struct DBGRequestSourceDebug {
   U32 sigNo;
   U32 size;
   U32 pid ;
   U32 programHandle ;
};
_GLOBAL void create_DBGRequestSourceDebug(const U32 _pid, const U32 _programHandle, const char *_hostName, const char *_userName, const char *_execFileName, union SIGNAL **_sig);


#ifdef LITTLE_ENDIAN
void convert_DBGRequestSourceDebug(struct DBGRequestSourceDebug *_sig);
#else
#define convert_DBGRequestSourceDebug(_sig)
#endif


#define DBGRequestSourceDebug_get_hostName_size(XXsig, XXretVal) do {\
   U8 *XXptr = (U8*)XXsig + ALIGN_SIZE(16);\
   XXretVal = *(U32*)XXptr;\
}while(0)
#define DBGRequestSourceDebug_get_hostName(XXsig, XXretVal) do {\
   U8 *XXptr = (U8*)XXsig + ALIGN_SIZE(16);\
   XXretVal = (char*)(XXptr+4);\
}while(0)
#define DBGRequestSourceDebug_get_userName_size(XXsig, XXretVal) do {\
   U8 *XXptr = (U8*)XXsig + ALIGN_SIZE(16);\
   XXptr += ALIGN_SIZE( *((U32*)XXptr) ) + 4;\
   XXretVal = *(U32*)XXptr;\
}while(0)
#define DBGRequestSourceDebug_get_userName(XXsig, XXretVal) do {\
   U8 *XXptr = (U8*)XXsig + ALIGN_SIZE(16);\
   XXptr += ALIGN_SIZE( *((U32*)XXptr) ) + 4;\
   XXretVal = (char*)(XXptr+4);\
}while(0)
#define DBGRequestSourceDebug_get_execFileName_size(XXsig, XXretVal) do {\
   U8 *XXptr = (U8*)XXsig + ALIGN_SIZE(16);\
   XXptr += ALIGN_SIZE( *((U32*)XXptr) ) + 4;\
   XXptr += ALIGN_SIZE( *((U32*)XXptr) ) + 4;\
   XXretVal = *(U32*)XXptr;\
}while(0)
#define DBGRequestSourceDebug_get_execFileName(XXsig, XXretVal) do {\
   U8 *XXptr = (U8*)XXsig + ALIGN_SIZE(16);\
   XXptr += ALIGN_SIZE( *((U32*)XXptr) ) + 4;\
   XXptr += ALIGN_SIZE( *((U32*)XXptr) ) + 4;\
   XXretVal = (char*)(XXptr+4);\
}while(0)



/*
 *===========================================================================
 * DBGSERVERSTARTED
 *===========================================================================
 *
 * Description:
 * Sent to notify that this dbgserver has just started.
 * The intention is that any previous connected debugger should
 * detect that the target has been restarted.
  *
 * Parameters:
 *   serverPort:    The port number for the TCP server socket
 *   notUsed1:   
 *   notUsed2:   
 *   name:    Target name from SystemServer or created from softkernelName@host:pid
 *   info:    Other info, currently not used.
 */
#define DBGSERVERSTARTED 33049   /* !-SIGNO(struct DBGServerStarted)-! */
struct DBGServerStarted {
   U32 sigNo;
   U32 size;
   U32 serverPort ;
   U32 notUsed1 ;
   U32 notUsed2 ;
};
_GLOBAL void create_DBGServerStarted(const U32 _serverPort, const U32 _notUsed1, const U32 _notUsed2, const char *_name, const char *_info, union SIGNAL **_sig);


#ifdef LITTLE_ENDIAN
void convert_DBGServerStarted(struct DBGServerStarted *_sig);
#else
#define convert_DBGServerStarted(_sig)
#endif


#define DBGServerStarted_get_name_size(XXsig, XXretVal) do {\
   U8 *XXptr = (U8*)XXsig + ALIGN_SIZE(20);\
   XXretVal = *(U32*)XXptr;\
}while(0)
#define DBGServerStarted_get_name(XXsig, XXretVal) do {\
   U8 *XXptr = (U8*)XXsig + ALIGN_SIZE(20);\
   XXretVal = (char*)(XXptr+4);\
}while(0)
#define DBGServerStarted_get_info_size(XXsig, XXretVal) do {\
   U8 *XXptr = (U8*)XXsig + ALIGN_SIZE(20);\
   XXptr += ALIGN_SIZE( *((U32*)XXptr) ) + 4;\
   XXretVal = *(U32*)XXptr;\
}while(0)
#define DBGServerStarted_get_info(XXsig, XXretVal) do {\
   U8 *XXptr = (U8*)XXsig + ALIGN_SIZE(20);\
   XXptr += ALIGN_SIZE( *((U32*)XXptr) ) + 4;\
   XXretVal = (char*)(XXptr+4);\
}while(0)



/*
 *===========================================================================
 * DBGSETBP
 *===========================================================================
 *
 * Description:
 * Sent to define a breakpoint.
 * The tag list should be terminated by 0.
 * TAG: SDM_SET_BP_COUNT_TAG = 1
 *   A counter for how many times a breakpoint is trigged before intercepting
 *   the catch scope.
  *
 * Parameters:
 *   address:    The address of the breakpoint
 *   mainBid:    The bid of the main block for the segment that contains the address
 *   tagList:    A list of tagged values (max 8 values), the list terminated.
 *   triggCatch:    The trig and catch scopes
 */
#define DBGSETBP 33050   /* !-SIGNO(struct DBGSetBp)-! */
struct DBGSetBp {
   U32 sigNo;
   U32 size;
   U32 address ;
   U32 mainBid ;
   U32 tagList[17] ;
};
#ifdef IS_DBGSERVER_CLIENT
_GLOBAL void create_DBGSetBp(const U32 _address, const U32 _mainBid, const U32 *_tagList, const U8 *_triggCatch, U32 _triggCatchSize, union SIGNAL **_sig);
#endif


#ifdef LITTLE_ENDIAN
void convert_DBGSetBp(struct DBGSetBp *_sig);
#else
#define convert_DBGSetBp(_sig)
#endif


#define DBGSetBp_get_triggCatch_size(XXsig, XXretVal) do {\
   U8 *XXptr = (U8*)XXsig + ALIGN_SIZE(84);\
   XXretVal = *(U32*)XXptr;\
}while(0)
#define DBGSetBp_get_triggCatch(XXsig, XXretVal) do {\
   U8 *XXptr = (U8*)XXsig + ALIGN_SIZE(84);\
   XXretVal = (U8*)(XXptr+4);\
}while(0)



/*
 *===========================================================================
 * DBGCONSOLEOUTPUT
 *===========================================================================
 *
 * Description:
 * Sent from the dbgserver to clients that has a console.
  *
 * Parameters:
 *   buffer:   
 */
#define DBGCONSOLEOUTPUT 33051   /* !-SIGNO(struct DBGConsoleOutput)-! */
struct DBGConsoleOutput {
   U32 sigNo;
   U32 size;
};
_GLOBAL void create_DBGConsoleOutput(const U8 *_buffer, U32 _bufferSize, union SIGNAL **_sig);


#ifdef LITTLE_ENDIAN
void convert_DBGConsoleOutput(struct DBGConsoleOutput *_sig);
#else
#define convert_DBGConsoleOutput(_sig)
#endif


#define DBGConsoleOutput_get_buffer_size(XXsig, XXretVal) do {\
   U8 *XXptr = (U8*)XXsig + ALIGN_SIZE(8);\
   XXretVal = *(U32*)XXptr;\
}while(0)
#define DBGConsoleOutput_get_buffer(XXsig, XXretVal) do {\
   U8 *XXptr = (U8*)XXsig + ALIGN_SIZE(8);\
   XXretVal = (U8*)(XXptr+4);\
}while(0)



/*
 *===========================================================================
 * DBGCONSOLEINPUT
 *===========================================================================
 *
 * Description:
 * Sent from the dbgserver to clients that has a console.
  *
 * Parameters:
 *   buffer:   
 */
#define DBGCONSOLEINPUT 33052   /* !-SIGNO(struct DBGConsoleInput)-! */
struct DBGConsoleInput {
   U32 sigNo;
   U32 size;
};
#ifdef IS_DBGSERVER_CLIENT
_GLOBAL void create_DBGConsoleInput(const U8 *_buffer, U32 _bufferSize, union SIGNAL **_sig);
#endif


#ifdef LITTLE_ENDIAN
void convert_DBGConsoleInput(struct DBGConsoleInput *_sig);
#else
#define convert_DBGConsoleInput(_sig)
#endif


#define DBGConsoleInput_get_buffer_size(XXsig, XXretVal) do {\
   U8 *XXptr = (U8*)XXsig + ALIGN_SIZE(8);\
   XXretVal = *(U32*)XXptr;\
}while(0)
#define DBGConsoleInput_get_buffer(XXsig, XXretVal) do {\
   U8 *XXptr = (U8*)XXsig + ALIGN_SIZE(8);\
   XXretVal = (U8*)(XXptr+4);\
}while(0)



/*
 *===========================================================================
 * DBGREGISTERCONSOLE
 *===========================================================================
 *
 * Description:
 * Sent from the dbgserver to clients that has a console.
  *
 * Parameters:
 *   input:    If non zero the client wonts to support input.
 *   notUsed1:   
 *   notUsed2:   
 *   notUsed3:   
 *   terminalName:   
 */
#define DBGREGISTERCONSOLE 33053   /* !-SIGNO(struct DBGRegisterConsole)-! */
struct DBGRegisterConsole {
   U32 sigNo;
   U32 size;
   U8 input ;
   U8 notUsed1 ;
   U8 notUsed2 ;
   U8 notUsed3 ;
};
#ifdef IS_DBGSERVER_CLIENT
_GLOBAL void create_DBGRegisterConsole(const U8 _input, const U8 _notUsed1, const U8 _notUsed2, const U8 _notUsed3, const char *_terminalName, union SIGNAL **_sig);
#endif


#ifdef LITTLE_ENDIAN
void convert_DBGRegisterConsole(struct DBGRegisterConsole *_sig);
#else
#define convert_DBGRegisterConsole(_sig)
#endif


#define DBGRegisterConsole_get_terminalName_size(XXsig, XXretVal) do {\
   U8 *XXptr = (U8*)XXsig + ALIGN_SIZE(12);\
   XXretVal = *(U32*)XXptr;\
}while(0)
#define DBGRegisterConsole_get_terminalName(XXsig, XXretVal) do {\
   U8 *XXptr = (U8*)XXsig + ALIGN_SIZE(12);\
   XXretVal = (char*)(XXptr+4);\
}while(0)



/*
 *===========================================================================
 * DBGREGISTERCONSOLEREPLY
 *===========================================================================
 *
 * Description:
 *
 * status may have the following values:
 * 0 - success
 * 1 - failure
  *
 * Parameters:
 *   status:   
 *   message:    If operation failed message contain a plain text error message.
 */
#define DBGREGISTERCONSOLEREPLY 33054   /* !-SIGNO(struct DBGRegisterConsoleReply)-! */
struct DBGRegisterConsoleReply {
   U32 sigNo;
   U32 size;
   U32 status ;
};
_GLOBAL void create_DBGRegisterConsoleReply(const U32 _status, const char *_message, union SIGNAL **_sig);


#ifdef LITTLE_ENDIAN
void convert_DBGRegisterConsoleReply(struct DBGRegisterConsoleReply *_sig);
#else
#define convert_DBGRegisterConsoleReply(_sig)
#endif


#define DBGRegisterConsoleReply_get_message_size(XXsig, XXretVal) do {\
   U8 *XXptr = (U8*)XXsig + ALIGN_SIZE(12);\
   XXretVal = *(U32*)XXptr;\
}while(0)
#define DBGRegisterConsoleReply_get_message(XXsig, XXretVal) do {\
   U8 *XXptr = (U8*)XXsig + ALIGN_SIZE(12);\
   XXretVal = (char*)(XXptr+4);\
}while(0)



/*
 *===========================================================================
 * DBGUNREGISTERCONSOLE
 *===========================================================================
 *
 * Description:
 *
 * status may have the following values:
 * 0 - success
 * 1 - failure
  *
 * Parameters:
 */
#define DBGUNREGISTERCONSOLE 33055   /* !-SIGNO(struct DBGUnregisterConsole)-! */
struct DBGUnregisterConsole {
   U32 sigNo;
   U32 size;
};
#ifdef IS_DBGSERVER_CLIENT
_GLOBAL void create_DBGUnregisterConsole(union SIGNAL **_sig);
#endif


#ifdef LITTLE_ENDIAN
void convert_DBGUnregisterConsole(struct DBGUnregisterConsole *_sig);
#else
#define convert_DBGUnregisterConsole(_sig)
#endif





/*
 *===========================================================================
 * DBGUNREGISTERCONSOLEREPLY
 *===========================================================================
 *
 * Description:
 *
 * status may have the following values:
 * 0 - success
 * 1 - failure
  *
 * Parameters:
 */
#define DBGUNREGISTERCONSOLEREPLY 33056   /* !-SIGNO(struct DBGUnregisterConsoleReply)-! */
struct DBGUnregisterConsoleReply {
   U32 sigNo;
   U32 size;
};
_GLOBAL void create_DBGUnregisterConsoleReply(union SIGNAL **_sig);


#ifdef LITTLE_ENDIAN
void convert_DBGUnregisterConsoleReply(struct DBGUnregisterConsoleReply *_sig);
#else
#define convert_DBGUnregisterConsoleReply(_sig)
#endif





/*
 *===========================================================================
 * DBGUNEXPECTEDEXCEPTION
 *===========================================================================
 *
 * Description:
 * Sent asyncronosly to clients that have an application scope
 * for source code debugging.
 *
 * For this signal to be sent the client version have to be 1.3 or greater.
  *
 * Parameters:
 *   exceptionCode:    A CPU family specific exception identifier.
 *   faultAddress:    The faulting addr (for a memory access).
 *   pid:    Pid of faulting process or 0 if unknown.
 *   message:    A text description of the exception.
 */
#define DBGUNEXPECTEDEXCEPTION 33057   /* !-SIGNO(struct DBGUnexpectedException)-! */
struct DBGUnexpectedException {
   U32 sigNo;
   U32 size;
   U32 exceptionCode ;
   U32 faultAddress ;
   U32 pid ;
};
_GLOBAL void create_DBGUnexpectedException(const U32 _exceptionCode, const U32 _faultAddress, const U32 _pid, const char *_message, union SIGNAL **_sig);


#ifdef LITTLE_ENDIAN
void convert_DBGUnexpectedException(struct DBGUnexpectedException *_sig);
#else
#define convert_DBGUnexpectedException(_sig)
#endif


#define DBGUnexpectedException_get_message_size(XXsig, XXretVal) do {\
   U8 *XXptr = (U8*)XXsig + ALIGN_SIZE(20);\
   XXretVal = *(U32*)XXptr;\
}while(0)
#define DBGUnexpectedException_get_message(XXsig, XXretVal) do {\
   U8 *XXptr = (U8*)XXsig + ALIGN_SIZE(20);\
   XXretVal = (char*)(XXptr+4);\
}while(0)



/*
 *===========================================================================
 * DBGWRITELDMVARS
 *===========================================================================
 *
 * Description:
 * Sent from clients to set LDM variables. May only be sent if the debug server
 * has the feature LDM_VARS. 
  *
 * Parameters:
 *   count:    number of strings in vars (always even)
 *   vars:    name/value strings   
 */
#define DBGWRITELDMVARS 33058   /* !-SIGNO(struct DBGWriteLdmVars)-! */
struct DBGWriteLdmVars {
   U32 sigNo;
   U32 size;
   U32 count ;
};
#ifdef IS_DBGSERVER_CLIENT
_GLOBAL void create_DBGWriteLdmVars(const U32 _count, const U8 *_vars, U32 _varsSize, union SIGNAL **_sig);
#endif


#ifdef LITTLE_ENDIAN
void convert_DBGWriteLdmVars(struct DBGWriteLdmVars *_sig);
#else
#define convert_DBGWriteLdmVars(_sig)
#endif


#define DBGWriteLdmVars_get_vars_size(XXsig, XXretVal) do {\
   U8 *XXptr = (U8*)XXsig + ALIGN_SIZE(12);\
   XXretVal = *(U32*)XXptr;\
}while(0)
#define DBGWriteLdmVars_get_vars(XXsig, XXretVal) do {\
   U8 *XXptr = (U8*)XXsig + ALIGN_SIZE(12);\
   XXretVal = (U8*)(XXptr+4);\
}while(0)



/*
 *===========================================================================
 * DBGREADLDMVARSREQUEST
 *===========================================================================
 *
 * Description:
 * Sent from clients to read LDM variables. May only be sent if the debug 
 * server has the feature LDM_VARS. 
  *
 * Parameters:
 *   count:    number of strings in name
 *   names:    name strings 
 */
#define DBGREADLDMVARSREQUEST 33059   /* !-SIGNO(struct DBGReadLdmVarsRequest)-! */
struct DBGReadLdmVarsRequest {
   U32 sigNo;
   U32 size;
   U32 count ;
};
#ifdef IS_DBGSERVER_CLIENT
_GLOBAL void create_DBGReadLdmVarsRequest(const U32 _count, const U8 *_names, U32 _namesSize, union SIGNAL **_sig);
#endif


#ifdef LITTLE_ENDIAN
void convert_DBGReadLdmVarsRequest(struct DBGReadLdmVarsRequest *_sig);
#else
#define convert_DBGReadLdmVarsRequest(_sig)
#endif


#define DBGReadLdmVarsRequest_get_names_size(XXsig, XXretVal) do {\
   U8 *XXptr = (U8*)XXsig + ALIGN_SIZE(12);\
   XXretVal = *(U32*)XXptr;\
}while(0)
#define DBGReadLdmVarsRequest_get_names(XXsig, XXretVal) do {\
   U8 *XXptr = (U8*)XXsig + ALIGN_SIZE(12);\
   XXretVal = (U8*)(XXptr+4);\
}while(0)



/*
 *===========================================================================
 * DBGREADLDMVARSREPLY
 *===========================================================================
 *
 * Description:
 * Sent from clients to read LDM variables. May only be sent if the debug 
 * server has the feature LDM_VARS. 
  *
 * Parameters:
 *   count:    number of strings in vars (always even)
 *   vars:    name/value strings    
 */
#define DBGREADLDMVARSREPLY 33060   /* !-SIGNO(struct DBGReadLdmVarsReply)-! */
struct DBGReadLdmVarsReply {
   U32 sigNo;
   U32 size;
   U32 count ;
};
_GLOBAL void create_DBGReadLdmVarsReply(const U32 _count, const U8 *_vars, U32 _varsSize, union SIGNAL **_sig);


#ifdef LITTLE_ENDIAN
void convert_DBGReadLdmVarsReply(struct DBGReadLdmVarsReply *_sig);
#else
#define convert_DBGReadLdmVarsReply(_sig)
#endif


#define DBGReadLdmVarsReply_get_vars_size(XXsig, XXretVal) do {\
   U8 *XXptr = (U8*)XXsig + ALIGN_SIZE(12);\
   XXretVal = *(U32*)XXptr;\
}while(0)
#define DBGReadLdmVarsReply_get_vars(XXsig, XXretVal) do {\
   U8 *XXptr = (U8*)XXsig + ALIGN_SIZE(12);\
   XXretVal = (U8*)(XXptr+4);\
}while(0)



/*
 *===========================================================================
 * DBGREADLDMVARSENDMARK
 *===========================================================================
 *
 * Description:
 * Sent from clients to read LDM variables. May only be sent if the debug 
 * server has the feature LDM_VARS. 
  *
 * Parameters:
 */
#define DBGREADLDMVARSENDMARK 33061   /* !-SIGNO(struct DBGReadLdmVarsEndMark)-! */
struct DBGReadLdmVarsEndMark {
   U32 sigNo;
   U32 size;
};
_GLOBAL void create_DBGReadLdmVarsEndMark(union SIGNAL **_sig);


#ifdef LITTLE_ENDIAN
void convert_DBGReadLdmVarsEndMark(struct DBGReadLdmVarsEndMark *_sig);
#else
#define convert_DBGReadLdmVarsEndMark(_sig)
#endif





/*
 *===========================================================================
 * DBGGETCURRENTPROCESS
 *===========================================================================
 *
 * Description:
 * Sent from clients to get the current process. The reply will be
 * one DBGGetProcessInfoReply and one DBGInfoProcEndMark.
 *
 * This signal would typical be implemented by a freeze mode dbgserver
 * such as fmm.
  *
 * Parameters:
 */
#define DBGGETCURRENTPROCESS 33062   /* !-SIGNO(struct DBGGetCurrentProcess)-! */
struct DBGGetCurrentProcess {
   U32 sigNo;
   U32 size;
};
#ifdef IS_DBGSERVER_CLIENT
_GLOBAL void create_DBGGetCurrentProcess(union SIGNAL **_sig);
#endif


#ifdef LITTLE_ENDIAN
void convert_DBGGetCurrentProcess(struct DBGGetCurrentProcess *_sig);
#else
#define convert_DBGGetCurrentProcess(_sig)
#endif





#endif /* __dbgserverinterface_sig */
